;Written by Xiaoming Hu, Penn State, Jan, 2010 
; contact yuanfangcan@gmail.com
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/wrf/WRF_contributed.ncl"

begin
  abc_names        = (/"OZONE","NO3","a","b","c"/)
  abc_locationY    = (/1,1,0.36,104.2,1699.4/)
  var_names        = (/"OZONE","NO3","OH","CO","CH4"/)
  var_names_toshow = (/"OZONE","NO~B~3~N~","HO","CO","CH~B~4~N~"/)
;  files = (/"TS_species_control.txt","TS_species10ppbO3.txt","TS_species_increase40ppbO3.txt","TS_species_increase70ppbO3.txt","TS_species_increase100ppbO3.txt"/)
;  files = (/"TS_speciesiso0.36_control.txt","TS_speciesiso0.36_increase10ppbO3.txt","TS_speciesiso0.36_increase40ppbO3.txt","TS_speciesiso0.36_increase70ppbO3.txt","TS_speciesiso0.36_increase100ppbO3.txt"/)
;  files = (/"TS_speciesiso0.36cloud_control.txt","TS_speciesiso0.36cloud_increase10ppbO3.txt","TS_speciesiso0.36cloud_increase40ppbO3.txt","TS_speciesiso0.36cloud_increase70ppbO3.txt","TS_speciesiso0.36cloud_increase100ppbO3.txt"/)
  files = (/"TS_speciesiso0.36RADaug26_control.txt","TS_speciesiso0.36RADaug26_increase10ppbO3.txt","TS_speciesiso0.36RADaug26_increase40ppbO3.txt","TS_speciesiso0.36RADaug26_increase70ppbO3.txt","TS_speciesiso0.36cloud_increase10ppbO3.txt","TS_speciesiso0.36cloud_increase40ppbO3.txt","TS_speciesiso0.36cloud_increase70ppbO3.txt"/)

  plot = new(3,graphic)
; figurename = "Fig14_RACMsimulated_COCH4OH_O3sensitivity_bariso0.36"
; figurename = "Fig14_RACMsimulated_COCH4OH_O3sensitivity_bariso0.36cloud"
 figurename = "Fig14_RACMsimulated_COCH4OH_O3sensitivity_bar_Final"
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
  setvalues wks
    "wkForegroundColor" : "Black";"Blue"
  end setvalues

  Nsenarios = 7 
  Nspeciesoutput = 3 
  Data_output = new ((/Nspeciesoutput,Nsenarios/),float)

   opt = True
   opt@title  = "Height(km), O3_Control(K),  O3_NonConvect(K)"
   opt@fout = "Figure11_part2.txt"
   write_matrix (Data_output, "3f15.5" , opt)


 do ivars = 2 , dimsizes(var_names)-1   
  data_array =  readAsciiTable(files(0),16,"float",1)
  dims = dimsizes(data_array)
  data_array_combine = new((/dims(0),dimsizes(files)/),float)
  do ifiles = 0 , dimsizes(files)-1 
     data_array =  readAsciiTable(files(ifiles),16,"float",1) 
     data_array_combine(:,ifiles) = (/data_array (:,ivars+11)/)
  end do  
     if (var_names(ivars).eq."OH") then
     Time_to_pick = 16 
     data_sensitive = dim_avg(transpose(data_array_combine(Time_to_pick-9:Time_to_pick-5,:))) 
     else
     Time_to_pick = 19 
     data_sensitive = data_array_combine(Time_to_pick-7,:) 
     end if 
   if (ivars.eq.0) then ; o3
     O3 = data_array_combine(:,88) 
   end if 
;     print(O3)

    a4_height = 29.7 ; in centimeters, if my 
    a4_width = 23.0 ; reference is correct 
    cm_per_inch = 2.54 
 
  res1                       = True            ; plot mods desired
  res1@gsnFrame               = False                     ; don't draw yet
;  res1@gsnDraw                = False                     ; don't advance frame

  res1@vpHeightF             =0.225
  res1@vpWidthF              = 0.75 
  res1@vpXF             = 0.2
  res1@vpYF             = 0.9-0.26*(ivars-2)
  res1@tmXBLabelDeltaF = -0.4
  res1@tiXAxisOffsetYF = 0.01

  res1@gsnPaperMargin    = 0.01
  res1@tiYAxisString         = var_names_toshow(ivars)+", ppbv" 
  res1@xyDashPatterns    = (/0,16,0,16,0,4/)       ; 0 is default (solid)
;  res1@xyLineColors           = (/"black","green","blue","Turquoise3","Purple4","Magenta2","red","brown"/)
;  res1@xyMarkLineModes   = (/"MarkLines","MarkLines","MarkLines","MarkLines","MarkLines","MarkLines"   /)
  res1@xyMarkLineModes   = (/"Markers","Markers","Markers","Markers","Markers","Markers"   /)
 res1@xyMarkers         =  (/16,16,16,16,16,16/)                      ; choose type of marker  
; res1@xyMarkerColor     = "Turquoise3"       
 res1@xyLineColors       = (/"blue","red","black","green","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/)
 res1@xyMarkerColors     = (/"blue","red","black","green","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/) ;"black"; "Cyan3"       
 res1@xyMarkerSizeF     = 0.01  
  res1@xyLineThicknessF       = 5 
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendParallelPosF   = .68                  ; move units right
  res1@pmLegendWidthF         = 0.4                ; Change width and
  res1@pmLegendHeightF        = 0.18                ; height of legend.
  res1@tiXAxisFuncCode = "~"
;  res1@tmYLMode = "Manual"
;  res1@tmYLTickStartF= 294.0
;  res1@tmYLTickEndF  = 304.0
  res1@tmYLTickSpacingF = 2.0
  res1@pmTickMarkDisplayMode = "Always"         ; turn on tickmarks
  res1@tmXTOn = False            ; turn off top   labels
  res1@tmYROn = False            ; turn off right labels
  res1@lgPerimOn = False
  res1@tiXAxisFontHeightF= 0.021
  res1@tiYAxisFontHeightF= 0.021
  res1@tmXBLabelFontHeightF = 0.021
  res1@tmYLLabelFontHeightF = 0.021
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendParallelPosF   = .7                  ; move units right
  res1@pmLegendOrthogonalPosF = -0.05                ; move units down
  res1@pmLegendWidthF         = 0.1                ; Change width and
  res1@pmLegendHeightF        = 0.15                ; height of legend.
  res1@tmYLMinorOn = False 
  res1@pmLegendDisplayMode    = "Always"       ; create a legend
;  res1@xyExplicitLegendLabels = (/"Control","Inject O3 100ppb 4AM","Inject O3 100ppb 10AM","Inject O3 100ppb 2PM","Inject O3 100ppb 2PM noEvoc"/)
 res1@xyExplicitLegendLabels = (/"Control","Inject O3 10ppb","Inject O3 40ppb","Inject O3 70ppb","Inject O3 100ppb"/)
 res1@tmYLMajorOutwardLengthF = 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  delete(res1@xyMarkLineModes);   = (/"Markers","Markers","Markers","Markers","Markers","Markers"   /)
;  res1@tiXAxisString = "O~B~3~N~, ppb"
  delete(res1@pmLegendDisplayMode);    = "Always"       ; create a legend
  res1@trXMaxF = 7.5 
  res1@trXMinF = 0.5 
  res1@tmYLMode   = "Explicit" 
  if (var_names(ivars).eq."CH4".or.var_names(ivars).eq."OH") then 
    if (var_names(ivars).eq."CH4") then 
    res1@trYMinF               = 1694
    res1@trYMaxF               = 1700 
    res1@tmYLTickSpacingF      = 1 
    res1@tmYLLabelStride       =2
    res1@tmYLValues     = ispan(1694,1700,1) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
    res1@tmYLLabels     = ispan(1694,1700,1) 
    else
    res1@trYMinF               = 0.05
    res1@trYMaxF               = 0.4 
    res1@tmYLTickSpacingF      = 0.05
    res1@tmYLLabelStride       =2
    res1@tmYLValues     = fspan(0.1,0.4,7) ;(/6,12,18,24,30.16,42,42+6,42+12,18,24,30.16,42/)       ; location of explicit labels
    res1@tmYLLabels     = fspan(0.1,0.4,7)
    end if 
  else
    res1@trYMinF               = 99
    res1@trYMaxF               = 105 
    res1@tmYLTickSpacingF      = 1 
    res1@tmYLLabelStride       =2
    res1@tmYLValues     = ispan(99,105,1) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
    res1@tmYLLabels     = ispan(99,105,1) 
  end if 
  if (var_names(ivars).eq."CH4") then
  res1@tmXBLabelsOn = True
  res1@tiXAxisString         = "Scenarios"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  else 
  res1@tmXBLabelsOn = False 
  end if 
  res1@tmXBMode = "Explicit"
  res1@tmXBValues     = ispan(1,7,1) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
;  res1@tmXBLabelAngleF                 = 45.    ; change label angle
  res1@tmXBLabels     = (/"Control","10 ppb","40 ppb","70 ppb","10 ppb~C~ cloud","40 ppb~C~ cloud","70 ppb~C~ cloud"/) 
  res1@gsnXYBarChart         = True                 ; turn on bar chart
  res1@gsnXYBarChartBarWidth = 0.5                 ; change bar widths
  res1@gsnXYBarChartColors = (/"firebrick","red","orange","green", \
  "red","orange","green"/)            ; choose colors
  if (var_names(ivars).eq."OH".or.var_names(ivars).eq."NO3") then
     res1@tiYAxisString         = var_names_toshow(ivars)+", pptv" 
  end if 
;    plot(ivars-2)  = gsn_csm_xy (wks,ispan(1,7,1),data_sensitive,res1) ; create plot
    Data_output(ivars-2,:) = data_sensitive
    plot(ivars-2)  = gsn_csm_xy (wks,ispan(1,7,1),data_sensitive,res1) ; create plot

  tres       =  True
  tres@txFontHeightF = 0.025

  ;  gsn_text(wks,plot(ivars-2),abc_names(ivars),0.9,abc_locationY(ivars),tres)

  print(var_names(ivars))
  print(data_sensitive)
  end do ; ivars

   opt = True
   opt@title  = "Control, increase10ppb,  increase40ppb,  increase70ppb,  increase10ppbCloud,  increase40ppbCloud,  increase70ppbCloud(Line1-3OH,CO,CH4)"
   opt@fout = "Figure14_scenarios.txt"
   write_matrix (Data_output, "7f15.5" , opt)


  frame(wks)

;  system("convert -trim -resize 100% "+figurename+".eps /micromet/s1/www/htdocs/datatransfer/westSenegal/figures/"+figurename+".jpg")
;  system("convert -trim -resize 100% "+figurename+".eps /micromet/s1/www/htdocs/datatransfer/westSenegal/figures/forJACproduction/"+figurename+".jpg")
;  system("mv "+figurename+".eps /micromet/s1/www/htdocs/datatransfer/westSenegal/figures/forJACproduction/"+figurename+".eps")
;  system("rm "+figurename+".eps ")

 end 

