load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
begin
       species = "CO2"
       system("mv fort.701 CO2_time_height.txt")
       CO2_contain = readAsciiTable("CO2_time_height.txt",41,"float",1)
       CO2 = transpose(CO2_contain(1:,1:40))/1000
       CO2!0 = "height"
       CO2!1 = "time"
       CO2&height =  CO2_contain(0,1:40) 
       CO2&time = CO2_contain(1:,0) 
         figurename = species+"_time_height"
  wks = gsn_open_wks("eps",figurename) 
  gsn_define_colormap(wks,"BlAqGrYeOrRevi200")
  
  res                = True 
  res@trYMaxF = 1000
  res@gsnMaximize = True
  res@gsnPaperOrientation   = "portrait"
  res@vpXF           = .2            ; set the X-axis NDC starting point
  res@vpWidthF       = .65             ; set the width of the plot in NDC units
  res@vpHeightF       = .3             ; set the width of the plot in NDC units
  res@gsnSpreadColors = True
  res@tmXTOn                 = False
  res@tmYROn                 = False
  res@tmXBMode = "Explicit"
  res@tmXBValues     = ispan(24,114,6) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
  res@tmXBLabels     = (/"Jul15","06","12","18","Jul16","06","12","18","Jul17","06","12","18","Jul18","06","12","18"/)

  res@tiMainFontColor = "Blue" 
  res@tiXAxisFontColor = "Blue" 
  res@tiYAxisFontColor = "Blue" 
  res@tmBorderLineColor = "Blue"
  res@tmXBLabelFontColor = "Blue"
  res@tmBorderThicknessF = 4 
  res@tmYLLabelFontColor = "Blue"
  res@tmYLLabelFont = 22 
  res@tmXBLabelFont = 22 
  res@tmXBMajorLineColor = "Blue"
  res@tmYLMajorLineColor = "Blue"
;  res@tmXBLabelFontHeightF  = 0.04
  res@lbOrientation           = "vertical"
  res@tiYAxisString         = "~F22~Height, m";"SDN of T, K"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res@tiXAxisString         = "~F22~ Central Standard Time (CST)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res@tiXAxisString         = "~F22~ Time"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res@cnFillOn              = True             ; color plot desired
  res@cnLinesOn             = False            ; turn off contour lines
  res@gsnAddCyclic = False   
  res@cnLineLabelsOn        = False            ; turn off contour labels
;  res@cnFillMode = "RasterFill"
  res@cnLevelSelectionMode  = "ManualLevels"
  res@cnMaxLevelValF        =345 
  res@cnMinLevelValF       = 335 
  res@cnLevelSpacingF   = 1. 
  res@lbLabelStride         =2
;  res@lbLabelAutoStride    = True
   res@gsnLeftString = "~F22~CO2 (ppm)"
   res@gsnRightString = "Simulated by CACHE"

  setvalues wks            
    "wkColorMap"        : "BlAqGrYeOrRevi200"  
    "wkForegroundColor" : "Blue" 
;    "wkBackgroundColor" : (/1.,1.,1./) 
  end setvalues
   res@gsnYAxisIrregular2Linear = True
;  res@gsnLeftString = " ";  species(ispecies); "~F22~CurrentSpecies (ppb)"
;   res@gsnRightString = " ";"OR1 (Deciduous)"

    plot  = gsn_csm_contour(wks, CO2, res )          ; draw second plot
  
   system("convert -trim "+figurename+".eps figures/"+figurename+".jpg")
   system("mv "+figurename+".eps figures/.")


end
;  res@lgLabelStride  =  3 
