load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
begin
       species = "PAN"
       system("mv fort.661 PAN_time_height.txt")
       PAN_contain = readAsciiTable("PAN_time_height.txt",41,"float",1)
       PAN = transpose(PAN_contain(1:,1:40))
       PAN!0 = "height"
       PAN!1 = "time"
       PAN&height =  PAN_contain(0,1:40) 
       PAN&time = PAN_contain(1:,0) 
         figurename = species+"_time_height"
  wks = gsn_open_wks("eps",figurename) 
  gsn_define_colormap(wks,"BlAqGrYeOrRevi200")
  
  res                = True 
  res@trYMaxF = 3000
  res@gsnMaximize = True
  res@gsnPaperOrientation   = "portrait"
  res@vpXF           = .2            ; set the X-axis NDC starting point
  res@vpWidthF       = .65             ; set the width of the plot in NDC units
  res@vpHeightF       = .3             ; set the width of the plot in NDC units
  res@gsnSpreadColors = True
  res@tmXTOn                 = False
  res@tmYROn                 = False
  res@tmXBMode = "Explicit"
  res@tmXBValues     = ispan(24,114,6) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
  res@tmXBLabels     = (/"J15","06","12","18","J16","06","12","18","J17","06","12","18","J18","06","12","18"/)

  res@tiMainFontColor = "Black" 
  res@tiXAxisFontColor = "Black" 
  res@tiYAxisFontColor = "Black" 
  res@tmBorderLineColor = "Black"
  res@tmXBLabelFontColor = "Black"
  res@tmBorderThicknessF = 4 
  res@tmYLLabelFontColor = "Black"
  res@tmYLLabelFont = 22 
  res@tmXBLabelFont = 22 
  res@tmXBMajorLineColor = "Black"
  res@tmYLMajorLineColor = "Black"
  res@tmYLMinorOn = False
;  res@tmXBLabelFontHeightF  = 0.04
  res@lbOrientation           = "vertical"
  res@tiYAxisString         = "~F22~Height, m";"SDN of T, K"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res@tiXAxisString         = "~F22~ Central Standard Time (CST)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res@tiXAxisString         = "~F22~ Time"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res@cnFillOn              = True             ; color plot desired
  res@cnLinesOn             = False            ; turn off contour lines
  res@gsnAddCyclic = False   
  res@cnLineLabelsOn        = False            ; turn off contour labels
;  res@cnFillMode = "RasterFill"
;  res@cnLevelSelectionMode  = "ManualLevels"
;  res@cnMaxLevelValF        = 65 ;1580
;  res@cnMinLevelValF       =  5 ;1420
;  res@cnLevelSpacingF   = 5 
  res@lbLabelStride         =2
;  res@lbLabelAutoStride    = True
   res@gsnLeftString = "~F22~PAN (ppb)"
   res@gsnRightString = "Simulated by CACHE"

  setvalues wks            
    "wkColorMap"        : "BlAqGrYeOrRevi200"  
    "wkForegroundColor" : "Black" 
;    "wkBackgroundColor" : (/1.,1.,1./) 
  end setvalues
   res@gsnYAxisIrregular2Linear = True
;  res@gsnLeftString = " ";  species(ispecies); "~F22~CurrentSpecies (ppb)"
;   res@gsnRightString = " ";"OR1 (Deciduous)"

    plot  = gsn_csm_contour(wks, PAN, res )          ; draw second plot
  
   system("convert -trim "+figurename+".eps figures/"+figurename+".jpg")
   system("mv "+figurename+".eps figures/.")


end
;  res@lgLabelStride  =  3 
