C
C########################################################################
C     HERTEL RACM PROGRAMM
C     DEFINITIONS
C########################################################################
C
      IMPLICIT double precision (A-H,O-Z)

C 237 reactions, 23 photolysis reactions, 214 thermal reactions,
C 191 MAXTIMES photolysis time points, initial values for max number 74
C  77 species ,  emission predicted for max number 76 (see DATA IEMIT)
C  72 emission time points, 76 max number of emissioned species (LEMIN)
C  25 emissioned species(LEMIT), 9 dry deposition species
C     LEMIN=LPRED=LPRIN!
 
      PARAMETER (NREAC=237,NREACJ=23,NREACK=214)
      PARAMETER (NUMSPEC=77,MAXTIMES=191)
      PARAMETER (LSPEC = 77, LPRED = 76) 
      PARAMETER ( LEMIN = 76, LTIME = 72) 
      PARAMETER ( LEMIT = 25, LDRY = 9 )
      PARAMETER ( LPRIN = 76, IDATA = 2880 )
C##
C########################################################################
C##  COMMONN
C########################################################################
C##
      COMMON /PHOTO/ XJVAL(NREACJ,191)
      COMMON /DYNAMICS/ IEMIT(LEMIT),IDRY(LDRY)
      COMMON /WSTOCK/ RJI(NREACJ), RKI(NREACK), P, TEMP, YC(LSPEC),
     &                CRJ(NREACJ), CRK(NREACK)

      COMMON /MARK/ ISTEP0, IOUT, XT(1800), VCOUT(1800,LSPEC)
      COMMON /PRODUCT/ PRODSI(LPRED)
      INTEGER  ISTEP0, IOUT
      COMMON /TIMEA/DTC, TIMENOW, INITVALS(NUMSPEC), TIMEMAX
      double precision INITVALS
      COMMON/IOCHAR/ SCENARIO,CARD
      CHARACTER*80 SCENARIO
      CHARACTER*80 CARD

C declare all species including the atmospheric constant O2,N2,H2O
    
      COMMON /CHPS3D/ LACO3, LADDC, LADDT, LADDX, LALD , LAPI,
     &                LAPIP, LCH4 , LCO  , LCO2 , LCSL , LCSLP,
     &                LDCB , LDIEN, LETE , LETEP, LETH , LETHP,
     &                LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &                LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET,
     &                LHNO3, LHNO4, LHO  , LHO2 , LHONO, LISO ,
     &                LISOP, LKET , LKETP, LLIM , LLIMP, LMACR,
     &                LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2 ,
     &                LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI ,
     &                LOLIP, LOLND, LOLNN, LOLT , LOLTP, LONIT,
     &                LOP1 , LOP2 , LORA1, LORA2, LPAA , LPAN ,
     &                LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &                LTPAN, LUDD , LXO2 , LXYL , LXYLP
      COMMON /CHNM3D/ SPNAM(LSPEC)
      CHARACTER*6     SPNAM
      COMMON /EMIT_DATA/ EMIT(LEMIN,LTIME)
      COMMON /DEPO/ VDAY(LDRY), VNIGHT(LDRY),
     &              DRY_JAC(LPRED), DRY_DEPTH
C ***************************************************************************
