MODULE module_kpp_racm_interf
!  USE module_state_description
!  USE module_configure
  USE racm_Parameters
  USE racm_Precision
  USE racm_UpdateRconstWRF
  USE racm_Integrator
  USE module_wkppc_constants
  USE parameters
     INTEGER, PARAMETER, PRIVATE :: Pj_o31d = 1
     INTEGER, PARAMETER, PRIVATE :: Pj_o33p = 2
     INTEGER, PARAMETER, PRIVATE :: Pj_no2 = 3
     INTEGER, PARAMETER, PRIVATE :: Pj_no3o2 = 4
     INTEGER, PARAMETER, PRIVATE :: Pj_no3o = 5
     INTEGER, PARAMETER, PRIVATE :: Pj_hno2 = 6
     INTEGER, PARAMETER, PRIVATE :: Pj_hno3 = 7
     INTEGER, PARAMETER, PRIVATE :: Pj_hno4 = 8
     INTEGER, PARAMETER, PRIVATE :: Pj_h2o2 = 9
     INTEGER, PARAMETER, PRIVATE :: Pj_ch2or = 10
     INTEGER, PARAMETER, PRIVATE :: Pj_ch2om = 11
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3cho = 12
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3coch3 = 13
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3coc2h5 = 14
     INTEGER, PARAMETER, PRIVATE :: Pj_hcocho = 15
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3cocho = 16
     INTEGER, PARAMETER, PRIVATE :: Pj_hcochest = 17
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3o2h = 18
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3coo2h = 19
     INTEGER, PARAMETER, PRIVATE :: Pj_ch3ono2 = 20
     INTEGER, PARAMETER, PRIVATE :: Pj_hcochob = 21
     INTEGER, PARAMETER, PRIVATE :: Pj_macr = 22
     INTEGER, PARAMETER, PRIVATE :: Pj_hobr = 23
     INTEGER, PARAMETER, PRIVATE :: Pj_br2 = 24
     INTEGER, PARAMETER, PRIVATE :: Pj_bro = 25
     INTEGER, PARAMETER, PRIVATE :: Pj_n2o5 = 26
     INTEGER, PARAMETER, PRIVATE :: Pj_o2 = 27
     INTEGER, PARAMETER, PRIVATE :: Pj_pan = 28
     INTEGER, PARAMETER, PRIVATE :: Pj_acet = 29
     INTEGER, PARAMETER, PRIVATE :: Pj_mglo = 30
     INTEGER, PARAMETER, PRIVATE :: Pj_hno4_2 = 31
     INTEGER, PARAMETER, PRIVATE :: Pj_n2o = 32
     INTEGER, PARAMETER, PRIVATE :: Pj_pooh = 33
     INTEGER, PARAMETER, PRIVATE :: Pj_mpan = 34
     INTEGER, PARAMETER, PRIVATE :: Pj_mvk = 35
     INTEGER, PARAMETER, PRIVATE :: Pj_etooh = 36
     INTEGER, PARAMETER, PRIVATE :: Pj_prooh = 37
     INTEGER, PARAMETER, PRIVATE :: Pj_onitr = 38
     INTEGER, PARAMETER, PRIVATE :: Pj_acetol = 39
     INTEGER, PARAMETER, PRIVATE :: Pj_glyald = 40
     INTEGER, PARAMETER, PRIVATE :: Pj_hyac = 41
     INTEGER, PARAMETER, PRIVATE :: Pj_mek = 42
     INTEGER, PARAMETER, PRIVATE :: Pj_open = 43
     INTEGER, PARAMETER, PRIVATE :: Pj_gly = 44
     INTEGER, PARAMETER, PRIVATE :: Pj_acetp = 45
     INTEGER, PARAMETER, PRIVATE :: Pj_xooh = 46
     INTEGER, PARAMETER, PRIVATE :: Pj_isooh = 47
     INTEGER, PARAMETER, PRIVATE :: Pj_alkooh = 48
     INTEGER, PARAMETER, PRIVATE :: Pj_mekooh = 49
     INTEGER, PARAMETER, PRIVATE :: Pj_tolooh = 50
     INTEGER, PARAMETER, PRIVATE :: Pj_terpooh = 51
CONTAINS
SUBROUTINE racm_interface( &
!    chem, id, dtstepc,config_flags, &
    nspec_old, vc, id, dtstepc, &  !config_flags, &
    p_phy,t_phy,rho_phy,moist, &
    vdrog3, ldrog, &
             addt, addx, addc, etep, oltp, &
             olip, cslp, limp, hc5p, hc8p, &
             tolp, xylp, apip, isop, hc3p, &
             ethp, o3p, tco3, mo2, o1d, &
             olnn, olnd, rpho, xo2, ketp, &
             xno2, ol2p, oln, macp, &
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, &
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, &
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, &
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, &
             ph_hcochob, ph_macr, ph_hobr, ph_br2, ph_bro, &
             ph_n2o5, ph_o2, ph_pan, ph_acet, ph_mglo, &
             ph_hno4_2, ph_n2o, ph_pooh, ph_mpan, ph_mvk, &
             ph_etooh, ph_prooh, ph_onitr, ph_acetol, ph_glyald, &
             ph_hyac, ph_mek, ph_open, ph_gly, ph_acetp, &
             ph_xooh, ph_isooh, ph_alkooh, ph_mekooh, ph_tolooh, &
             ph_terpooh)
    IMPLICIT NONE
    INTEGER, INTENT(IN ) :: id
    INTEGER, INTENT(IN ) :: nspec_old
    REAL, INTENT(IN ) :: dtstepc
    REAL, DIMENSION(  nspec_old ), INTENT(INOUT ) ::vc
    REAL, &
         INTENT(IN ) :: moist
     REAL, &
             INTENT(IN ) :: &
                                                         p_phy, &
                                                         t_phy, &
                                                         rho_phy

    INTEGER, INTENT ( IN ) :: ldrog
    REAL, INTENT(INOUT) :: &
                      vdrog3(ldrog)
      REAL,  &
         INTENT(INOUT ) :: &
               addt, addx, addc, etep, oltp, &
               olip, cslp, limp, hc5p, hc8p, &
               tolp, xylp, apip, isop, hc3p, &
               ethp, o3p, tco3, mo2, o1d, &
               olnn, olnd, rpho, xo2, ketp, &
               xno2, ol2p, oln, macp
      REAL, &
         INTENT(INOUT ) :: &
               ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, &
               ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, &
               ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, &
               ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, &
               ph_hcochob, ph_macr, ph_hobr, ph_br2, ph_bro, &
               ph_n2o5, ph_o2, ph_pan, ph_acet, ph_mglo, &
               ph_hno4_2, ph_n2o, ph_pooh, ph_mpan, ph_mvk, &
               ph_etooh, ph_prooh, ph_onitr, ph_acetol, ph_glyald, &
               ph_hyac, ph_mek, ph_open, ph_gly, ph_acetp, &
               ph_xooh, ph_isooh, ph_alkooh, ph_mekooh, ph_tolooh, &
               ph_terpooh
    INTEGER, PARAMETER :: njv=51
    REAL(KIND=dp), DIMENSION(njv) :: jv
    REAL(KIND=dp):: TIME_START
    REAL(KIND=dp):: TIME_END
    INTEGER, DIMENSION(20) :: ICNTRL
    REAL(KIND=dp), DIMENSION(20) :: RCNTRL
    INTEGER, DIMENSION(20) :: ISTATUS
    REAL(KIND=dp), DIMENSION(20) :: RSTATUS
    INTEGER :: IERR_U
    REAL(KIND=dp), DIMENSION(NREACT):: RCONST
    REAL(KIND=dp), DIMENSION(NVAR) :: var
    REAL(KIND=dp), DIMENSION(NFIX) :: fix
    REAL(KIND=dp) :: TEMP
    REAL(KIND=dp), DIMENSION(NSPEC) :: ATOL, RTOL
    REAL(KIND=dp) :: conv, oconv
    REAL(KIND=dp) :: C_M
    INTEGER :: i,j,k,n
      DO n=1, 20
         ICNTRL(n) = 0
         RCNTRL(n) = 0._dp
      END DO
      DO n=1, NSPEC
         ATOL(n) = REAL(atols, KIND=dp)
         RTOL(n) = REAL(rtols, KIND=dp)
      END DO
      TIME_START = 0.0_dp
      TIME_END = REAL(dtstepc, KIND=dp)
   ICNTRL(1) = 1
   ICNTRL(3) = 2
   RCNTRL(3) = 0.01_dp * TIME_END
    FIX(indf_M) = REAL(dens2con_a * rho_phy, KIND=dp)
    C_M = FIX(indf_M)
!    FIX(indf_H2O) = REAL(dens2con_w * moist(i,k,j,P_QV) * rho_phy(i,k,j), KIND=dp)
    FIX(indf_H2O) = REAL(dens2con_w * moist* rho_phy, KIND=dp)
    TEMP = REAL(t_phy, KIND=dp)
!xhu     conv=1.E-6_dp*dens2con_a*rho_phy
     conv=dens2con_a*rho_phy
     oconv = 1.E0_dp/conv
    jv(Pj_o31d) = REAL(ph_o31d, KIND=dp)
    jv(Pj_o33p) = REAL(ph_o33p, KIND=dp)
    jv(Pj_no2) = REAL(ph_no2, KIND=dp)
    jv(Pj_no3o2) = REAL(ph_no3o2, KIND=dp)
    jv(Pj_no3o) = REAL(ph_no3o, KIND=dp)
    jv(Pj_hno2) = REAL(ph_hno2, KIND=dp)
    jv(Pj_hno3) = REAL(ph_hno3, KIND=dp)
    jv(Pj_hno4) = REAL(ph_hno4, KIND=dp)
    jv(Pj_h2o2) = REAL(ph_h2o2, KIND=dp)
    jv(Pj_ch2or) = REAL(ph_ch2or, KIND=dp)
    jv(Pj_ch2om) = REAL(ph_ch2om, KIND=dp)
    jv(Pj_ch3cho) = REAL(ph_ch3cho, KIND=dp)
    jv(Pj_ch3coch3) = REAL(ph_ch3coch3, KIND=dp)
    jv(Pj_ch3coc2h5) = REAL(ph_ch3coc2h5, KIND=dp)
    jv(Pj_hcocho) = REAL(ph_hcocho, KIND=dp)
    jv(Pj_ch3cocho) = REAL(ph_ch3cocho, KIND=dp)
    jv(Pj_hcochest) = REAL(ph_hcochest, KIND=dp)
    jv(Pj_ch3o2h) = REAL(ph_ch3o2h, KIND=dp)
    jv(Pj_ch3coo2h) = REAL(ph_ch3coo2h, KIND=dp)
    jv(Pj_ch3ono2) = REAL(ph_ch3ono2, KIND=dp)
    jv(Pj_hcochob) = REAL(ph_hcochob, KIND=dp)
    jv(Pj_macr) = REAL(ph_macr, KIND=dp)
    jv(Pj_hobr) = REAL(ph_hobr, KIND=dp)
    jv(Pj_br2) = REAL(ph_br2, KIND=dp)
    jv(Pj_bro) = REAL(ph_bro, KIND=dp)
    jv(Pj_n2o5) = REAL(ph_n2o5, KIND=dp)
    jv(Pj_o2) = REAL(ph_o2, KIND=dp)
    jv(Pj_pan) = REAL(ph_pan, KIND=dp)
    jv(Pj_acet) = REAL(ph_acet, KIND=dp)
    jv(Pj_mglo) = REAL(ph_mglo, KIND=dp)
    jv(Pj_hno4_2) = REAL(ph_hno4_2, KIND=dp)
    jv(Pj_n2o) = REAL(ph_n2o, KIND=dp)
    jv(Pj_pooh) = REAL(ph_pooh, KIND=dp)
    jv(Pj_mpan) = REAL(ph_mpan, KIND=dp)
    jv(Pj_mvk) = REAL(ph_mvk, KIND=dp)
    jv(Pj_etooh) = REAL(ph_etooh, KIND=dp)
    jv(Pj_prooh) = REAL(ph_prooh, KIND=dp)
    jv(Pj_onitr) = REAL(ph_onitr, KIND=dp)
    jv(Pj_acetol) = REAL(ph_acetol, KIND=dp)
    jv(Pj_glyald) = REAL(ph_glyald, KIND=dp)
    jv(Pj_hyac) = REAL(ph_hyac, KIND=dp)
    jv(Pj_mek) = REAL(ph_mek, KIND=dp)
    jv(Pj_open) = REAL(ph_open, KIND=dp)
    jv(Pj_gly) = REAL(ph_gly, KIND=dp)
    jv(Pj_acetp) = REAL(ph_acetp, KIND=dp)
    jv(Pj_xooh) = REAL(ph_xooh, KIND=dp)
    jv(Pj_isooh) = REAL(ph_isooh, KIND=dp)
    jv(Pj_alkooh) = REAL(ph_alkooh, KIND=dp)
    jv(Pj_mekooh) = REAL(ph_mekooh, KIND=dp)
    jv(Pj_tolooh) = REAL(ph_tolooh, KIND=dp)
    jv(Pj_terpooh) = REAL(ph_terpooh, KIND=dp)
    var(ind_O3) = conv * REAL( MAX(vc(lo3),0.), KIND=dp)
    var(ind_H2O2) = conv * REAL( MAX(vc(lh2o2),0.), KIND=dp)
    var(ind_NO) = conv * REAL( MAX(vc(lno),0.), KIND=dp)
    var(ind_NO2) = conv * REAL( MAX(vc(lno2),0.), KIND=dp)
    var(ind_NO3) = conv * REAL( MAX(vc(lno3),0.), KIND=dp)
    var(ind_N2O5) = conv * REAL( MAX(vc(ln2o5),0.), KIND=dp)
    var(ind_HONO) = conv * REAL( MAX(vc(lhono),0.), KIND=dp)
    var(ind_HNO3) = conv * REAL( MAX(vc(lhno3),0.), KIND=dp)
    var(ind_HNO4) = conv * REAL( MAX(vc(lhno4),0.), KIND=dp)
    var(ind_SO2) = conv * REAL( MAX(vc(lso2),0.), KIND=dp)
    var(ind_SULF) = conv * REAL( MAX(vc(lsulf),0.), KIND=dp)
    var(ind_CO) = conv * REAL( MAX(vc(lco),0.), KIND=dp)
    var(ind_CO2) = conv * REAL( MAX(vc(lco2),0.), KIND=dp)
    var(ind_CH4) = conv * REAL( MAX(vc(lch4),0.), KIND=dp)
    var(ind_ETH) = conv * REAL( MAX(vc(leth),0.), KIND=dp)
    var(ind_HC3) = conv * REAL( MAX(vc(lhc3),0.), KIND=dp)
    var(ind_HC5) = conv * REAL( MAX(vc(lhc5),0.), KIND=dp)
    var(ind_HC8) = conv * REAL( MAX(vc(lhc8),0.), KIND=dp)
    var(ind_ETE) = conv * REAL( MAX(vc(lete),0.), KIND=dp)
    var(ind_OLT) = conv * REAL( MAX(vc(lolt),0.), KIND=dp)
    var(ind_OLI) = conv * REAL( MAX(vc(loli),0.), KIND=dp)
    var(ind_DIEN) = conv * REAL( MAX(vc(ldien),0.), KIND=dp)
    var(ind_ISO) = conv * REAL( MAX(vc(liso),0.), KIND=dp)
    var(ind_API) = conv * REAL( MAX(vc(lapi),0.), KIND=dp)
    var(ind_LIM) = conv * REAL( MAX(vc(llim),0.), KIND=dp)
    var(ind_TOL) = conv * REAL( MAX(vc(ltol),0.), KIND=dp)
    var(ind_XYL) = conv * REAL( MAX(vc(lxyl),0.), KIND=dp)
    var(ind_CSL) = conv * REAL( MAX(vc(lcsl),0.), KIND=dp)
    var(ind_HCHO) = conv * REAL( MAX(vc(lhcho),0.), KIND=dp)
    var(ind_ALD) = conv * REAL( MAX(vc(lald),0.), KIND=dp)
    var(ind_KET) = conv * REAL( MAX(vc(lket),0.), KIND=dp)
    var(ind_GLY) = conv * REAL( MAX(vc(lgly),0.), KIND=dp)
    var(ind_MGLY) = conv * REAL( MAX(vc(lmgly),0.), KIND=dp)
    var(ind_DCB) = conv * REAL( MAX(vc(ldcb),0.), KIND=dp)
    var(ind_MACR) = conv * REAL( MAX(vc(lmacr),0.), KIND=dp)
    var(ind_UDD) = conv * REAL( MAX(vc(ludd),0.), KIND=dp)
    var(ind_HKET) = conv * REAL( MAX(vc(lhket),0.), KIND=dp)
    var(ind_ONIT) = conv * REAL( MAX(vc(lonit),0.), KIND=dp)
    var(ind_PAN) = conv * REAL( MAX(vc(lpan),0.), KIND=dp)
    var(ind_TPAN) = conv * REAL( MAX(vc(ltpan),0.), KIND=dp)
    var(ind_OP1) = conv * REAL( MAX(vc(lop1),0.), KIND=dp)
    var(ind_OP2) = conv * REAL( MAX(vc(lop2),0.), KIND=dp)
    var(ind_PAA) = conv * REAL( MAX(vc(lpaa),0.), KIND=dp)
    var(ind_ORA1) = conv * REAL( MAX(vc(lora1),0.), KIND=dp)
    var(ind_ORA2) = conv * REAL( MAX(vc(lora2),0.), KIND=dp)
    var(ind_HO) = conv * REAL( MAX(vc(lho),0.), KIND=dp)
    var(ind_HO2) = conv * REAL( MAX(vc(lho2),0.), KIND=dp)
    var(ind_O3P) = conv * REAL( MAX(o3p,0.), KIND=dp)
    var(ind_O1D) = conv * REAL( MAX(o1d,0.), KIND=dp)
    var(ind_MO2) = conv * REAL( MAX(mo2,0.), KIND=dp)
    var(ind_ETHP) = conv * REAL( MAX(ethp,0.), KIND=dp)
    var(ind_HC3P) = conv * REAL( MAX(hc3p,0.), KIND=dp)
    var(ind_HC5P) = conv * REAL( MAX(hc5p,0.), KIND=dp)
    var(ind_HC8P) = conv * REAL( MAX(hc8p,0.), KIND=dp)
    var(ind_ETEP) = conv * REAL( MAX(etep,0.), KIND=dp)
    var(ind_OLTP) = conv * REAL( MAX(oltp,0.), KIND=dp)
    var(ind_OLIP) = conv * REAL( MAX(olip,0.), KIND=dp)
    var(ind_ISOP) = conv * REAL( MAX(isop,0.), KIND=dp)
    var(ind_APIP) = conv * REAL( MAX(apip,0.), KIND=dp)
    var(ind_LIMP) = conv * REAL( MAX(limp,0.), KIND=dp)
    var(ind_PHO) = conv * REAL( MAX(RPHO,0.), KIND=dp)
    var(ind_ADDT) = conv * REAL( MAX(addt,0.), KIND=dp)
    var(ind_ADDX) = conv * REAL( MAX(addx,0.), KIND=dp)
    var(ind_ADDC) = conv * REAL( MAX(addc,0.), KIND=dp)
    var(ind_TOLP) = conv * REAL( MAX(tolp,0.), KIND=dp)
    var(ind_XYLP) = conv * REAL( MAX(xylp,0.), KIND=dp)
    var(ind_CSLP) = conv * REAL( MAX(cslp,0.), KIND=dp)
    var(ind_ACO3) = conv * REAL( MAX(vc(laco3),0.), KIND=dp)
    var(ind_TCO3) = conv * REAL( MAX(tco3,0.), KIND=dp)
    var(ind_KETP) = conv * REAL( MAX(ketp,0.), KIND=dp)
    var(ind_XO2) = conv * REAL( MAX(xo2,0.), KIND=dp)
    var(ind_OLNN) = conv * REAL( MAX(olnn,0.), KIND=dp)
    var(ind_OLND) = conv * REAL( MAX(olnd,0.), KIND=dp)
    var(ind_Br) = conv * REAL( MAX(vc(lbr),0.), KIND=dp)
    var(ind_BrO) = conv * REAL( MAX(vc(lbro),0.), KIND=dp)
    var(ind_HOBr) = conv * REAL( MAX(vc(lhobr),0.), KIND=dp)
    var(ind_HBr) = conv * REAL( MAX(vc(lhbr),0.), KIND=dp)
    var(ind_Br2) = conv * REAL( MAX(vc(lbr2),0.), KIND=dp)
   CALL racm_Update_Rconst( &
             jv, njv, &
             RCONST, &
             Pj_o31d, Pj_o33p, Pj_no2, Pj_no3o2, Pj_no3o, &
             Pj_hno2, Pj_hno3, Pj_hno4, Pj_h2o2, Pj_ch2or, &
             Pj_ch2om, Pj_ch3cho, Pj_ch3coch3, Pj_ch3coc2h5, Pj_hcocho, &
             Pj_ch3cocho, Pj_hcochest, Pj_ch3o2h, Pj_ch3coo2h, Pj_ch3ono2, &
             Pj_hcochob, Pj_macr, Pj_hobr, Pj_br2, Pj_bro, &
             Pj_n2o5, Pj_o2, Pj_pan, Pj_acet, Pj_mglo, &
             Pj_hno4_2, Pj_n2o, Pj_pooh, Pj_mpan, Pj_mvk, &
             Pj_etooh, Pj_prooh, Pj_onitr, Pj_acetol, Pj_glyald, &
             Pj_hyac, Pj_mek, Pj_open, Pj_gly, Pj_acetp, &
             Pj_xooh, Pj_isooh, Pj_alkooh, Pj_mekooh, Pj_tolooh, &
             Pj_terpooh, &
             C_M, FIX(indf_H2O), TEMP &
)
  CALL racm_INTEGRATE(TIME_START, TIME_END, &
          FIX, VAR, RCONST, ATOL, RTOL, &
          ICNTRL_U=icntrl, RCNTRL_U=rcntrl )
    vc(lo3) = MAX ( REAL (oconv * var(ind_O3), KIND=dp), 0.)
    vc(lh2o2) = MAX ( REAL (oconv * var(ind_H2O2), KIND=dp), 0.)
    vc(lno) = MAX ( REAL (oconv * var(ind_NO), KIND=dp), 0.)
    vc(lno2) = MAX ( REAL (oconv * var(ind_NO2), KIND=dp), 0.)
    vc(lno3) = MAX ( REAL (oconv * var(ind_NO3), KIND=dp), 0.)
    vc(ln2o5) = MAX ( REAL (oconv * var(ind_N2O5), KIND=dp), 0.)
    vc(lhono) = MAX ( REAL (oconv * var(ind_HONO), KIND=dp), 0.)
    vc(lhno3) = MAX ( REAL (oconv * var(ind_HNO3), KIND=dp), 0.)
    vc(lhno4) = MAX ( REAL (oconv * var(ind_HNO4), KIND=dp), 0.)
    vc(lso2) = MAX ( REAL (oconv * var(ind_SO2), KIND=dp), 0.)
    vc(lsulf) = MAX ( REAL (oconv * var(ind_SULF), KIND=dp), 0.)
    vc(lco) = MAX ( REAL (oconv * var(ind_CO), KIND=dp), 0.)
    vc(lco2) = MAX ( REAL (oconv * var(ind_CO2), KIND=dp), 0.)
    vc(lch4) = MAX ( REAL (oconv * var(ind_CH4), KIND=dp), 0.)
    vc(leth) = MAX ( REAL (oconv * var(ind_ETH), KIND=dp), 0.)
    vc(lhc3) = MAX ( REAL (oconv * var(ind_HC3), KIND=dp), 0.)
    vc(lhc5) = MAX ( REAL (oconv * var(ind_HC5), KIND=dp), 0.)
    vc(lhc8) = MAX ( REAL (oconv * var(ind_HC8), KIND=dp), 0.)
    vc(lete) = MAX ( REAL (oconv * var(ind_ETE), KIND=dp), 0.)
    vc(lolt) = MAX ( REAL (oconv * var(ind_OLT), KIND=dp), 0.)
    vc(loli) = MAX ( REAL (oconv * var(ind_OLI), KIND=dp), 0.)
    vc(ldien) = MAX ( REAL (oconv * var(ind_DIEN), KIND=dp), 0.)
    vc(liso) = MAX ( REAL (oconv * var(ind_ISO), KIND=dp), 0.)
    vc(lapi) = MAX ( REAL (oconv * var(ind_API), KIND=dp), 0.)
    vc(llim) = MAX ( REAL (oconv * var(ind_LIM), KIND=dp), 0.)
    vc(ltol) = MAX ( REAL (oconv * var(ind_TOL), KIND=dp), 0.)
    vc(lxyl) = MAX ( REAL (oconv * var(ind_XYL), KIND=dp), 0.)
    vc(lcsl) = MAX ( REAL (oconv * var(ind_CSL), KIND=dp), 0.)
    vc(lhcho) = MAX ( REAL (oconv * var(ind_HCHO), KIND=dp), 0.)
    vc(lald) = MAX ( REAL (oconv * var(ind_ALD), KIND=dp), 0.)
    vc(lket) = MAX ( REAL (oconv * var(ind_KET), KIND=dp), 0.)
    vc(lgly) = MAX ( REAL (oconv * var(ind_GLY), KIND=dp), 0.)
    vc(lmgly) = MAX ( REAL (oconv * var(ind_MGLY), KIND=dp), 0.)
    vc(ldcb) = MAX ( REAL (oconv * var(ind_DCB), KIND=dp), 0.)
    vc(lmacr) = MAX ( REAL (oconv * var(ind_MACR), KIND=dp), 0.)
    vc(ludd) = MAX ( REAL (oconv * var(ind_UDD), KIND=dp), 0.)
    vc(lhket) = MAX ( REAL (oconv * var(ind_HKET), KIND=dp), 0.)
    vc(lonit) = MAX ( REAL (oconv * var(ind_ONIT), KIND=dp), 0.)
    vc(lpan) = MAX ( REAL (oconv * var(ind_PAN), KIND=dp), 0.)
    vc(ltpan) = MAX ( REAL (oconv * var(ind_TPAN), KIND=dp), 0.)
    vc(lop1) = MAX ( REAL (oconv * var(ind_OP1), KIND=dp), 0.)
    vc(lop2) = MAX ( REAL (oconv * var(ind_OP2), KIND=dp), 0.)
    vc(lpaa) = MAX ( REAL (oconv * var(ind_PAA), KIND=dp), 0.)
    vc(lora1) = MAX ( REAL (oconv * var(ind_ORA1), KIND=dp), 0.)
    vc(lora2) = MAX ( REAL (oconv * var(ind_ORA2), KIND=dp), 0.)
    vc(lho) = MAX ( REAL (oconv * var(ind_HO), KIND=dp), 0.)
    vc(lho2) = MAX ( REAL (oconv * var(ind_HO2), KIND=dp), 0.)
   o3p = MAX (REAL (oconv * var(ind_O3P) , KIND=dp),0.)
   o1d = MAX (REAL (oconv * var(ind_O1D) , KIND=dp),0.)
   mo2 = MAX (REAL (oconv * var(ind_MO2) , KIND=dp),0.)
   ethp = MAX (REAL (oconv * var(ind_ETHP) , KIND=dp),0.)
   hc3p = MAX (REAL (oconv * var(ind_HC3P) , KIND=dp),0.)
   hc5p = MAX (REAL (oconv * var(ind_HC5P) , KIND=dp),0.)
   hc8p = MAX (REAL (oconv * var(ind_HC8P) , KIND=dp),0.)
   etep = MAX (REAL (oconv * var(ind_ETEP) , KIND=dp),0.)
   oltp = MAX (REAL (oconv * var(ind_OLTP) , KIND=dp),0.)
   olip = MAX (REAL (oconv * var(ind_OLIP) , KIND=dp),0.)
   isop = MAX (REAL (oconv * var(ind_ISOP) , KIND=dp),0.)
   apip = MAX (REAL (oconv * var(ind_APIP) , KIND=dp),0.)
   limp = MAX (REAL (oconv * var(ind_LIMP) , KIND=dp),0.)
   RPHO = MAX (REAL (oconv * var(ind_PHO) , KIND=dp),0.)
   addt = MAX (REAL (oconv * var(ind_ADDT) , KIND=dp),0.)
   addx = MAX (REAL (oconv * var(ind_ADDX) , KIND=dp),0.)
   addc = MAX (REAL (oconv * var(ind_ADDC) , KIND=dp),0.)
   tolp = MAX (REAL (oconv * var(ind_TOLP) , KIND=dp),0.)
   xylp = MAX (REAL (oconv * var(ind_XYLP) , KIND=dp),0.)
   cslp = MAX (REAL (oconv * var(ind_CSLP) , KIND=dp),0.)
    vc(laco3) = MAX ( REAL (oconv * var(ind_ACO3), KIND=dp), 0.)
   tco3 = MAX (REAL (oconv * var(ind_TCO3) , KIND=dp),0.)
   ketp = MAX (REAL (oconv * var(ind_KETP) , KIND=dp),0.)
   xo2 = MAX (REAL (oconv * var(ind_XO2) , KIND=dp),0.)
   olnn = MAX (REAL (oconv * var(ind_OLNN) , KIND=dp),0.)
   olnd = MAX (REAL (oconv * var(ind_OLND) , KIND=dp),0.)
    vc(lbr) = MAX ( REAL (oconv * var(ind_Br), KIND=dp), 0.)
    vc(lbro) = MAX ( REAL (oconv * var(ind_BrO), KIND=dp), 0.)
    vc(lhobr) = MAX ( REAL (oconv * var(ind_HOBr), KIND=dp), 0.)
    vc(lhbr) = MAX ( REAL (oconv * var(ind_HBr), KIND=dp), 0.)
    vc(lbr2) = MAX ( REAL (oconv * var(ind_Br2), KIND=dp), 0.)
END SUBROUTINE racm_interface
END MODULE module_kpp_racm_interf
