      program racmb
c Canopy-chemistry model CACHE (Renate Forkel, IMK-IFU)
c Major parts of the model (radiation canopy structure) are from CUPID by John Norman
c Chemistry subroutine by Bill Stockwell and Matthias Karl
c Reference: Forkel et al., 2006 (Atmospheric Environment 40)
c
c Still to be improved: 
c
c  Water extraction by roots
c  Photolysis

      implicit double precision (a-h,o-z)

      parameter (nlev=40,nsoil=15)    ! number of levels  
      parameter (nspec=77, nrect=237)
      parameter(maxemi=nspec) ! maximal number of emissions
      parameter(maxrect=500)
      parameter(maxphr=100, maxphpt=100)

      external f, jac, rate
      logical lprin

c     integer specnr
c     character*4,species
c     character mechid*60

      dimension vcp(nlev,nspec), phot1(23,nlev), 
     &vp(nlev),wind(nlev),akh(nlev),photout(23,nlev),ajnn(nlev)
      dimension temlf1(10,99)
      double precision photoj(maxphr)
      double precision vc(nspec)
      common /info/ iitime,llev
      common /treespec/ isort
      common /inputr/ inrad,iwpm2
      double precision emivalue(maxemi)
      common /emissions/ emivalue
      common/quellen/source(nlev,nspec)

      common/timpar/timloc,deltim,month,jday,iyear,icumdy
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/cpy2/hsoil,hcpys,evtot,etotw(99),contot(99),scond(10,99)
     1,ecpys,cphstr,cpestr,wcpys,evsmic,ihrwet(99)
      common/misc1/pi,pid180,pid2,sigma,iwrite(9,99),kmax
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot

      common/astron/eqtm,decl,sindec,cosdec,decmax,sinlat,coslat,
     1 tanlat,dlong
      common/deg/sunazm,viewzn(99),viewaz(99),nozenv,noazmv
     & ,xintv(20,90)
      common /rad1/emis,emisol,rsoil(3),rleaf(3),tleaf(3),aleaf(3)
     &,expdif(99),rlayr(3,30),tlayr(3,30)
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common /rad3/radtop(3),fbeam(3),coszen,zenang
     & ,ratiod,ration,ratio
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/rad6/rlfdif(3),tlfdif(3),rlfdir(3),tlfdir(3)
      common /rad7/ facte(99)
      common/resis1/rhleaf(99),rsleaf(10,99),rsnovp(10,99),
     & rst(10,99),hpsi
      common/resis2/radn,anstom,rcut20,rsmin,trsopt,trsmin,trsmax,rsm
     1,rsexp,psi1,psi2
      common/root1/froot(99),resrot(99),rootsm,psixy,psitop,rroot
     1,rootup(99),cpytr,psisum,aroot
      common/cpy1/etotwt,htot,rplnt,evapg(99),heatg(99),eave(99)
     &,have(99),waterg(99)
      common/cpysrc/ evaps(99),heats(99)
      common/soil1/zs(nsoil),sl,dels
      common/feld/ eta(nsoil),psi(nsoil),psit(nsoil),
     &temp(nsoil),xk(nsoil),psieta(nsoil),
     &psitet(nsoil),xlam(nsoil),axa(nsoil),bxb(nsoil),
     &cxc(nsoil),dxd(nsoil),d1t(nsoil),
     &d2t(nsoil),d1eta(nsoil),d2eta(nsoil),
     &xl11(nsoil),xl22(nsoil),rho0(nsoil),
     &rho1(nsoil),rho22(nsoil),xl210(nsoil),
     &p21(nsoil),p21t(nsoil),h(nsoil),datm(nsoil)
      common/bodk/ etamin,etamax,xkr,por,trefp,trefk,cp3,rho3,
     &feldka,albdry,albwet
      common/intf/ qgrnd,qsatg,tausum,tsum,vsum,tsurf,patm,
     &fnet,gdown,gfnet,afl1,aflh,bfl1,bfl2,bflh
      data akh/nlev*0./
      common/stratpar/ stable,vgday,vgn,zrday,zrn,alphaday,alphan
      logical stable

      common/efactneu/ efiso2(2,15),                   !Isopren
     & efapi(2,15),efbpi(2,15),efcam(2,15),eftri(2,15),  !Monoterpene
     & efsab(2,15),efmyr(2,15),efbph(2,15),eflim(2,15),
     & ef18c(2,15),efd3c(2,15),efpci(2,15),efaty(2,15),
     & efaca(2,15),efbca(2,15),efoci(2,15),
     & sovoce(9)
      common /par/parabv


      common/etc/fiso,fapi,flim,fmacr,sumsiso,sumsapi,sumslim,fapi2
     &,fiso2,flim2,fmacr2
      common/spezies/ 
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP


c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

c  INPUT
c Emission type
c  isort=1 Guenter emissions, coniferous (needs sources)
c  isort=2 Guenter emissions, deciduous (needs sources)
c  isort=3 Steinbrecher emissions, spruce (needs sourcneu)
c  isort=4 Steinbrecher emissions, pine (needs sourcneu)
c  isort=5 Steinbrecher emissions with Seufert corrections, quercus ilex (needs sourcneu)
c  isort=6 Ciccioli (needs sourcneu)
c  isort=7 Citrus   (needs sourcneu)
c  isort=8 Quercus Robur   (needs sourcneu)
c  isort=9 Oak ridge deciduous mixed forest

c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c Simulation length and number of time steps
      timloc=0.      
      deltim=60.* 1.0      ! time step in seconds
      ntimes= 60.*60./deltim * 24. * 2.
      dpt= (deltim/60.)/60. !print all time steps
      dpt= 30./60.          ! print frequency (fraction of hour)
c     dpt= 10./60.          ! print frequency (fraction of hour)

      tstart= timloc*3600.
      ptime=timloc+dpt

c     open(71,file='fluss_out')
c     open(72,file='conc_out')

c   Initialize profiles of T, RH, and chemical species
c ----------------------------------------------------------------------
      call init(vcp,phot1,emiss,wind,rlat,clump)
c-------------------------------------------------------------------------
      ratdsav=ratiod
      ratnsav=ration

      iday=1

      if(isort.eq.1) write(6,'(/," 1: Guenther, coniferous ")')
      if(isort.eq.2) write(6,'(/," 2: Guenther, deciduous  ")')
      if(isort.eq.3) write(6,'(/," 3: Steinbecher, spruce  ")')
      if(isort.eq.4) write(6,'(/," 4: Steinbecher, pine    ")')
      if(isort.eq.5) write(6,'(/," 5: Steinbecher, Q.ilex  ")')
      if(isort.eq.6) write(6,'(/," 6: Ciccioli,    Q.ilex  ")')
      if(isort.eq.7) write(6,'(/," 7: Seufert,     Citrus  ")')
      if(isort.eq.8) write(6,'(/," 8: Steinbrecher,Q. robur")')
      if(isort.eq.9) write(6,'(/," 9: Oak ridge dec. mixed ")')
      write(6,'(/," Hertel, dtstep=60s  akh          "2f10.2)')
c     write(6,'(/," lai=5.0 kon3, db=cs2, akh=akm ",2f10.2)')
c     write(6,'(/," lai=5.0 kon3, db=cs2, alpha=2.0",2f10.2)')


c ----------------------------------------------------------------------
      call print(timloc,vcp,emiss,wind,photout,akh,iday)
c-------------------------------------------------------------------------

c Radiation input from file ?
      if(inrad.eq.1) then
      dtl2=0.
      read(33,*)   ! read header
      timin=0.
      endif

      do 100 itime=1,ntimes  ! ----------------- Time loop

      if(timloc.ge.24.) then  ! New day?
      timloc=timloc-24.
      tstart=timloc*3600.
      jday=jday+1
      iday=iday+1
      icumdy=icumdy+1
      endif
c
      lprin=.false.
      if(timloc.ge.ptime-deltim/3600.) lprin=.true.
      if(itime.eq.ntimes) lprin=.true.
c     lprin=.true.

      write(6,'(/," itime, time "i5,2f10.2)') itime,timloc    

c Consider cloud effects

      ratiod=ratdsav
      ration=ratnsav


c-------------------------------------------------------------------------
      call declin
      call zenith
c-------------------------------------------------------------------------
c
c
c Radiation input from file ?
c Read incoming radiation from extra file (unit 33) for calulating ratiod (cloud effect)
      if(inrad.eq.1) then
cc    if(timloc/24.+(iday-1).ge.timin) read(33,*) timin,averad ! for input times like in srad-020727ff
      if(timloc             .gt.timin) read(33,*) timin,averad ! for input times like in srad-990720-20
      if(timloc.eq.0.) read(33,*) timin,averad
       write(06,*) 'timin', timin   ,timloc
      potvis=0.
      potnir=0.
      if(coszen.gt.0.01 ) then
c  correct for curvature of atmos in airmas
      airmas=(sqrt(coszen**2+.0025)-coszen)/.00125
c  correct for refraction(good to 89.5 deg.)
      airmas=airmas-2.8/(90.-zenang/pid180)**2
      potbm1=600.*exp(-.160*airmas)
      potvis=(potbm1+(600.-potbm1)*.4)*coszen
      potdif=(600.-potbm1)*.4*coszen
      uu=1/coszen
      axlog=dlog10(uu)
      a=10**(-1.195+.4459*axlog-.0345*axlog*axlog)
      watabs=1320.*a
      potbm2=720.*exp(-.05*airmas)-watabs
      if(potbm2.lt.0.)potbm2=0.
      eval=(720.-potbm2-watabs)*.54*coszen
      potnir=eval+potbm2*coszen
        if(iwpm2.eq.1) then
        ratiod=averad/(potvis+potnir) !  averad includes total solar spectrum (SWdown) in W/m**2
        else
        ratiod=(averad/4.6)/potvis    !  averad is PAR in micromoles per (m2 seconds)
c      write(06,'("averad",f8.3,3f8.1,f8.3)')
c    & timin,averad/4.6,potvis,potnir,ratiod
        endif
      endif
       else
c  Modify #########################################################################
c  Modify if you want to introduce cloud cover without specifying PAR on extra file
c  Example:
      if(iday.eq.2) then
       if(timloc.ge.8..and.timloc.lt.12.5)  then
       if(timloc.ge.11..and.timloc.lt.12.)  ratiod=0.1
       ratiod=0.6
       ration=0.6
       endif
       if(timloc.gt.19.) then
       ratiod=0.4
       endif
      endif
      endif


c Radiation for all layers and 10 angle classes
c-------------------------------------------------------------------------
      call declin
c-------------------------------------------------------------------------
c-------------------------------------------------------------------------
      call zenith
c-------------------------------------------------------------------------
c-------------------------------------------------------------------------
      call dstlit(zenang,sunazm,kmax,rlfdir,tlfdir)
c-------------------------------------------------------------------------
      if (coszen.gt.0.) call radin4
c-------------------------------------------------------------------------
      call difint(clump,sunazm)
c-------------------------------------------------------------------------
      do k=1,nlev
      vp(k)=0.01*vcp(k,lh2o)*p(k)
      psat=610.7*exp(17.1536*(t(k)-273.15)/(t(k)-
     &38.33))
      p1=vcp(k,lh2o)*p(k)
      relh(k)=p1/psat
      enddo
      ta=t(30)
      vpa=   vp(30) 
c     write(06,'(" ta,va ",4e12.4)') ta,vpa,vcp(25,lh2o)

c-------------------------------------------------------------------------
      call skyir(ta,vpa) 
c-------------------------------------------------------------------------

c     write(06,'(" radtop",3e12.4)') radtop
c     write(06,'(" parabv(radtop)",e12.4)') 
c    &  2.8*radtop(1)


c **** Iteration over stress *****************************************
c **** Iterate leaf temperature *****************
      ipass=0
      noiter=0
      iterh=0

c     write(6,*) ' '
c     write(6,*) ' j  templf (vor Iteration)'
c     do j=jtot,2,-1
c     write(6,'(i3,10f11.6)') j,(templf(i,j),i=1,itotp1)
c     enddo


      kstrt=3
      if(coszen.gt.0.) kstrt=1 ! always longwave, shortwave only if sun is up
 1060 if(ipass.eq.1) kstrt=3
c-------------------------------------------------------------------------
      call radiat(kstrt,coszen,radtop,fbeam,zenang,sunazm,clump,
     & lprin)
c-------------------------------------------------------------------------

c Stomatal resistance
c ----------------------------------------------------------------------
      call stoma(lprin,t,relh)
c ----------------------------------------------------------------------
c      write(06,'(" noiter=",2i3)') noiter,ipass


c Leaf surface temperature
c ----------------------------------------------------------------------
      call lfebal(t,vp,wind,lprin)
c ----------------------------------------------------------------------

      igo=0
      tlfsum=0.
      do 1200 i=1,itotp1
      do 1200 j=2,jtot
      if(abs(templf(i,j)-temlf1(i,j)).gt.0.2) igo=1
      tlfsum=tlfsum+abs(templf(i,j)-temlf1(i,j))
 1200 continue
      dtlf=tlfsum/(itotp1*(jtot-1))
c     write(6,1218)dtlf,noiter
c     if(noiter.eq.50)write(6,1218)dtlf,noiter
 1218 format(' mean abs tleaf_new-tleaf= ',f6.3,' noiter=',i3)
      if(noiter.gt.50) goto 1219
      if(igo.eq.1) then      
      ipass=1
      noiter=noiter+1
      do 1100 i=1,itotp1
      do 1100 j=2,jtot
c  tried weighting .5 and .5 but convergence is only half as fast.
      templf(i,j)=.9*templf(i,j)+.1*temlf1(i,j)
 1100 temlf1(i,j)=templf(i,j)
      goto 1060
      endif

c Water extraction by roots
c ----------------------------------------------------------------------
 1219 call rootex
c ----------------------------------------------------------------------

c ----------------------------------------------------------------------
      call stress
c ----------------------------------------------------------------------

      psidif=psitop-psitp1
      if(iterh.gt.50)write(6,1265)ihr,iterh,psitop/100.,cpytr
     &,psidif/100.
 1265 format(' ihr=',i3,' iterh=',i3,' psitop=',f6.2,' cpytr=',f8.2
     &,' psidif=',f6.2)
      if(iterh.gt.50)goto 1300
c  check if stress is limiting
c      write(06,'(" iterh=",i3)') iterh  
c      write(06,'(" psi1,psitop,psitp1",3e11.3)') psi1,psitop,psitp1
      
      if(psitp1.lt.psi1.and.iterh.eq.0) goto 1255
      if(psitop.ge.psi1.and.iterh.eq.0) goto 1300
 1255 psimn=(psi1+psi2)/2.
      if(iterh.gt.0) goto 1270
c  psitp1 is previous psitop.   psisv1 is psitot before calc of cpytr
c    from previous iteration. it goes with trsav1 for first coord. of
c    slope estm of cpytr vs psitop relation.
      trsav1=cpytr
      psisv1=psitp1
      if(abs(psitop-psitp1).gt.0.) psitop=(psitop+psitp1)/2.
      if(abs(psitop-psi2).le.0.) psitop=psitop+10.
      if(psitop.lt.psi2) psitop=psimn-sqrt((psi2-psitop)/(-psitop))*
     &(psi1-psi2)
      psitp1=psitop
      iterh=iterh+1
      goto 1060
 1270 if(abs(psitop-psitp1).lt.10.)goto 1300
      amx=(trsav1-cpytr)/(psisv1-psitp1)
      b=trsav1-amx*psisv1
      xroot=0.66667*rroot+1./rootsm
      psitop=(-b*xroot+psisum)/(1.+amx*xroot)
c psisum in above stm was originally psisum/rootsm, chen, 02/19/90.
      if(iterh.gt.10) psitop=(psitop+psitp1)/2.
      if(psitop.lt.psi2) psitop=psimn-sqrt((psi2-psitop)/(-psitop))*
     &(psi1-psi2)/2.
      trsav1=cpytr
      psisv1=psitp1
      psitp1=psitop
      iterh=iterh+1
      goto 1060
 1300 continue
c *********** end iteration over stress *******************************

      do k=1,nlev
      evaps(k)=0.
      heats(k)=0.
      enddo
      do k=2,jtot
      evaps(levhtr-2+k)=evapg(k)
      heats(levhtr-2+k)=heatg(k)
      enddo

c     if(lprin) then

c     write(6,*) ' '
c     write(6,*) ' j  dstnet'
c     do j=jtot,2,-1
c     write(6,'(i3,10e11.3)') j,(dstnet(i,j),i=1,itotp1)
c     enddo

c     write(6,*) ' '
c     write(6,*) ' j  dstrad(3,i,j)'
c     do j=jtot,2,-1
cc     write(6,'(i3,10e11.3)') j,(rsleaf(i,j),i=1,itotp1)           
c     write(6,'(i3,10e11.3)') j,(dstrad(3,i,j),i=1,itotp1)           
c     enddo

c     write(6,*) ' '
c     write(6,*) ' j  templf'
c     do j=jtot,2,-1
c     write(6,'(i3,10f11.6)') j,(templf(i,j),i=1,itotp1)
c     enddo
 
c     endif


c Vertical exchange 

c Wind (fixed specified profile)

c  Modify #####################################################
      if(rnet(jtot).gt.0.) then
      vg=vgday       !day
c      if(timloc.gt.11.and.timloc.lt.12) vg=vgday/10.
      alphab=alphaday
      zrough=zrday
      else            !night
      vg= vgn
      if(timloc.lt.20) vg=vgday
c  TEST xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c     if(iday.eq.4) then
c      if(timloc.gt.18.and.timloc.lt.19) vg=vgn*0.8
c      if(timloc.gt.19.and.timloc.lt.21) vg=vgn*0.5
c     endif
      alphab=alphan
      zrough=zrn
      endif
c Wind profile
c ----------------------------------------------------------------------
      call wprofil(vg,alphab,wind)
c ----------------------------------------------------------------------

c Exchange coefficients
c ----------------------------------------------------------------------
       call atk(rlat,z,wind,akh,ajnn,lprin)
c ----------------------------------------------------------------------
 
c Sources due to emissions >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
c ----------------------------------------------------------------------
      if(isort.le.2) then
c  a) uenther emissions
      call sources(vcp,lprin)
      else
c  b) Steinbrecher emissions
      call sourcneu(vcp,isort,lprin,deltim)
      endif
c ----------------------------------------------------------------------
 
c Sinks due to deposition >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
c ----------------------------------------------------------------------
      call sinks(vcp,akh,lprin)
c ----------------------------------------------------------------------
c     do k=1,nlev
c     source(k,lo3)=0.
c     enddo
c ----------------------------------------------------------------------

c  Modify #########################################################################
c Advective sources of heat and NOx (example)
c     goto 4444
      if(rnet(jtot).gt.0.) then
       if(timloc.gt.6..and.timloc.lt.9.) then
c       do k=2,28
c        if(iday.ne.5) then
c         t(k)=t(k)-1.0/3600.*deltim
c        else
c         t(k)=t(k)-2.0/3600.*deltim
c        endif
c       enddo
        do k=22,31
        vcp(k,lno2)=vcp(k,lno2)+3.75*1.e-9/3600.*deltim
        enddo
       elseif(timloc.gt.14..and.timloc.lt.16.) then
        do k=22,34
        vcp(k,lno2)=vcp(k,lno2)+3.75*1.e-9/3600.*deltim
        enddo
       else
        do k=22,33
        vcp(k,lno2)=vcp(k,lno2)+1.45*1.e-9/3600.*deltim
        enddo
       endif
      else            !night
       do k=22,26
       vcp(k,lno2)=vcp(k,lno2)+1.0*1.e-9/3600.*deltim
       enddo
      endif

c4444 continue
 
c  Turbulent transport of chemical species and water vapor 
c   newc includes loop over all RACM species (array vcp).
c ----------------------------------------------------------------------
      call newc(akh,vcp)
c     call newc(ajnn,vcp) !only for tests
c ----------------------------------------------------------------------
c  New temperature profile 
c ----------------------------------------------------------------------
      call newt(akh)
c ----------------------------------------------------------------------
c
c Photolysis frequencies above canopy (needs still improvement)
c (values presently supplied by subr. init and a simple dependence of  the
c  cosine of the zenith angle and current clouds (given by ratiod)

c photolysis frequencies in canopy >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

      do 10 k=1,nlev  !------------------- Level loop for chemistry
      lev=k

      t0=tstart
      t1=tstart+deltim

c      dtlast=0.
       dtlast=dtl2
       iitime=itime
       llev=lev

c Photolysis frequencies (preliminary)

      photoj( 1)=phot1( 3,lev)          !no2
      photoj( 2)=phot1( 1,lev)          !o3 -> o1d
      photoj( 3)=phot1( 2,lev)          !o3 -> o3p
      photoj( 4)=phot1( 6,lev)          !hono
      photoj( 5)=phot1( 7,lev)          !hno3
      photoj( 6)=phot1( 8,lev)          !ho2no2
      photoj( 7)=phot1( 4,lev)          !no3 -> no
      photoj( 8)=phot1( 5,lev)          !no3 -> no2 + o3p
      photoj( 9)=phot1( 9,lev)          !h2o2
      photoj(10)=phot1(11,lev)          !hcho -> h2 + co
      photoj(11)=phot1(10,lev)          !hcho -> 2 ho2 + co
      photoj(12)=phot1(12,lev)          !ald
      photoj(13)=phot1(18,lev)          !op1
      photoj(14)=phot1(13,lev)          !op2
      photoj(15)=phot1(19,lev)          !paa
      photoj(16)=phot1(14,lev)          !ket
      photoj(17)=phot1(15,lev)          !gly -> 0.13 hcho + 1.87 co
      photoj(18)=phot1(21,lev)          !gly -> 0.45 hcho + 1.55 co + 0.80 ho2
      photoj(19)=phot1(16,lev)          !mgly
      photoj(20)=phot1(17,lev)          !dcb
      photoj(21)=phot1(20,lev)          !onit
      photoj(22)=phot1(22,lev)          !macr
      photoj(23)=phot1(23,lev)          !hket


c Simple parameterization of photolysis frequencies.
c Preliminary !!!!!!!
c
c photolysis profile follows PAR profile
      if(lev.le.levhtr) then
      extf=facte(1)
      else
      if((lev-levhtr).le.jtot) extf=facte(lev-levhtr+1) 
      if(lev.gt.levcpy) extf=1.
      endif
 
c      extf=1. ! Test: no photolysis profile

c Convert to  1/s 
      do iph=1,23
      if(coszen.gt.0.) then
      photoj(iph)=photoj(iph)/60.*ratiod
      photoj(iph)=photoj(iph)*coszen*extf
      else
      photoj(iph)=0.0
      endif
      photout(iph,lev)=photoj(iph)
      enddo
c

      do j=1,nspec
c  species concentrations
      vc(j)=vcp(lev,j)
c  emivalue in 1/s , set to zero, emissions are handeled within newc
      emivalue(j)=0.0 
      enddo  

      tt=t(lev)
      pp=p(lev)


c     humidity in volume mixing ration of water vapor
c     s=qva(i,j,k)/psb(i,j)

c   Chemical transformation
       dum1=vc(lmacr)
c ----------------------------------------------------------------------
c     if(lev.ge.levcpy+3) then !uncomment if you want to switch off in-canopy reactions for test purposes 
                               ! ################################################################
      call racmh(t0,t1,tt,pp,vc,nspec,photoj,dtlast,lprin)
c     endif
c ----------------------------------------------------------------------
      dum2=vc(lmacr)-dum1
      if(lev.eq.levcpy+1) fmacr2=dum2/deltim*1e9

      if(lev.eq.1) then
       dtl=dmin1(deltim,dtlast)
      else
       dtl=dmin1(dtl,dtlast)
      endif

c       if(lev.eq.1) then
c       write(6,'(1x,3f10.2)') dtlast,dtl,dtl2                 
c       write(6,'(1x,a4,4x,d12.6)')species(33),vc(33)*1.e6
c       write(6,'(1x,a4,4x,d12.6)')species(36),vc(36)*1.e6
c       write(6,'(1x,a4,4x,d12.6)')species(47),vc(47)*1.e6
c       write(6,'(1x,a4,4x,d12.6)')species(52),vc(52)*1.e6
c       endif


      do jspec=1,nspec
      vcp(lev,jspec)=max(vc(jspec),0.0)
      enddo  

  10  continue    ! Ende level-Loop


c Fluxes at canopy top  (convert to ug/m^2/s) 
      fiso=-akh(levcpy)*
     &           (vcp(levcpy+1,liso)*1.e9-vcp(levcpy,liso)*1.e9)/
     &               (z(levcpy+1)-z(levcpy))*40./1000.*68.
      fapi=-akh(levcpy)*
     &       (vcp(levcpy+1,lapi)*1.e9-vcp(levcpy,lapi)*1.e9)/
     &               (z(levcpy+1)-z(levcpy))*40./1000.*136.
      flim=-akh(levcpy)*
     &     (vcp(levcpy+1,llim)*1.e9-vcp(levcpy,llim)*1.e9)/
     &               (z(levcpy+1)-z(levcpy))*40./1000.*136.
      fmacr=-akh(levcpy)*
     &      (vcp(levcpy+1,lmacr)*1.e9-vcp(levcpy,lmacr)*1.e9)/
     &               (z(levcpy+1)-z(levcpy))*40./1000.*70.

c Fluxes above canopy top, height depends on grid spacing and coice of izo
      izo=levcpy+3
      izu=izo-1
      fapi2=-akh(izu)*
     &       (vcp(izo,lapi)*1.e9-vcp(izu,lapi)*1.e9)/
     &               (z(izo)-z(izu))*40./1000.*136.
      fiso2=-akh(izu)*
     &       (vcp(izo,liso)*1.e9-vcp(izu,liso)*1.e9)/
     &               (z(izo)-z(izu))*40./1000.*68.
      flim2=-akh(izu)*
     &       (vcp(izo,llim)*1.e9-vcp(izu,llim)*1.e9)/
     &               (z(izo)-z(izu))*40./1000.*136.

      fmacr2=-akh(izu)*
     &       (vcp(izo,lmacr)*1.e9-vcp(izu,lmacr)*1.e9)/
     &               (z(izo)-z(izu))*40./1000.*70.

c
c New soil temperature and moisture
c ----------------------------------------------------------------------
      call erdbod
c ----------------------------------------------------------------------
c
      do 222 i=1,nsoil
      if (eta(i).lt.etamin) goto 223
      goto 224
 223  write(06,3900)i,eta(i)
 3900 format(1x,i5,e20.10,'!!!')
      eta(i)=etamin
 224  if(eta(i).ge.etamax) goto 225
      goto 222
 225  write(06,3900)i,eta(i)
      eta(i)=etamax
 222  continue
c
c Boundary condition for temperature and humidity
c
      p1b=p21(2)*h(2)
      p1a=0.01*vcp(1,lh2o)*p(1)
      xla=(xlam(1)+xlam(2))*.5
      fnet=-rnet(1)
      qvap1=vcp(1,lh2o)*0.622  !approximately
      qvap2=vcp(2,lh2o)*0.622
      patm=p(1)
c
c New surface temperature and moisture
c ----------------------------------------------------------------------
      call grenzn(fnet,patm,p21(1),h(1),rhoair(1),psi(1),
     &p21t(1),psieta(1),xl11(1),xl11(2),xl22(1),xl22(2),psit(1),
     &d1t(1),d1t(2),d1eta(1),d1eta(2),d2t(1),d2t(2),d2eta(1),d2eta(2),
     &xl210(1),xlam(1),xlam(2),akh(1),z(1),z(2),zs(1),zs(2),
     &theta(1),theta(2),t(1),vcp1,qvap2,
     &temp(1),temp(2),eta(1),eta(2),
     &qgrnd,qsatg,afl1,aflh,bflh,bfl1,bfl2,deltim,tausum,jtime,
     &p1a,p1b)
c ----------------------------------------------------------------------
c
      tsurf=temp(1)
      tsfc=tsurf-273.15

      if(afl1.ge.0.0) vsum=vsum+afl1*deltim
      if(afl1.lt.0.0) tsum=tsum-afl1*deltim
      vcp(1,lh2o)=vcp1              ! XXXXXXXX
c
      timloc=t1/3600.
c
c  Printout
      if(lprin) then
c ----------------------------------------------------------------------
      call print(timloc,vcp,emiss,wind,photout,akh,iday)
c-------------------------------------------------------------------------
      if(timloc.ge.24.) then
      ptime=ptime-24.
      endif
      ptime=ptime+dpt-1.e-11
      endif

      tstart=tstart+deltim
      dtl2= dtl

 100  continue    ! End of time loop

      stop 9999
      end

c ****************************************************************

      block data
c
      parameter (nlevel=40,nsoil=15)
      implicit double precision (a-h,o-z)
      common/imp/alpha,beta
      common/konst/pi,p0,aaa,bbb,ccc,ddd,ak,r0,r1,grav,cp,xl,tconv

c RACM species
      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP


c       parameters for the crank-nicolson scheme (alpha+beta=2.)
      data alpha/2.0/,beta/0.0/
c       Verschiedenes
      data pi/3.1415927/,p0/1000.00/,aaa/1.809567/,
     & bbb/17.269388/,ccc/4717.3061/,ddd/35.86/,
     &tconv/273.15/,ak/0.4/,grav/9.81/
      data r0/287.05/r1/461.51/,cp/1004.4/,xl/2499000./

      data 
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP
     &  /   1  ,   2  ,   3  ,    4 ,   5  ,   6  ,   7  ,   8
     &    , 9  ,  10  ,  11  ,  12  ,  13  ,  14  ,  15  ,  16
     &    ,17  ,  18  ,  19  ,  20  ,  21  ,  22  ,  23  ,  24
     &    ,25  ,  26  ,  27  ,  28  ,  29  ,  30  ,  31  ,  32
     &    ,33  ,  34  ,  35  ,  36  ,  37  ,  38  ,  39  ,  40
     &    ,41  ,  42  ,  43  ,  44  ,  45  ,  46  ,  47  ,  48
     &    ,49  ,  50  ,  51  ,  52  ,  53  ,  54  ,  55  ,  56
     &    ,57  ,  58  ,  59  ,  60  ,  61  ,  62  ,  63  ,  64
     &    ,65  ,  66  ,  67  ,  68  ,  69  ,  70  ,  71  ,  72
     &    ,73  ,  74  ,  75  ,  76  ,  77/

      end


c ---------------------------------------------------------------------


      subroutine init(vcp,phot1,emiss,wind,rlat,clump)
c Initial profiles of all prognostic variables and many parameters

      implicit double precision (a-h,o-z)
      parameter (nlev=40,nsoil=15)    ! number of levels  
      parameter (nspec=77, nrect=237)
      parameter(maxemi=nspec) ! maximal number of emissions
      parameter(maxrect=500)
      parameter(maxphr=100, maxphpt=100)

      double precision emivalue(maxemi)
      dimension vcp(nlev,nspec), phot1(23,nlev),
     &wind(nlev)
      dimension gr(99)

      common/konst/pii,p0,aaa,bbb,ccc,ddd,ak,r0,r1,grav,cp,xl,tconv
      common/astron/eqtm,decl,sindec,cosdec,decmax,sinlat,coslat,
     1 tanlat,dlong
      common/timpar/timloc,deltim,month,jday,iyear,icumdy
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/cpy2/hsoil,hcpys,evtot,etotw(99),contot(99),scond(10,99)
     1,ecpys,cphstr,cpestr,wcpys,evsmic,ihrwet(99)
      common/deg/sunazm,viewzn(99),viewaz(99),nozenv,noazmv
     & ,xintv(20,90)
      common /emissions/ emivalue
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/grid/ del,zmin1,zmin2,a0(nlev),b0(nlev),c0(nlev)
      common/inter1/wtp(99),frwet(99),frwtmx,pint(99),pilast(99)
     1,pint1(99),twater
      common/misc1/pi,pid180,pid2,sigma,iwrite(9,99),kmax
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/misc6/xint,xintz(99),nalpha,ispher,nxintz
      common/photo2/ox,cair,rastom,cucond,d1,bkv,facj,rxcham,rsfac
     &             ,znon,conmin,ic3c4
      common /rad1/emis,emisol,rsoil(3),rleaf(3),tleaf(3),aleaf(3)
     &,expdif(99),rlayr(3,30),tlayr(3,30)
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common /rad3/radabv(3),fbeam1(3),coszen,zenang
     &,ratiod,ration,ratio
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/resis2/radn,anstom,rcut20,rsmin,trsopt,trsmin,trsmax,rsm
     1,rsexp,psi1,psi2
      common/root1/froot(99),resrot(99),rootsm,psixy,psitop,rroot
     1,rootup(99),cpytr,psisum,aroot
      common/soil1/zs(nsoil),sl,dels
      common/soil4/pe,bx,bd,aks,an,ws,asoil,bsoil,csoil,dsoil,esoil
      common/feld/ eta(nsoil),psi(nsoil),psit(nsoil),
     &temp(nsoil),xk(nsoil),psieta(nsoil),
     &psitet(nsoil),xlam(nsoil),axa(nsoil),bxb(nsoil),
     &cxc(nsoil),dxd(nsoil),d1t(nsoil),
     &d2t(nsoil),d1eta(nsoil),d2eta(nsoil),
     &xl11(nsoil),xl22(nsoil),rho0(nsoil),
     &rho1(nsoil),rho22(nsoil),xl210(nsoil),
     &p21(nsoil),p21t(nsoil),h(nsoil),datm(nsoil)
      common/stuetzw/sep(18),sp(18),sek(17),sk(17),
     &sept(10),spt(10),sel(10),sxl(10),
     &cpsi(17,3),ck(16,3),cpsit(9,3),clam(9,3),
     &isp,isk,ispt,isl
      common/intf/ qgrnd,qsatg,tausum,tsum,vsum,tsurf,patm,
     &fnet,gdown,gfnet,afl1,aflh,bfl1,bfl2,bflh
      common/bodk/ etamin,etamax,xkr,por,trefp,trefk,cp3,rho3,
     &feldka,albdry,albwet

      common/stratpar/ stable,vgday,vgn,zrday,zrn,alphaday,alphan
      logical stable

      common /treespec/ isort
      common /inputr/ inrad,iwpm2
      common/efact/ efiso,efterp,efovoc,reflai,
     & splitterp(3),splitovoc(9)
      common/efactneu/ efiso2(2,15),                   !Isopren
     & efapi(2,15),efbpi(2,15),efcam(2,15),eftri(2,15),  !Monoterpene
     & efsab(2,15),efmyr(2,15),efbph(2,15),eflim(2,15),
     & ef18c(2,15),efd3c(2,15),efpci(2,15),efaty(2,15),
     & efaca(2,15),efbca(2,15),efoci(2,15),
     & sovoce(9)

      dimension sterpin(3),sovocin(9)


      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP



c--------------------------------------------------------------
c           1      2      3       4     5      6      7      8
c          ACO3   ADDC   ADDT   ADDX   ALD    API    APIP   CH4 
c           9     10     11     12     13     14     15     16
c          CO     CO2    CSL    CSLP   DCB    DIEN   ETE    ETEP
c          17     18     19     20     21     22     23     24
c          ETH    ETHP   GLY    H2     H2O    H2O2   HC3    HC3P
c          25     26     27     28     29     30     31     32
c          HC5    HC5P   HC8    HC8P   HCHO   HKET   HNO3   HNO4
c          33     34     35     36     37     38     39     40
c          HO     HO2    HONO   ISO    ISOP   KET    KETP   LIM 
c          41     42     43     44     45     46     47     48
c          LIMP   MACR   MGLY   MO2    N2     N2O5   NO     NO2 
c          49     50     51     52     53     54     55     56
c          NO3    O1D    O2     O3     O3P    OLI    OLIP   OLND
c          57     58     59     60     61     62     63     64
c          OLNN   OLT    OLTP   ONIT   OP1    OP2    ORA1   ORA2
c          65     66     67     68     69     70     71     72
c          PAA    PAN    PHO    SO2    SULF   TCO3   TOL    TOLP
c          73     74     75     76     77
c          TPAN   UDD    XO2    XYL    XYLP
c--------------------------------------------------------------
c

      pi=4.*atan(1.)
      pid180=pi/180.
      pid2=pi*0.5
      sigma=5.67e-08
      rgas=8.314
      decmax=sin(23.44*pid180)

c Read parameters from file inputn
      open(unit=20,file='inputn',status='unknown')
c
      read(20,*) jday,iyear                      ! ##### Start day and year
      icumdy=jday
      read(20,*) xlat,xlong,stdlng               ! ##### geographical location
      read(20,*) isort                           ! ##### tree type (see plant.f)
      read(20,*) hcpy,htr,levhtr,levcpy,del      ! ##### canopy height, trunk space height, top level of trunk spece, top level of canopy, parameter for grid spacing
      read(20,*) tlai,sizelf                     ! ##### total projected LAI, leaf size
      read(20,*) stable
      read(20,*) vgday,vgn                       ! ##### geostrophic wind (day, night) 
      read(20,*) zrday,zrn,alphaday,alphan       ! ##### roughness height (day, night), wind profile parameters (day, night)
      read(20,*) itot,jmax,jmin,dfmin,clump,kmax 
      read(20,*) inrad, iwpm2                     ! ##### read incoming solar radation (iinrad=1), input is in W/m**2 (iwpm2=1) or micromoles per (m2 seconds) (iwpm2=0) 
      read(20,*) ratiod,ration                   ! modifiers for incoming radiation (only important when incoming radiation is not read from file (i.e. inrad=0)
      read(20,*) emis,emisol, factir
      read(20,*) (rsoil(m),m=1,kmax),(rleaf(m),m=1,kmax), !reflectivities, transmissions
     1(tleaf(m),m=1,kmax)
      nxintz=9

c     write(6,*) xlat,xlong,stdlng
c     write(6,*) isort
c     write(6,*) hcpy,htr,levhtr,levcpy,del
c     write(6,*) tlai,sizelf
c     write(6,*) stable
c     write(6,*) vgday,vgn
c     write(6,*) zrday,zrn,alphaday,alphan
c     write(6,*) itot,jmax,jmin,dfmin,clump,kmax

      write(06,'(/,"     Canopy between ",f4.1," and ",f4.1," m")') 
     &htr,hcpy
      write(06,'(/,"     Canopy levels ",i3," to ",i3)')
     &levhtr,levcpy
      write(06,'("     Total LAI=",f4.1,/)') tlai
      write(06,'("     vgday,vgnight",2f4.1)') vgday,vgn
      write(06,'("     zrday,zrn,alphaday,alphan",4f5.2)') 
     & zrday,zrn,alphaday,alphan

c Canopy strcture
c ----------------------------------------------------------------
      call cpstruct(imunu,gr)
c ----------------------------------------------------------------
c row and plant spacings
      read(20,*)rowspc,plspc,dmax                 ! ##### row and plant spacings
c******************* plant  *************************************************
c
c  this is where stom resis, photosynthesis, resp. etc. parameters
c    are read in, they are to remain fixed.
c  read in rs vs light
777   read(20,*)rcut20,rsmin,anstom,radn          ! ##### Cuticula resistance, min. stomata resistance, 
c  read rs vs temp
778   read(20,*)trsopt,trsmax,trsmin,rsexp,rsm    ! #####
c  read rs vs leaf psi
780   read(20,*)psi1,psi2,cidcai                  ! #####
c  cidcai  if < 0 then use cidca in code else set cidca=cidcai
c  convert potentials from bars to j/kg
      psi1=psi1*100.
      psi2=psi2*100.
c
c  additions to subr inplant for leaf p.s. by farquahr eqs.
      read(20,*)ic3c4,cair,rastom,cucond,d1,bkv,conmin,rxcham
c  input root resis in m4 kg-1 s-1 (corn=3.e6) assume .6 of plant
c    resistance is in root
      read(20,*)rroot
      read(20,*)aroot


c  rxcham blr of one side of leaf in chamber used to meas p.s. (s/m)
c  rastom ratio of stom resis on top and bot of leaf.
c  rsfac  factor to adjust blr by for stom cond or resis ratio(li-6200)
      rsfac=(rastom**2+1.)/(rastom+1.)**2
c  cucond cuticular cond to water (mol/m2/s)
c  d1    vpd for start of stom closure (mbar)
c  d2    vpd for end of stom closure (mbar)
c  bkv   parameter for vpd response of stomata
c

      hpsi=1.
      psitp1=psi1
      psitop=0.


      dlong=(stdlng-xlong)/15.
      sinlat=sin(xlat*pid180)
      coslat=cos(xlat*pid180)
      tanlat=sinlat/coslat
      rlat=xlat*pi/180.

c Solar daclination
c ---------------------------------------------------------------
      call declin 
c ---------------------------------------------------------------
      itotp1=itot+1

c  Height levels 
c ############################################################################
c  For changing the height levels modiy the following variable in file inputn:
c  canopy height 'hcpy', trunk height 'htr', level of canopy top 'levcpy' and 
c  top of trunk space 'levhtr'  
c  Select 'del' to get the desired model domain height (note that not
c  all combinations of hcpy, htr, levcpy, levhtr, and del are reasonable and possible)

      tt=exp((levhtr-1)*del)
      hh=exp((levcpy-1)*del)
      xx=((levcpy-1)*del)/((levhtr-1)*del)
      zmin1=(hcpy-htr*xx)/(hh+xx-tt*xx-1)
      zmin2=(zmin1+htr-zmin1*tt)/((levhtr-1)*del)
      do k=1,nlev
      z(k)=zmin1*exp((k-1)*del)+zmin2*(k-1)*del-zmin1
      enddo

      zf(nlev)=z(nlev)+0.5*(z(nlev)-z(nlev-1))
      do k=1,nlev-1
      zf(k)=0.5*(z(k+1)+z(k))
      if(k.gt.1) dzf(k)=zf(k)-zf(k-1)
      dz(k)=z(k+1)-z(k)
      enddo
      dzf(1)=zf(1)
      dzf(nlev)=dzf(nlev-1)
      dz(nlev)=dz(nlev-1)

      jtot=levcpy-levhtr+1

c Soil levels >>>>>>>>>>>>>> muss noch verbessert werden
      zs(1)=-0.05
      zs(2)=-0.1
      zs(3)=-0.2
      zs(4)=-0.4
      zs(5)=-0.7
      zs(6)=-1.

c Secify leaf area index per layer
c Modify #############################################################
      sumd=0.
      do ii=levhtr+1,levcpy
      jj=ii-levhtr
c     df(jj)=sqrt(float(ii-levhtr))
c     df(jj)= 1. !    (float(ii-levhtr))
c Specify according to your in-canopy layers ###########################
c number of specified layers must be equal levcpy-levhtr-1 #############
      df(1)=0.15
      df(2)=0.08
      df(3)=0.1
      df(4)=0.1
      df(5)=0.3
      df(6)=0.2
      df(7)=0.3
      df(8)=0.4
      df(9)=1.2
      df(10)=0.8

      sumd=sumd+df(jj)
      enddo
      do ii=1,levcpy-levhtr
      df(ii)=tlai/sumd*df(ii)
       write(06,'(" df=",i3,f7.3)') ii,df(ii)
      enddo
      
c
c Initialize atmospheric variables #######################################
c
      if(nlev.gt.99) 
     & write(06,'("Canopy radiation model permits only 99 layers,",
     & " but nlev is ",i4)') nlev 

c wind
      vg= vgn
      zrough=zrn
      ustara=vg/30. 
      alphab=6.95 ! Baldocchi, 1988, Atmos. Env. (results in too small values for wind speed in trunk space)
      alphab=1.2!  ########   
      alphab=alphan

c Wind profile
c ----------------------------------------------------------------------
      call wprofil(vg,alphab,wind)
c ----------------------------------------------------------------------

      do 10 lev=1,nlev

c pressure
      pres=1013.25*100.  ! Surface presssure, pascal
      p(lev)=pres*((1.0-z(lev)/44308.0)**(1.0/0.19023))

c Temperature ! Modify ##################################################
       t(lev)=299.00 -z(lev)*.0080 !0055
c      if(z(lev).gt.1500.) 
c    &  t(lev)=(300.00 -1500.*.005)- (z(lev)-1500.)*.002
c---------------
c      if(z(lev).lt.28.) t(lev)=290.00 ! +z(lev)*.20 

c      t(lev)=theta(lev)/((100000.0/p(lev))** .286)
       theta(lev)= t(lev)*((100000.0/p(lev))** .286)
      dtleaf=0.


c water vapor (volume mixing ratio [ppmv*10**6], corresponding
c                                          to mole fraction)
c identify species no. of H2O
c     jh2o=specnr(nspec,'H2O ')

      do i=1,nspec
      vcp(lev,i)=0.
      enddo

c Rel. humidity  ! Modify ##################################################
      relh(lev)=.4
      if(z(lev).lt.500.) 
     &relh(lev)=0.80  -z(lev)*.4/500.          
      p1=relh(lev)*610.7*exp(17.1536*(t(lev)-273.15)
     & /(t(lev)-38.33))
      vcp(lev,lh2o)=p1/p(lev) 

c Chemical compounds (volume mixing ratio [ppmv*10**6], corresponding
c                                          to mole fraction)
c Modify ##########################################################
       xx=0.01
      vcp(lev,lch4)=1.7e-6                  !    ch4
      vcp(lev,lco)=100.0e-9                   !    co
      vcp(lev,lco2)=0.000350                 !    co2
      vcp(lev,lh2)=0.5e-6                   !    h2
      vcp(lev,lh2o2)=1.0e-9 *exp(-z(lev)*0.0001)  !    h2o2
      vcp(lev,lh2o2)=0.5e-9 *exp(-z(lev)*0.0001)  !    h2o2
      vcp(lev,lhcho)=1.0e-9*exp(-z(lev)*0.01)   !  hcho   exp(-z(lev)*xx)
      vcp(lev,lhno3)=0.1e-9                  !    hno3
      vcp(lev,lhno3)=0.1e-9*exp(-z(lev)*0.01) !    hno3
      vcp(lev,lapi)=0.1e-9*exp(-z(lev)*xx)     !    api
      vcp(lev,llim)=0.001e-9*exp(-z(lev)*xx)   !    lim
      vcp(lev,llim)=0.1e-9*exp(-z(lev)*xx)   !    lim
      vcp(lev,liso)=0.2e-9*exp(-z(lev)*xx)     !    api
      vcp(lev,liso)=0.1e-9*exp(-z(lev)*xx)   !    iso
      vcp(lev,liso)=5.0e-9*exp(-z(lev)*xx)   !    iso
c     if(lev.lt.20) vcp(lev,liso)=0.8e-9
      vcp(lev,lmacr)=4.30e-9*exp(-z(lev)*xx)   !    macr

      vcp(lev,ln2)=0.781                   !    n2
      vcp(lev,lno)=1.0e-9 *exp(-z(lev)*0.001)   !    no
      vcp(lev,lno2)= 3.0e-9*exp(-z(lev)*0.001)  !    no2
      if(z(lev).gt.300.) vcp(lev,lno2)=2.0e-9
      if(z(lev).gt.600.) vcp(lev,lno2)=0.2e-9
      vcp(lev,lo2)=0.209                   !    o2
      vcp(lev,lo3)= 25.0e-9  +z(lev)*.10 e-9    !o3
      if(vcp(lev,lo3).gt.60.e-9) vcp(lev,lo3)=60.e-9
      if(z(lev).gt.1150.) vcp(lev,lo3)=60.e-9

      vcp(lev,leth)=1.5e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lete)=0.02e-9  *.1  *exp(-z(lev)*xx)  
      vcp(lev,lhc3)=4.3e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lhc5)=2.1e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lhc8)=0.3e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lald)=0.6e-9 *exp(-z(lev)*0.001)  
      vcp(lev,lket)=4.2e-9 *exp(-z(lev)*0.0001)  
c
      vcp(lev,ltol)=0.6e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lxyl)=2.0e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lolt)=0.03e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,loli)=0.3e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lpan)=0.3e-9 *.1   *exp(-z(lev)*xx)  
      vcp(lev,lora1)=0.3e-9 *.1   *exp(-z(lev)*xx)   
      vcp(lev,lora2)=0.3e-9 *.1   *exp(-z(lev)*xx)   
      vcp(lev,lora2)=0.03e-9 *.1   *exp(-z(lev)*xx)  

c Photolysis frequencies
c Constant with height! Will be corrected for current zenith angle and
c in-cammopy extinction with a very simple paramerization in the main program
c before calling the chemistry routine.

c     time units for rate constants : 1/min Values for zenith angle=0
      phot1( 3,lev)=0.542199            !no2
      phot1( 1,lev)=0.184632e-02        !o3 -> o1d
      phot1( 2,lev)=0.288514e-01        !o3 -> o3p
      phot1( 6,lev)=0.119043            !hono
      phot1( 7,lev)=0.412661e-04        !hno3
      phot1( 8,lev)=0.279748e-03        !ho2no2
      phot1( 4,lev)=1.56391             !no3 -> no
      phot1( 5,lev)=12.5313             !no3 -> no2 + o3p
      phot1( 9,lev)=0.477564e-03        !h2o2
      phot1(11,lev)=0.267928e-02        !hcho -> h2 + co
      phot1(10,lev)=0.182312e-02        !hcho -> 2 ho2 + co
      phot1(12,lev)=0.335393e-03        !ald
      phot1(18,lev)=0.325182e-03        !op1
      phot1(13,lev)=0.325182e-03        !op2
      phot1(19,lev)=0.126502e-03        !paa
      phot1(14,lev)=0.593159e-04        !ket
      phot1(15,lev)=0.396512e-02        !gly -> 0.13 hcho + 1.87 co
      phot1(21,lev)=0.158140e-02        !gly -> 0.45 hcho + 1.55 co + 0.80 ho2
      phot1(16,lev)=0.693949e-02        !mgly
      phot1(17,lev)=0.323318e-01        !dcb
      phot1(20,lev)=0.188569e-03        !onit
      phot1(22,lev)=0.101917e-03        !macr
      phot1(23,lev)=0.593159e-04        !hket

  10  continue
      
c First guess for leaf and soil temperature
      do i=1,itotp1
      do j=2,jtot
      templf(i,j)=t(j+levhtr)-273.15+dtleaf !templf bezieht sich zwar auf
		 ! die Schicht und nicht das Niveau, ist aber hier egal
      enddo
      enddo


c  contot(j) is accumulated condensate on leaf in layer j
c  frwet: fraction of wet leaves
      do ii=1,levcpy-levhtr
      pint1(ii)=0.    ! no intercepted rain
      contot(ii)=0.
      frwet(ii)=0.
      enddo
      twater=t(nlev-1)

c Boden ---------------------------------------------------------------
c
      tausum=0.
      vsum=0.
      tsum=0.

c        calculate soil grids
c
      sl=0.005
      dels=1.0
      zs(1)=-1.0e-04
      eps=0.0
      do 30 i=2,nsoil
      eps=eps+dels
   30 zs(i)=-sl*(eps**2)

      read(20,*)bd,sandfc,siltfc,clayfc  !preliminary soil properties
      read(20,*) eta                     ! ######### initial soil moisture
      read(20,*) temp                    ! ######### initial soil temperature
   

      adum=sandfc*alog(1.025)+siltfc*alog(.026)+clayfc*alog(.001)
      bdum=(sandfc*(alog(1.025))**2+siltfc*(alog(.026))**2+clayfc*(alog(
     &.001))**2-adum*adum)**.5
      dgeom=exp(adum)
      sgeom=exp(bdum)
c     compute air entry potential, pe=j/kg
      pes=-.5*dgeom**(-.5)
      bx=-2.*pes+.2*sgeom
      pe=pes*(bd/1.3)**(.67*bx)
      psolid=bd/2.65
      ws=1.-psolid  ! Wird moeglicherweise nur fuer psi gebraucht


c  calc frac of root system extracting water at each node
      froot(1)=0.
      resrot(1)=0.
      rootsm=0.
      do 700 jz=2,nsoil-1    
      zm=0.5*(z(jz-1)+z(jz))
      zmm=0.5*(z(jz)+z(jz+1))
      froot(jz)=exp(-aroot*zm)-exp(-aroot*zmm)
      resrot(jz)=rroot/froot(jz)
 700  rootsm=rootsm+1./resrot(jz)
      froot(nsoil)=froot(nsoil-1)
      resrot(nsoil)=resrot(nsoil-1)


      tsfc=temp(1)-273.15
      tsurf=temp(1)


c read emission factors for isoprene, monoterpenes and ovoc
c in 10-6 ppm/s bezogen auf 30C und 1000umol Photonen/m**2/s
c Emissionsfaktor von Guenther wurde durch 0.7 dividiert,
c    um Wert auf Blattebene zu erhalten (24.2.98)

      do iguenth=1,2
      read(20,*) reflaiin      
      read(20,*) efisoin,efterpin,efovocin     ! ##### Emission factors for plant type 1 and 2
      read(20,*) sterpin                       ! VOC split for TERP
      read(20,*) sovocin                       ! VOC split for OVOC
      if(iguenth.eq.isort) then
      reflai=reflaiin
      efiso=efisoin
      efterp=efterpin
      efovoc=efovocin
      do ist=1,3
      splitterp(ist)=sterpin(ist)
      enddo
      do io=1,9
      splitovoc(io)=sovocin(io) 
      enddo
      endif
      enddo

      close(20)
c
c      read soil properties
c
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        open(unit=7,file='./fd2dat/lehmst',  ! ######### adapt path if necessary
     &  status='unknown')
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c
      read(7,4999) ibt
      read(7,5000) isp,isk,ispt,isl
      read(7,5001) (sep(i),i=1,isp)
      read(7,5001) (sp(i),i=1,isp)
      read(7,5001) (sek(i),i=1,isk)
      read(7,5001) (sk(i),i=1,isk)
      read(7,5001) (sept(i),i=1,ispt)
      read(7,5001) (spt(i),i=1,ispt)
      read(7,5001) (sel(i),i=1,isl)
      read(7,5001) (sxl(i),i=1,isl)
      read(7,7510) por,feldka,albdry,albwet,etamin
      read(7,7870) xkr,trefp,trefk,cp3,rho3
        close(7)
 7510 format(5f12.3)
 7870 format(5f10.3)
c
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        open(unit=8,file='./fd2dat/lehmko',  ! ######### adapt path
     &  status='unknown')
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      read(8,4999) ibt
      do 515 i=1,isp-1
 515  read(8,5222) cpsi(i,1),cpsi(i,2),cpsi(i,3)
      do 516 i=1,isk-1
 516  read(8,5222) ck(i,1),ck(i,2),ck(i,3)
      do 517 i=1,ispt-1
 517  read(8,5222) cpsit(i,1),cpsit(i,2),cpsit(i,3)
      do 518 i=1,isl-1
 518  read(8,5222) clam(i,1),clam(i,2),clam(i,3)
        close(8)
 4999 format(a4)
 5222 format(3e24.16)
 5000 format(6i3)
 5001 format(6e10.3)
c
      etamax=por-por/30.
      patm=p(1)
      tsurf=temp(1)
      call icsevu(sep,sp,isp,cpsi,isp-1,eta(1),psianf,1,ier)
      psianf=-10.**psianf
      ha=exp(psianf/(r1*tsurf))
      e=aaa+(bbb*tsurf-ccc)/(tsurf-ddd)
      esat=exp(e)
      qgrnd=.622*esat*ha/(p(1)-.378*esat*ha)


      return
      end
