      subroutine racmh(t0,t1,tt,pp,vc,nspec,photoj,DTLAST,lprin)
      IMPLICIT double precision (A-H,O-Z)
      SAVE
C 
C----------------------------------------------------------------------
C     RACM chemistry (Stockwell et al., 1997) with Hertel solver
c     W.R. Stockwelli (Chemistry), M. Karl (Hertel solver), 1998
C----------------------------------------------------------------------
C

C 237 reactions, 23 photolysis reactions, 214 thermal reactions,
C 191 MAXTIMES photolysis time points, initial values for max number 74
C  77 species ,  emission predicted for max number 76 (see DATA IEMIT)
C  72 emission time points, 76 max number of emissioned species (LEMIN)
C  25 emissioned species(LEMIT), 9 dry deposition species
C     LEMIN=LPRED=LPRIN!
 
      PARAMETER (NREAC=237,NREACJ=23,NREACK=214)
      PARAMETER (NUMSPEC=77,MAXTIMES=191)
      PARAMETER (LSPEC = 77, LPRED = 76) 
      PARAMETER ( LEMIN = 76, LTIME = 72) 
      PARAMETER ( LEMIT = 25, LDRY = 9 )

      logical lprin
      dimension photoj(NREACJ)
      dimension vc(numspec)
C
C----------------------------------------------------------------------
C  COMMONN
C----------------------------------------------------------------------
C
      COMMON /DYNAMICS/ IEMIT(LEMIT),IDRY(LDRY)
      COMMON /WSTOCK/ RJI(NREACJ), RKI(NREACK), P, TEMP, YC(LSPEC),
     &                CRJ(NREACJ), CRK(NREACK)

      COMMON /MARK/ ISTEP0, IOUT, XT(1800), VCOUT(1800,LSPEC)
      COMMON /PRODUCT/ PRODSI(LPRED)
      COMMON /TIMEA/DTC, TIMENOW, INITVALS(NUMSPEC), TIMEMAX
      double precision INITVALS

C declare all species including the atmospheric constant O2,N2,CO2
c and also H2O
    
      COMMON /CHPS3D/ LACO3, LADDC, LADDT, LADDX, LALD , LAPI,
     &                LAPIP, LCH4 , LCO  , LCO2 , LCSL , LCSLP,
     &                LDCB , LDIEN, LETE , LETEP, LETH , LETHP,
     &                LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &                LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET,
     &                LHNO3, LHNO4, LHO  , LHO2 , LHONO, LISO ,
     &                LISOP, LKET , LKETP, LLIM , LLIMP, LMACR,
     &                LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2 ,
     &                LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI ,
     &                LOLIP, LOLND, LOLNN, LOLT , LOLTP, LONIT,
     &                LOP1 , LOP2 , LORA1, LORA2, LPAA , LPAN ,
     &                LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &                LTPAN, LUDD , LXO2 , LXYL , LXYLP
      COMMON /CHNM3D/ SPNAM(LSPEC)
      CHARACTER*6     SPNAM
      COMMON /EMIT_DATA/ EMIT(LEMIN,LTIME)
      COMMON /DEPO/ VDAY(LDRY), VNIGHT(LDRY),
     &              DRY_JAC(LPRED), DRY_DEPTH
C ***************************************************************************

      PARAMETER ( MAXSTEPS = 35000, LSC = 6 )
      PARAMETER (LEBI = LSPEC - 15)
C  LEBI= number of not provisorial species
      PARAMETER ( IG1 = 4, IG2 = 4)
C
      DIMENSION G1(IG1), G2(IG2), G10(IG1), G20(IG2), YC0(LSPEC)
      DIMENSION YCP(LSPEC), EPROD(LSPEC), ELOSS(LSPEC), IEBI(LEBI)
      DIMENSION RTOL(LSPEC)
      DIMENSION LDUM(LSPEC)
      EQUIVALENCE(LACO3,LDUM(1))
C
C FOR OUTPUTING NUMBERS OF ITERATION
C
      DIMENSION ITER_NOX(MAXSTEPS), ITER_HOX(MAXSTEPS),
     &          ITER_EULER(MAXSTEPS)
      LOGICAL ISTOP
C
      INCLUDE "a_data1.com"
c
      DATA EPSLON / 1.0E-30 /
C
      DATA IEBI/  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
     &           15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28,
     &           29, 30, 31, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45,
     &           51, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65,
     &           67, 68, 69, 71, 72, 74, 75, 76, 77/
C
C NOT IN IEBI: ACO3 , HNO4,HO  ,HO2 ,HONO, N2O5,
C              NO  ,NO2 ,NO3 ,O1D ,O3  ,O3P ,PAN ,TCO3 ,TPAN
C RTOL used like Hertel proposed in his paper
      DATA RTOL/ 5.0E-4,  5.0E-4,  5.0E-4, 5.0E-4,  5.0E-4, 5.0E-4, !6
     &           5.0E-4,  1.0E-3,  1.0E-3, 1.0E-3,  5.0E-4, 5.0E-4, !12
     &           5.0E-4,  5.0E-3,  5.0E-3, 5.0E-3,  5.0E-4, 5.0E-3, !18
     &           5.0E-4,  1.0E-3,  1.0E-3, 5.0E-5,  5.0E-4, 5.0E-3, !24
     &           5.0E-4,  5.0E-4,  5.0E-4, 5.0E-4,  5.0E-4, 5.0E-4, !30
     &           1.0E+0,  5.0E-3,  5.0E-3, 5.0E-3,  5.0E-3, 5.0E-4, !36
     &           5.0E-4,  5.0E-4,  5.0E-4, 5.0E-4,  5.0E-4, 5.0E-4, !42
     &           5.0E-4,  5.0E-4,  1.0E-3, 1.0E+0,  5.0E-4, 5.0E-4, !48
     &           1.0E-3,  1.0E+0,  1.0E+0, 5.0E-4,  1.0E+0, 5.0E-4, !54
     &           5.0E-4,  5.0E-4,  5.0E-4, 5.0E-4,  5.0E-4, 5.0E-4, !60
     &           1.0E+0,  1.0E+0,  5.0E-4, 5.0E-4,  5.0E-4, 5.0E-4, !66
     &           1.0E+0,  1.0E-3,  1.0E+0, 5.0E-4,  5.0E-4, 5.0E-4, !72
     &           5.0E-4,  5.0E-4,  1.0E-3, 5.0E-4,  5.0E-4/         !77

c     DATA RTOL/ 1.0E+0,  1.0E+0,  1.0E+0, 1.0E+0,  1.0E-2, 1.0E-2, !6
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E+0,  1.0E-2, 1.0E+0, !12
c    &           1.0E+0,  1.0E-2,  1.0E-2, 1.0E+0,  1.0E-2, 1.0E+0, !18
c    &           1.0E-2,  1.0E+0,  1.0E+0, 1.0E-2,  1.0E-2, 1.0E+0, !24
c    &           1.0E-2,  1.0E+0,  1.0E-2, 1.0E+0,  1.0E-2, 1.0E-2, !30
c    &           1.0E-2,  1.0E+0,  1.0E+0, 1.0E+0,  1.0E+0, 1.0E-2, !36
c    &           1.0E+0,  1.0E-2,  1.0E+0, 1.0E-2,  1.0E+0, 1.0E-2, !42
c    &           1.0E-2,  1.0E+0,  1.0E+0, 1.0E+0,  1.0E-3, 1.0E-3, !48
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E-2,  1.0E-2, 1.0E-2, !54
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E-2,  1.0E+0, 1.0E-2, !60
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E-2,  1.0E+0, 1.0E+0, !66
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E+0,  1.0E+0, 1.0E+0, !72
c    &           1.0E+0,  1.0E+0,  1.0E+0, 1.0E-2,  1.0E+0/         !77
 

C
C               '(ACO3)','(ADDC)','(ADDT)','(ADDX)','(ALD )','(API )',
C               '(APIP)','(CH4 )','(CO  )','(CO2 )','(CSL )','(CSLP)',
C               '(DCB )','(DIEN)','(ETE )','(ETEP)','(ETH )','(ETHP)',
C               '(GLY )','(H2  )','(H2O )','(H2O2)','(HC3 )','(HC3P)',
C               '(HC5 )','(HC5P)','(HC8 )','(HC8P)','(HCHO)','(HKET)',
C               '(HNO3)','(HNO4)','(HO  )','(HO2 )','(HONO)','(ISO )',
C               '(ISOP)','(KET )','(KETP)','(LIM )','(LIMP)','(MACR)',
C               '(MGLY)','(MO2 )','(N2  )','(N2O5)','(NO  )','(NO2 )',
C               '(NO3 )','(O1D )','(O2  )','(O3  )','(O3P )','(OLI )',
C               '(OLIP)','(OLND)','(OLNN)','(OLT )','(OLTP)','(ONIT)',
C               '(OP1 )','(OP2 )','(ORA1)','(ORA2)','(PAA )','(PAN )',
C               '(PHO )','(SO2 )','(SULF)','(TCO3)','(TOL )','(TOLP)',
C               '(TPAN)','(UDD )','(XO2 )','(XYL )','(XYLP'/
C
C
C************************************************************************
C***** DT_OPER IS THE TIME STEP OF OPERATOR SPLITTING
C***** DTSTEP IS THE THE TIME STEP
C******************************************************************************
C
        TIMENOW=t0/60.
        T=TIMENOW
        TEND=t1/60.
        DTSTEP=30.
        DT_OPER=TEND-TIMENOW
        TOLX=1.e-4 
        TOLF=1.e-14
        NTRIAL=100
        NTRIAL2=100
        P=pp/100.
        TEMP=tt
C
      IF ( TIMENOW .GT. TEND ) STOP 'TIME START LATER THAN TIME END'
C
C
      DTSTEP = DTSTEP / 60.	! IN MINS
C
C

      DO 1 J = 1, LSPEC
        LDUM(J) = J
1     CONTINUE
C
      DO 2 J = 1, NREACK
        CRK(J) = 0.
2     CONTINUE
C

C
5     CONTINUE
C
C     =YC OF INITIAL SPECIES 
      DO 6 L = 1, NUMSPEC
        YC(L) =  vc(L)*1.e6
6     CONTINUE
      do l=1,NREACJ
      RJI(l)=photoj(l)*60.
      enddo

C
C FLOOR THE SPECIES CONCENTRATION
C
      DO 7 J = 1, LSPEC
        IF( YC(J) .LT. EPSLON ) YC(J) = EPSLON
7     CONTINUE

c     write(06,'(6e12.4)') yc
C
      TNOY = YC(LNO) + YC(LNO2) + YC(LNO3) + 2. * YC(LN2O5) +
     &             YC(LHONO) + YC(LHNO3) + YC(LHNO4)
      TNOZ = YC(LNO) + YC(LNO2) + YC(LHNO3)
C
C THE OPERATOR SPLITTING IS RUNNING AS
C   DT = DT_OPER
C
C   START LOOP
C     DRY DEPOSITION                - DT / 2.
C       GAS PHASE CHEMISTRY + EMISS - DT
C     DRY DEPOSITION                - DT / 2.
C   END LOOP
C
      
      T        = TIMENOW
      OPDT = DT_OPER
      OPDT2 = OPDT / 2.
      ISTEP0     = 1
      IPASS_NOX = 0
      IPASS_HOX = 0
      IPASS_EUL = 0
C
C START OPERATOR SPLITTING LOOPING
C Chang:
C      MSTEP  = INT( ( TEND - TIMENOW ) / OPDT) +1 
C      NSTEP = INT( OPDT / DTSTEP ) +1 ! MAXIMUM STEPS ALLOWED FOR CHEM RXN
C Karl (27.05.98):
c     MSTEP  = INT( ( TEND - TIMENOW ) / OPDT) 
      mstep=1
      NSTEP = INT( OPDT / DTSTEP )  ! MAXIMUM STEPS ALLOWED FOR CHEM RXN
c     write(06,'("nstep",  i4)') nstep
c  RF
      MSTEP=1
      NSTEP = max( INT( OPDT/DTSTEP -1.e-10) +1, 1)
c     write(06,'("nstep",  i4)') nstep

C
C FOR OUTPUTING NUMBER OF ITERATION
C
      ICOUNT    = 0
C
C
      DO 9 JSTEP = 1, MSTEP
C
C DRY DEPOSITION - GO HALF STEP
C
        CALL DRY_DEPOSITION(T, OPDT2 )

C
C GAS PHASE CHEMICAL REACTION - GO FULL STEP
C
C THE FOLLOWING QUANTITY IS CALLED ONCE FOR EVERY OPDT PERIOD, RK(J).
C
c         write(6,'("t,p,rh",i3,8e13.4)')
c    &      j,temp,p,yc(lh2o),yc(lno)
c         write(6,'("vc",5e16.8)') (vc(l),l=1,lpred)

        CALL CHEM
       
C
        CALL GET_EMISSION(T)      ! LINK WITH EMISSION.F
C
        TOUT   = AMIN1( TEND, T + OPDT )
        TIME_HALF  = T + OPDT2
        DTC    = DTSTEP
  
C
CALL EXPLICIT SCHEME & NEWTON-RAPHSON ITERATION SCHEMES
C
        DO 11 ISTEP = 1, NSTEP
C
C FOR OUTPUTING NUMBER OF ITERATION
C
          ICOUNT    = ICOUNT + 1
          ICNOX     = 0
          ICHOX     = 0
C
ccccc     CALL PHOT(T)
          
C NO DRY DEPOSITION FOR GROUP 2,3,4; SO FAR ONLY PLANED FOR GROUP 1
C
          G10(1) = YC(LNO2)
          G10(2) = YC(LNO)
          G10(3) = YC(LO3)
          G10(4) = YC(LO3P)
C
          
          G20(1) = YC(LHO)
          G20(2) = YC(LHO2)
          G20(3) = YC(LHONO)
          G20(4) = YC(LHNO4)
C
          DO 12 L = 1, LSPEC
            YC0(L) = YC(L)
 
12        CONTINUE

C
          NITER=0
          DO 13 ITER = 1, NTRIAL
C
C COMPUTE CRJS AND CRKS BASED ON LATEST ITERATION SPECIES
C CONCENTRATIONS THAT WILL REMAIN UNCHANGED IN THE FOLLOWING SUBROUTINES
C
            
            CALL CRJK
c     write(06,'("istep,iter", 2i4)') istep,iter
c     write(06,'("rki ",10e12.3)') rki
c     write(06,'("crk ",10e12.3)') 
c     write(06,'("crk ",10e12.3)') crk

            
C SOLUTION FOR SOLVING STRONG COUPLING SPECIES
C
C (1) NO2, NO, O3, AND O3P GROUP
C
       
            G1(1) = YC(LNO2)
            G1(2) = YC(LNO)
            G1(3) = YC(LO3)
            G1(4) = YC(LO3P)
            XA    = YC(LO1D)
            
C
c     write(06,'("LO3P",i4,10e12.3)') iter,YC(LO3P)
                   
            CALL NEWRAP_NOXOX(NTRIAL2, G10, G1, IG1, TOLX, TOLF, XA,ITX)
         
C
C FOR OUTPUTING NUMBER OF ITERATION
C
            ICNOX = ICNOX + ITX
C
            IF ( NTRIAL2 .EQ. -999 ) THEN
              IPASS_NOX = IPASS_NOX + 1
              NTRIAL2 = NTRIAL20
            END IF
C
            
            YCP(LNO2)  = G1(1)
            YCP(LNO)   = G1(2)
            YCP(LO3)   = G1(3)
            YCP(LO3P)  = G1(4)
            YCP(LO1D)  = XA
           
      
C
C (2) HO, HO2, HONO, AND HNO4 GROUP
C
            G2(1) = YC(LHO)
            G2(2) = YC(LHO2)
            G2(3) = YC(LHONO)
            G2(4) = YC(LHNO4)
C
            CALL NEWRAP_HOXHNOX( NTRIAL2, G20, G2, IG2, TOLX, 
     &                           TOLF,XA,ITX)
C
C FOR OUTPUTING NUMBER OF ITERATION
C
            ICHOX = ICHOX + ITX
C
            IF ( NTRIAL2 .EQ. -999 ) THEN
              IPASS_HOX = IPASS_HOX + 1
              NTRIAL2 = NTRIAL20
            END IF
C
            YCP(LHO)   = G2(1)
            YCP(LHO2)  = G2(2)
            YCP(LHONO) = G2(3)
            YCP(LHNO4) = G2(4)
            YCP(LO1D)  = XA
C
            CALL PRODLOSS( EPROD, ELOSS )


C NEW REACTION-CIRCLES FOR RACM !!!!!
C
C (3) ACO3 AND PAN
C
C PROD OF  ACO3
            RP_ACO3 = +     CRJ( 16)+       CRJ( 19)+       CRJ( 22)
     &              +       CRJ( 23)+       CRK( 54)+       CRK( 58)
     &              + 0.650*CRK( 64)+       CRK( 69)+       CRK( 71)
     &              + 0.150*CRK( 86)+ 0.150*CRK( 87)+ 0.130*CRK( 90)
     &              + 0.280*CRK( 91)+ 0.700*CRK( 92)
     &              +       CRK(123)+ 0.230*CRK(124)+       CRK(164)
     &              + 0.120*CRK(166)+       CRK(205)+ 0.230*CRK(206)

C LOSS OF ACO3
          
            RL_ACO3 = + RKI(104) * YC(LNO2) +  RKI(122) * YC(LNO)
     &              + RKI(141) * YC(LHO2)  +  RKI(142) * YC(LHO2)
     &              + RKI(162) * YC(LMO2)  +  RKI(163) * YC(LMO2)
     &              + RKI(169) * YC(LETHP) +  RKI(170) * YC(LHC3P)
     &              + RKI(171) * YC(LHC5P) +  RKI(172) * YC(LHC5P)
     &              + RKI(173) * YC(LETEP) +  RKI(174) * YC(LOLTP)
     &              + RKI(175) * YC(LOLIP) +  RKI(176) * YC(LISOP)
     &              + RKI(177) * YC(LAPIP) +  RKI(178) * YC(LLIMP)
     &              + RKI(179) * YC(LTOLP) +  RKI(180) * YC(LXYLP)
     &              + RKI(181) * YC(LCSLP)
     &              +  0.880 * RKI(184) * YC(LKETP)
     &              + RKI(185) * YC(LOLNN) +  RKI(186) * YC(LOLND)
     &              + RKI(204) * YC(LNO3)  +  RKI(211) * YC(LXO2)
C PROD OF PAN
            RP_PAN  = + 0.400*CRK( 66)+ 0.400*CRK( 82)+ 0.300*CRK( 92)
C LOSS OF PAN
            RL_PAN = RKI( 65) * YC(LHO)  +  RKI(105)
C ACO3 + ACO3
            R88DT = RKI( 182) * DTC
C PAN ->
            R89DT = RKI(105) * DTC
C ACO3 -> PAN
            R98DT  = RKI(104) * YC(LNO2) * DTC
C
C SOLV THE GENERAL QUADRATIC EQUATION
C A*X**2 + B*X + C
C WITH SOLUTION X = ( -B + SQRT( B * B + 4. * A * C ) ) / 2. / A
C
            CMN = 1. + RL_PAN * DTC
            A = 2. * R88DT * CMN
            B = CMN * ( 1. + RL_ACO3 * DTC ) - R89DT * R98DT
            C = CMN * ( YC0(LACO3) + RP_ACO3 * DTC ) + R89DT * YC0(LPAN)
            YCP(LACO3) = ( -B + SQRT( B * B + 4. * A * C ) ) / 2. / A
            YCP(LPAN)  = ( YC0(LPAN) + R98DT * YCP(LACO3) ) / CMN
 
C
C (4) TCO3 AND TPAN
C
C PROD OF TCO3
            RP_TCO3 = +     CRJ( 20)+ 0.510*CRK( 59)+ 0.500*CRK( 60)
     &              + 0.200*CRK( 72)+ 0.500*CRK( 73)
C LOSS OF TCO3
            RL_TCO3 = RKI(106) * YC(LNO2)  +  RKI(123) * YC(LNO)
     &              + RKI(143) * YC(LHO2)  +  RKI(144) * YC(LHO2)
     &              + RKI(164) * YC(LMO2)  +  RKI(165) * YC(LMO2)
     &              + RKI(183) * YC(LACO3) +  RKI(205) * YC(LNO3)
C LOSS OF TPAN
            RL_TPAN = RKI( 66) * YC(LHO)   +  RKI( 82) * YC(LNO3)
     &              + RKI( 92) * YC(LO3)   +  RKI(107)
C NO  TCO3 + TCO3
C !!!!! MISSING R44DT         
C TPAN ->
            R34DT = RKI(107) * DTC 
C TCO3 -> TPAN
            R43DT  = RKI(106) * YC(LNO2) * DTC
C
            A1     = 1. + RL_TPAN * DTC
            A2     = 1. + RL_TCO3  * DTC
            A3     = YC0(LTCO3) + RP_TCO3 * DTC
            ATOP3  = A1 * A3        + R43DT * YC0(LTPAN)
            ATOP3  = A1 * A3        + R34DT * YC0(LTPAN)
            ATOP5  = A2 * YC0(LTPAN) + R43DT * A3
            BOTT   = A1 * A2 - R34DT * R43DT
            YCP(LTCO3)  = ATOP3 / BOTT
            YCP(LTPAN) = ATOP5 / BOTT

C
C (5) NO3 AND N2O5
C LOSS OF N2O5
            RL_N2O5 = RKI( 31)
C PROD OF NO3
            RP_NO3 = + 0.350*CRJ(  6)+       CRK( 14)+       CRK( 23)
     &              +        CRK( 26)  +       CRK( 65)
cc   &              +   RKI( 26) * YC(LO3  ) * YC(LNO2 )+  CRK( 65)
cc   &              +   RKI( 26) * YC(LO3  ) * 3.e-9    +  CRK( 65)
     &              + 0.600* CRK( 66)
c xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

C LOSS OF NO3
            RL_NO3 =  RJI(  7) +  RJI(  8) 
     &             + RKI( 17) * YC(LHO) 
     &             +  RKI( 21) * YC(LHO2)  + RKI( 28) * YC(LNO)
     &             +  ( RKI( 29) + RKI( 30) ) * YC(LNO2)
     &             +  RKI( 68) * YC(LHCHO) + RKI( 69) * YC(LALD)
     &             +  RKI( 70) * YC(LGLY)  + RKI( 71) * YC(LMGLY)
     &             +  RKI( 72) * YC(LMACR) + RKI( 73) * YC(LDCB)
     &             +  RKI( 74) * YC(LCSL)  + RKI( 75) * YC(LETE)
     &             +  RKI( 76) * YC(LOLT)  + RKI( 77) * YC(LOLI)
     &             +  RKI( 78) * YC(LDIEN) + RKI( 79) * YC(LISO)
     &             +  RKI( 80) * YC(LAPI)  + RKI( 81) * YC(LLIM)
     &     + 0.400 *  RKI( 82) * YC(LTPAN)  + RKI(190) * YC(LMO2)
     &             +  RKI(191) * YC(LETHP)  + RKI(192) * YC(LHC3P)
     &             +  RKI(193) * YC(LHC5P)  + RKI(194) * YC(LHC8P)
     &             +  RKI(195) * YC(LETEP)  + RKI(196) * YC(LOLTP)
     &             +  RKI(197) * YC(LOLIP)  + RKI(198) * YC(LISOP)
     &             +  RKI(199) * YC(LAPIP)  + RKI(200) * YC(LLIMP)
     &             +  RKI(201) * YC(LTOLP)  + RKI(202) * YC(LXYLP)
     &             +  RKI(203) * YC(LCSLP)  + RKI(204) * YC(LACO3)
     &             +  RKI(205) * YC(LTCO3)  + RKI(206) * YC(LKETP)
     &             +  RKI(207) * YC(LOLNN)  + RKI(208) * YC(LOLND)
     &             +  RKI(214) * YC(LXO2)
 
C NO3 + NO3
            R55DT  = RKI( 32) * DTC
C N2O5->
            R56DT  = RKI( 31) * DTC
C NO3 -> N2O5
            R65DT  = RKI( 30) * YC(LNO2) * DTC
C 
C solution of the quadratic equation
            CMN1 = 1. + RL_N2O5 * DTC
            AA = 2. * R55DT * CMN1
            BB = CMN1 * ( 1. + RL_NO3 * DTC ) - R56DT * R65DT
            CC = CMN1 * ( YC0(LNO3) + RP_NO3 * DTC )
     &           + R56DT * YC0(LN2O5)
            YCP(LNO3) = ( -BB + SQRT( BB * BB + 4. * AA * CC ) )
     &                    / 2. / AA
            YCP(LN2O5)= ( YC0(LN2O5) + R65DT * YCP(LNO3) ) / CMN1
C
C SOLUTION FOR OTHER SPECIES; EULER-BACKWARD ITERATION METHOD
C
            DO 14 KL = 1, LEBI
              L = IEBI(KL)
              YCP(L) = ( YC0(L) + EPROD(L) * DTC ) /
     &                            ( 1. + ELOSS(L) * DTC / YC(L) )
14          CONTINUE
C
C CHECK CONVERGENCE
C  |YCold - YCnew| <= RTOL*(YCold + YCnew)
C
            
            ISTOP = .TRUE.
            DO 15 L = 1, LSPEC
               
               YCP(L) = ABS(AMAX1( EPSLON, YCP(L) ))
               IF ( ABS( YC(L) - YCP(L) ) .GT. RTOL(L) *
     &             ( YCP(L) + YC(L) ) ) ISTOP = .FALSE.
 
               YC(L) = YCP(L)
15          CONTINUE
            IF( ISTOP ) GOTO 200  
            NITER = NITER+1

13        CONTINUE
          
          NTRIAL = -999
C
200       IF ( NTRIAL .EQ. -999 ) THEN
            IPASS_EUL = IPASS_EUL + 1
            NTRIAL = NTRIAL0
          END IF
       
C
C FOR OUTPUTING NUMBER OF ITERATION
C
          ITER_EULER(ICOUNT) = ITER
          ITER_NOX(ICOUNT)   = ICNOX
          ITER_HOX(ICOUNT)   = ICHOX
C
          T = T + DTC	! UPDATE TIME
          IF ( T .EQ. TOUT ) GO TO 300
          IF ( T .GT. TOUT ) STOP 'TIME COUNTER IS WRONG'
          IF ( T + DTC .GT. TOUT ) DTC = TOUT - T	! GO NO FURTHER THAN OPDT
11      CONTINUE

C
C WIND CLOCK BACK OPDT / 2. FOR EMISSION & DEPOSITION - FINISHING 2ND HALF STEP
C
C DRY DEPOSITION; GO ANOTHER HALF STEP
C
        
300     CALL DRY_DEPOSITION(TIME_HALF, OPDT2 )
        
C
C STORE CONCENTRATIONS FOR OUTPUT
C
C   NOy
        TNOY = YC(LNO2) + YC(LNO) + YC(LHNO3) + 2. * YC(LN2O5) +
     &               YC(LNO3) + YC(LHONO) + YC(LHNO4)
C   NOx
        TNOZ = YC(LNO2) + YC(LNO) + YC(LHNO3)
C
        IF (T .GE. TEND) GO TO 400
C
9     CONTINUE
C
400   CONTINUE
C
c        if(lprin) then
c         write(6,'("t,p,rh",i3,3e13.4)')
c    &      j,temp,p,yc(lh2o)
c         write(6,'("vc",5e16.8)') (vc(l),l=1,lpred)
c         write(6,'("yc",5e16.8)') (yc(l),l=1,lspec)
c        endif

C
      DO  L = 1, NUMSPEC
        vc(L) =  YC(L)/1.e6
      enddo    

      return 
      END
C----------------------------------------------------------------------
C----------------------------------------------------------------------
C          RACM CHEM BOX MODEL CHEM RATE CNST CALCULATION MODULE     
C----------------------------------------------------------------------
      SUBROUTINE CHEM
C************************************************************************
      INCLUDE "a_params.com"
      SAVE
      PARAMETER( LSC = 12 )
      DOUBLE PRECISION GASCON, CM
      DOUBLE PRECISION TMP0, TMPI, TMPE, TMPR, TMPM, TMPQ, TMPF
      DOUBLE PRECISION TMP2,TMP3

      double precision CONST(2), PRES, TO300, PATMOT2, PATMOT3 
      DATA CONST/ 4.4E17, 3.23E33 /

C********************************************************************

      TO300   = TEMP / 300.
      PRES = P / 1013.   ! pressure in atm

C CALCULATE CONCENTRATION OF 3RD-BODY IN MOLECULAR UNITS
C   GAS CONSTANTS IN UNITS bar cm3 molecule-1 K-1

      GASCON=83.145/6.0221E23
      
C   n/V = P/(R T)
      CM = PRES /(GASCON * TEMP)

C CONVERT FIRST ORDER RATE CONSTANT IN min-1 FOR
C HERTEL SOLVER: * 60.      

C CONVERT SECOND ORDER RATE CONSTANT IN ppm-1 min-1 FOR
C HERTEL SOLVER: * PATMOT2

      PATMOT2 = CONST(1) * PRES / TEMP
C CONVERT THIRD ORDER RATE CONSTANT IN ppm-1 min-1 FOR
C HERTEL SOLVER: * PATMOT3 

      PATMOT3 = CONST(2) * (PRES/TEMP) * (PRES/TEMP)

C
C*********************************************************************
C
C
C 001 O3P   O2        ->      O3                                               
      RKI(  1)= CM * 6.00E-34*((TO300)**(-2.3)) * PATMOT2 
C TROE in CBIV, special reaction in RACM                               
c     write(06,'("cm,TO300,PATMOT2 ",10e12.3)') cm,TO300,PATMOT2
C
  
C 002 O3P   O3        ->  2.0 O2                                               
      RKI(  2) = 0.8000E-11* EXP(-2060.00/TEMP) * PATMOT2
C
C 003 O1D   N2        ->      O3P         N2                                   
      RKI(  3) = 0.1800E-10* EXP( 110.000/TEMP) * PATMOT2
C
C    Achtung N2 einfuehren!!!!
C
C 004 O1D   O2        ->      O3P         O2                                   
      RKI(  4) = 0.3200E-10* EXP( 70.0000/TEMP) * PATMOT2
C
C 005 O1D   H2O       ->      HO          HO                                   
      RKI(  5) = 0.2200E-09 * PATMOT2
C
C 006 O3    HO        ->      HO2         O2                                   
      RKI(  6) = 0.1600E-11* EXP(-940.000/TEMP) * PATMOT2
C
C 007 O3    HO2       ->      HO     2.   O2                                   
      RKI(  7) = 0.1100E-13* EXP(-500.000/TEMP) * PATMOT2
C
C 008 HO    HO2       ->      H2O         O2                                   
      RKI(  8) = 0.4800E-10* EXP( 250.000/TEMP) * PATMOT2
C
C 009 H2O2  HO        ->      HO2         H2O                                  
      RKI(  9) = 0.2900E-11* EXP(-160.000/TEMP) * PATMOT2
C
C 010 HO2   HO2       ->      H2O2        O2                                   
      RKI( 10)=(2.3E-13*EXP(600./TEMP) +1.7E-33 * CM * EXP(1000./TEMP))
     & * PATMOT2
C
C     FIRST 10
C
C     third order reaction !!!H2O 
C
C 011 HO2   HO2   H2O ->      H2O2        H2O         O2                       
      RKI( 11)=(3.22E-34 * EXP(2800./TEMP)+2.38E-54*CM*EXP(3200./TEMP))
     & * PATMOT3
 
C
C 012 O3P   NO        ->      NO2                                              
        TMP0 = 0.9000E-31*(TO300)**(  -1.500)
        TMPI = 0.3000E-10*(TO300)**(   0.000)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 12) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C 013 O3P   NO2       ->      NO          O2                                   
      RKI( 13) = 0.6500E-11* EXP( 120.000/TEMP) * PATMOT2
C
C 014 O3P   NO2       ->      NO3                                              
        TMP0 = 0.9000E-31*(TO300)**(  -2.000)
        TMPI = 0.2200E-10*(TO300)**(   0.000)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = ((1. + (LOG10(TMPR)**2))**(-1))
      RKI( 14) = (TMPM/(1. + TMPR))*0.6**TMPE * PATMOT2
C
C 015 HO    NO        ->      HONO                                             
        TMP0 = 0.7000E-30*(TO300)**(  -2.600)
        TMPI = 0.1500E-10*(TO300)**(  -0.500)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 15) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C 016 HO    NO2       ->      HNO3                                             
        TMP0 = 0.2600E-29*(TO300)**(  -3.200)
        TMPI = 0.2400E-10*(TO300)**(  -1.300)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 16) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C 017 HO    NO3       ->      NO2         HO2                                  
      RKI( 17) = 0.2200E-10 * PATMOT2
C
C 018 HO2   NO        ->      NO2         HO                                   
      RKI( 18) = 0.3700E-11* EXP( 250.000/TEMP) * PATMOT2
C
C 019 HO2   NO2       ->      HNO4                                             
        TMP0 = 0.1800E-30*(TO300)**(  -3.200)
        TMPI = 0.4700E-11*(TO300)**(  -1.400)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 19) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C     first order reaction
C 020 HNO4            ->      HO2         NO2                                  
        TMP0 = 0.1800E-30*(TO300)**(  -3.200)
        TMPI = 0.4700E-11*(TO300)**(  -1.400)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
        TMPF = (TMPM/(1. + TMPR))*0.6**TMPE
        TMPQ = 0.2100E-26*EXP( 10900.0    /TEMP)
      RKI( 20) = (TMPF/TMPQ) * 1. * 60.
C
C     FIRST 20
C
C 021 HO2   NO3       ->  0.3 HNO3    0.7 NO2    0.7  HO                       
      RKI( 21) = 0.3500E-11 * PATMOT2
C
C 022 HO    HONO      ->      H2O         NO2                                  
      RKI( 22) = 0.1800E-10* EXP(-390.000/TEMP) * PATMOT2
C
C 023 HO    HNO3      ->      NO3         H2O                                  
      TMP0 = 7.2E-15*EXP(785/TEMP)                                            
      TMP2 = 4.1E-16*EXP(1440/TEMP)                                           
      TMP3 = 1.9E-33*EXP(725/TEMP)*CM                                        
      RKI( 23)= (TMP0 + TMP3/(1+TMP3/TMP2)) * PATMOT2                          
C
C 024 HO    HNO4      ->      NO2         H2O         O2                       
      RKI( 24) = 0.1300E-11* EXP( 380.000/TEMP) * PATMOT2
C
C 025 O3    NO        ->      NO2         O2                                   
      RKI( 25) = 0.2000E-11* EXP(-1400.00/TEMP) * PATMOT2
C
C 026 O3    NO2       ->      NO3         O2                                   
      RKI( 26) = 0.1200E-12* EXP(-2450.00/TEMP) * PATMOT2
C
C    third order reaction! O2!!!
C
C 027 NO    NO    O2  ->      NO2         NO2                                  
       RKI( 27) = 0.3300E-18* EXP( 530.000/TEMP) * PATMOT3
       RKI( 27) = RKI( 27) * 1.0E-20

C 0.33E-38 out of range for single double precision
C
C 028 NO3   NO        ->      NO2         NO2                                  
      RKI( 28) = 0.1500E-10* EXP( 170.000/TEMP) * PATMOT2
C
C 029 NO3   NO2       ->      NO          NO2         O2                       
      RKI( 29) = 0.4500E-13* EXP(-1260.00/TEMP) * PATMOT2
C
C 030 NO3   NO2       ->      N2O5                                             
        TMP0 = 0.2200E-29*(TO300)**(  -3.900)
        TMPI = 0.1500E-11*(TO300)**(  -0.700)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 30) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C     FIRST 30
C
C     first order reaction
C 031 N2O5            ->      NO2         NO3                                  
        TMP0 = 0.2200E-29*(TO300)**(  -3.900)
        TMPI = 0.1500E-11*(TO300)**(  -0.700)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
        TMPF = (TMPM/(1. + TMPR))*0.6**TMPE
        TMPQ = 0.2700E-26*EXP( 11000.0/TEMP)
      RKI( 31) = (TMPF/TMPQ) * 1. * 60.
C
C 032 NO3   NO3       ->      NO2         NO2         O2                       
      RKI( 32) = 0.8500E-12* EXP(-2450.00/TEMP) * PATMOT2
C
C 033 HO    H2        ->      H2O         HO2                                  
      RKI( 33) = 0.5500E-11* EXP(-2000.00/TEMP) * PATMOT2
C
C 034 HO    SO2       ->      SULF        HO2                                  
        TMP0 = 0.3000E-30*(TO300)**(-3.300)
        TMPI = 0.1500E-11*(TO300)**(0.000)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI( 34) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C
C 035 CO    HO        ->      HO2         CO2                                  
      RKI( 35)= 1.5E-13 * (1. + 2.439E-20 * CM) * PATMOT2                              
C
C 036 ISO   O3P       -> 0.86 OLT    0.05 HCHO  0.02  HO                       
C &                      0.01 CO     0.13 DCB   0.28  HO2               
C &                      0.15 XO2                                       
      RKI( 36) = 0.6000E-10 * PATMOT2
C
C 037 MACR  O3P       ->      ALD                                              
      RKI( 37) = 0.1590E-10* EXP( 13.0000/TEMP) * PATMOT2
C
C 038 CH4   HO        ->      MO2         H2O                                  
      RKI( 38) = 0.7440E-17* TEMP * TEMP * EXP(-1361.00/TEMP) * PATMOT2
C
C 039 ETH   HO        ->      ETHP        H2O                                  
      RKI( 39) = 0.1510E-16* TEMP * TEMP * EXP(-492.000/TEMP) * PATMOT2
C
C 040 HC3   HO        -> .583 HC3P   .381 HO2   .335  ALD                      
C &                      .036 ORA1   .036 CO    .036  GLY               
C &                      .036 HO     .010 HCHO        H2O               
      RKI( 40) = 0.5260E-11* EXP(-260.000/TEMP) * PATMOT2
C
C     FIRST 40
C
C 041 HC5   HO        -> .750 HC5P   .250 KET   .250  HO2                      
C &                           H2O                                       
      RKI( 41) = 0.8020E-11* EXP(-155.000/TEMP) * PATMOT2
C 042 HC8   HO        -> .951 HC8P   .025 ALD   .024  HKET                     
C &                      .049 HO2         H2O                           
      RKI( 42) = 0.1640E-10* EXP(-125.000/TEMP) * PATMOT2
C 043 ETE   HO        ->      ETEP                                             
      RKI( 43) = 0.1960E-11* EXP( 438.000/TEMP) * PATMOT2
C 044 OLT   HO        ->      OLTP                                             
      RKI( 44) = 0.5720E-11* EXP( 500.000/TEMP) * PATMOT2
C 045 OLI   HO        ->      OLIP                                             
      RKI( 45) = 0.1330E-10* EXP( 500.000/TEMP) * PATMOT2
C 046 DIEN  HO        ->      ISOP                                             
      RKI( 46) = 0.1480E-10* EXP( 448.000/TEMP) * PATMOT2
C 047 ISO   HO        ->      ISOP                                             
      RKI( 47) = 0.2540E-10* EXP( 410.000/TEMP) * PATMOT2
C 048 API   HO        ->      APIP                                             
      afakt=1.
      bfakt=0.
      dfakt=0. !D3C
      tfakt=0.
      cfakt=0.
      RKI( 48) = 0.0
      if(afakt.gt.1.e-20) then
      RKI( 48) = afakt* 0.1210E-10* EXP( 444.000/TEMP) * PATMOT2
c     RKI( 48) = afakt* .0537E-09 * PATMOT2 !API ohne T-Abh
      endif
      if(bfakt.gt.1.e-20) then
      RKI( 48) = bfakt* 0.2380E-10* EXP( 357.000/TEMP) * PATMOT2 !b-Pinen
      endif
      if(dfakt.gt.1.e-20) then
      RKI( 48) = dfakt* 0.0880E-09 * PATMOT2                     !D3Caren
      endif
      if(tfakt.gt.1.e-20) then
      RKI( 48) = tfakt* 0.0100E-09 * PATMOT2                     !Tricyclen
      endif
      if(cfakt.gt.1.e-20) then
      RKI( 48) = cfakt* 0.0530E-09 * PATMOT2                     !Camphen   
      endif
C 049 LIM   HO        ->      LIMP                                             
      RKI( 49) =  0.1710E-09 * PATMOT2
C 050 TOL   HO        -> 0.90 ADDT   0.10 XO2   0.10  HO2                      
      RKI( 50) = 0.1810E-11* EXP( 355.000/TEMP) * PATMOT2
C
C     FIRST 50
C
C 051 XYL   HO        -> 0.90 ADDX   0.10 XO2   0.10  HO2                      
      RKI( 51) = 0.7300E-11* EXP( 355.000/TEMP) * PATMOT2
C
C 052 CSL   HO        -> 0.85 ADDC   0.10 PHO   0.05  HO2                      
C &                      0.05 XO2                                       
      RKI( 52) = 0.6000E-10 * PATMOT2
C
C 053 HCHO  HO        ->      HO2         CO          H2O                      
      RKI( 53) = 0.1000E-10 * PATMOT2
C
C 054 ALD   HO        ->      ACO3        H2O                                  
      RKI( 54) = 0.5550E-11* EXP( 331.000/TEMP) * PATMOT2
C
C 055 KET   HO        ->      KETP        H2O                                  
      RKI( 55) = 0.5680E-17* TEMP * TEMP * EXP( 92.0000/TEMP)
     &  * PATMOT2
C
C 056 HKET  HO        ->      HO2         MGLY        H2O                      
      RKI( 56) = 0.3000E-11 * PATMOT2
C
C 057 GLY   HO        ->      HO2    2.0  CO          H2O                      
      RKI( 57) = 0.1140E-10 * PATMOT2

C 058 MGLY  HO        ->      ACO3        CO          H2O                      
      RKI( 58) = 0.1720E-10 * PATMOT2
C
C 059 MACR  HO        -> 0.51 TCO3   0.41 HKET  0.08  MGLY                     
C &                      0.41 CO     0.08 HCHO  0.49  HO2               
C &                      0.49 XO2                                       
      RKI( 59) = 0.1860E-10* EXP( 175.000/TEMP) * PATMOT2
C
C 060 HO    DCB       -> 0.50 TCO3   0.50 HO2   0.50  XO2                      
C &                      0.35 UDD    0.15 GLY   0.15  MGLY              
      RKI( 60) = 0.2800E-10* EXP( 175.000/TEMP) * PATMOT2
C
C
C     FIRST 60
C
C 061 HO    UDD       -> 0.88 ALD    0.12 KET         HO2                      
      RKI( 61) = 0.2700E-09 * PATMOT2
C
C 062 OP1   HO        -> .65  MO2    .35  HCHO  0.35  HO                       
      RKI( 62) = 0.2930E-11* EXP( 190.000/TEMP) * PATMOT2
C
C 063 OP2   HO        -> 0.44 HC3P   0.08 ALD   0.49  HO                       
C &                      0.07 XO2    0.41 KET                           
      RKI( 63) = 0.3400E-11* EXP( 190.000/TEMP) * PATMOT2
C
C 064 PAA   HO        -> 0.65 ACO3   0.35 HO2   0.35  HCHO                     
C &                      0.35 XO2                                       
      RKI( 64) = 0.2930E-11* EXP( 190.000/TEMP) * PATMOT2
C
C 065 PAN   HO        ->      HCHO        NO3         XO2                      
C &                           H2O                                       
      RKI( 65) = 0.4000E-13 * PATMOT2
C
C 066 TPAN  HO        -> 0.60 HKET   0.60 NO3   0.40  PAN                      
C &                      0.40 HCHO   0.40 HO2         XO2               
      RKI( 66) = 0.3250E-12* EXP( 500.000/TEMP) * PATMOT2
C
C 067 ONIT  HO        ->      HC3P        NO2         H2O                      
      RKI( 67) = 0.5310E-11* EXP(-260.000/TEMP) * PATMOT2
C
C 068 HCHO  NO3       ->      HO2         HNO3        CO                       
      RKI( 68) = 0.3400E-12* EXP(-1900.00/TEMP) * PATMOT2
C
C 069 ALD   NO3       ->      ACO3        HNO3                                 
      RKI( 69) = 0.1400E-11* EXP(-1900.00/TEMP) * PATMOT2
C
C 070 GLY   NO3       ->      HNO3        HO2   2.0   CO                       
      RKI( 70) = 0.2900E-11* EXP(-1900.00/TEMP) * PATMOT2
C
C
C     FIRST 70
C
C 071 MGLY  NO3       ->      HNO3        ACO3        CO                       
      RKI( 71) = 0.1400E-11* EXP(-1900.00/TEMP) * PATMOT2
C
C 072 MACR  NO3       -> 0.20 TCO3   0.20 HNO3  0.80  OLNN                     
C &                      0.80 CO                                        
      RKI( 72) = 0.8270E-14* EXP(-150.000/TEMP) * PATMOT2
C
C 073 DCB   NO3       -> 0.50 TCO3   0.50 HO2   0.50  XO2                      
C &                      0.25 GLY    0.25 ALD   0.50  NO2               
C &                      0.03 KET    0.25 MGLY  0.50  HNO3              
      RKI( 73) = 0.2870E-12* EXP(-1000.00/TEMP) * PATMOT2
C
C 074 CSL   NO3       ->      HNO3        PHO                                  
      RKI( 74) = 0.2200E-10 * PATMOT2
C
C 075 ETE   NO3       -> 0.80 OLNN   0.20 OLND                                 
      RKI( 75) = 0.4880E-17* TEMP * TEMP * EXP(-2282.00/TEMP)
     & * PATMOT2
C
C 076 OLT   NO3       -> 0.43 OLNN   0.57 OLND                                 
      RKI( 76) = 0.1790E-12* EXP(-450.000/TEMP) * PATMOT2
C
C 077 OLI   NO3       -> 0.11 OLNN   0.89 OLND                                 
      RKI( 77) = 0.8640E-12* EXP( 450.000/TEMP) * PATMOT2 
C
C 078 DIEN  NO3       -> 0.90 OLNN   0.10 OLND  0.90  MACR                     
      RKI( 78) = 0.1000E-12 * PATMOT2
C
C 079 ISO   NO3       -> 0.90 OLNN   0.10 OLND  0.90  MACR                     
      RKI( 79) = 0.4000E-11* EXP(-446.000/TEMP) * PATMOT2
C
C 080 API   NO3       -> 0.10 OLNN   0.90 OLND                                 
      RKI( 80) = 0.0
      if(afakt.gt.1.e-20) then
      RKI( 80) = afakt* 0.1190E-11* EXP( 490.000/TEMP) * PATMOT2
      RKI( 80) = afakt* .616E-11 * PATMOT2   !api
      endif
      if(bfakt.gt.1.e-20) then
      RKI( 80) = bfakt* 0.2510E-11 * PATMOT2   ! b-Pinen
      endif
      if(dfakt.gt.1.e-20) then
      RKI( 80) = dfakt* 0.9100E-11 * PATMOT2   ! D3Caren
      endif
      if(tfakt.gt.1.e-20) then
      RKI( 80) = tfakt* 0.0050E-11 * PATMOT2   ! Tricyclen
      endif
      if(cfakt.gt.1.e-20) then
      RKI( 80) = cfakt* 0.0660E-11 * PATMOT2   ! Camphen
      endif
C
C
C     FIRST 80
C
C 081 LIM   NO3       -> 0.13 OLNN   0.87 OLND                                 
      RKI( 81) = 0.1220E-10 * PATMOT2 
C
C 082 TPAN  NO3       -> 0.60 ONIT   0.60 NO3   0.40  PAN                      
C &                      0.40 HCHO   0.40 NO2         XO2               
      RKI( 82) = 0.2200E-13* EXP(-500.000/TEMP) * PATMOT2
C
C 083 ETE   O3        ->      HCHO   0.43 CO    0.37  ORA1                     
C &                      0.26 HO2    0.13 H2    0.12  HO                
      RKI( 83) = 0.9140E-14* EXP(-2580.00/TEMP) * PATMOT2
C
C 084 OLT   O3        -> 0.64 HCHO   0.44 ALD   0.37  CO                       
C &                      0.14 ORA1   0.10 ORA2  0.25  HO2               
C &                      0.40 HO     0.03 KET   0.03  KETP              
C &                      0.06 CH4    0.05 H2    0.03  ETH               
C &                      .006 H2O2   0.19 MO2   0.10  ETHP              
      RKI( 84) = 0.4330E-14* EXP(-1800.00/TEMP) * PATMOT2
C
C 085 OLI   O3        -> 0.02 HCHO   0.99 ALD   0.16  KET                      
C &                      0.30 CO     .011 H2O2  0.14  ORA2              
C &                      0.07 CH4    0.22 HO2   0.63  HO                
C &                      0.23 MO2    0.12 KETP  0.06  ETH               
C &                      0.18 ETHP                                      
      RKI( 85) = 0.4400E-14* EXP(-845.000/TEMP) * PATMOT2
C
C 086 DIEN  O3        -> 0.90 HCHO   0.39 MACR  0.36  CO                       
C &                      0.15 ORA1   0.09 O3P   0.30  HO2               
C &                      0.35 OLT    0.28 HO    0.05  H2                
C &                      0.15 ACO3   0.03 MO2   0.02  KETP              
C &                      0.13 XO2    .001 H2O2                          
      RKI( 86) = 0.1340E-13* EXP(-2283.00/TEMP) * PATMOT2
C
C 087 ISO   O3        -> 0.90 HCHO   0.39 MACR  0.36  CO                       
C &                      0.15 ORA1   0.09 O3P   0.30  HO2               
C &                      0.35 OLT    0.28 HO    0.05  H2                
C &                      0.15 ACO3   0.03 MO2   0.02  KETP              
C &                      0.13 XO2    .001 H2O2                          
      RKI( 87) = 0.7860E-14* EXP(-1913.00/TEMP) * PATMOT2
C
C 088 API   O3        -> 0.65 ALD    0.53 KET   0.14  CO                       
C &                      0.20 ETHP   0.42 KETP  0.85  HO                
C &                      0.10 HO2    0.02 H2O2                          
      RKI( 88) = 0.0
      if(afakt.gt.1.e-20) then
      RKI( 88) =  afakt*  0.1010E-14* EXP(-732.000/TEMP) * PATMOT2
      RKI( 88) =  afakt*  0.0685E-15 * PATMOT2 !api
      endif
      if(bfakt.gt.1.e-20) then
      RKI( 88) =  bfakt*  0.0150E-15 * PATMOT2 !b-Pinen
      endif
      if(dfakt.gt.1.e-20) then
      RKI( 88) =  dfakt*  0.0370E-15 * PATMOT2 !D3Caren
      endif
      if(tfakt.gt.1.e-20) then
      RKI( 88) =  tfakt*  0.5000E-19 * PATMOT2 !Triciclen
      endif
      if(cfakt.gt.1.e-20) then
      RKI( 88) =  cfakt*  0.0009E-15 * PATMOT2 !Camphen
      endif
C
C 089 LIM   O3        -> 0.04 HCHO   0.46 OLT   0.14  CO                       
C &                      0.16 ETHP   0.42 KETP  0.85  HO                
C &                      0.10 HO2    0.02 H2O2  0.79  MACR              
C &                      0.01 ORA1   0.07 ORA2                          
      RKI( 89) =  0.2000E-15 * PATMOT2
C
C 090 MACR  O3        -> 0.40 HCHO   0.60 MGLY  0.13  ORA2                     
C &                      0.54 CO     0.08 H2    0.22  ORA1              
C &                      0.29 HO2    0.07 HO    0.13  OP2               
C &                      0.13 ACO3                                      
      RKI( 90) = 0.1360E-14* EXP(-2112.00/TEMP) * PATMOT2
C
C
C     FIRST 90
C
C 091 DCB   O3        -> 0.21 HO     0.29 HO2   0.66  CO                       
C &                      0.50 GLY    0.62 MGLY  0.28  ACO3              
C &                      0.16 ALD    0.11 PAA   0.11  ORA1              
C &                      0.21 ORA2                                      
      RKI( 91) = 0.2000E-17 * PATMOT2
C
C 092 TPAN  O3        -> 0.70 HCHO   0.30 PAN   0.70  NO2                      
C &                      0.13 CO     0.04 H2    0.11  ORA1              
C &                      0.08 HO2    .036 HO    0.70  ACO3              
      RKI( 92) = 0.2460E-14* EXP(-1700.00/TEMP) * PATMOT2
C
C 093 PHO   NO2       -> 0.10 CSL         ONIT                                 
      RKI( 93) = 0.2000E-10 * PATMOT2
C
C 094 PHO   HO2       ->      CSL                                              
      RKI( 94) = 0.1000E-10 * PATMOT2
C
C 095 ADDT  NO2       ->      CSL         HONO                                 
      RKI( 95) = 0.3600E-10 * PATMOT2
C
C 096 ADDT  O2        -> 0.98 TOLP   0.02 CSL   0.02  HO2                      
      RKI( 96) = 0.1660E-16* EXP( 1044.00/TEMP) * PATMOT2
C
C 097 ADDT  O3        ->      CSL         HO                                   
      RKI( 97) = 0.5000E-10 * PATMOT2
C
C 098 ADDX  NO2       ->      CSL         HONO                                 
      RKI( 98) = 0.3600E-10 * PATMOT2
C
C 099 ADDX  O2        -> 0.98 XYLP   0.02 CSL   0.02  HO2                      
      RKI( 99) = 0.1660E-16* EXP( 1044.00/TEMP) * PATMOT2
C
C 100 ADDX  O3        ->      CSL         HO                                   
      RKI(100) = 0.1000E-10 * PATMOT2
C
C
C     FIRST 100
C
C 101 ADDC  NO2       ->      CSL         HONO                                 
      RKI(101) = 0.3600E-10 * PATMOT2
C
C 102 ADDC  O2        -> 0.98 CSLP   0.02 CSL   0.02  HO2                      
      RKI(102) = 0.1660E-16* EXP( 1044.00/TEMP) * PATMOT2
C
C 103 ADDC  O3        ->      CSL         HO                                   
      RKI(103) = 0.5000E-10 * PATMOT2
C
C 104 ACO3  NO2       ->      PAN                                              
        TMP0 = 0.9700E-28*(TO300)**(  -5.600)
        TMPI = 0.9300E-11*(TO300)**(  -1.500)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI(104) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C   first order reaction
C
C 105 PAN             ->      ACO3        NO2                                  
        TMP0 = 0.9700E-28*(TO300)**(  -5.600)
        TMPI = 0.9300E-11*(TO300)**(  -1.500)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
        TMPF = (TMPM/(1. + TMPR))*0.6**TMPE
        TMPQ = 0.8600E-28*EXP( 13954.0    /TEMP)
      RKI(105) = (TMPF/TMPQ) * 1. * 60.
C
C 106 TCO3  NO2       ->      TPAN                                             
        TMP0 = 0.9700E-28*(TO300)**(  -5.600)
        TMPI = 0.9300E-11*(TO300)**(  -1.500)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
      RKI(106) = ((TMPM/(1. + TMPR))*0.6**TMPE) * PATMOT2
C
C     first order reaction
C
C 107 TPAN            ->      TCO3        NO2                                  
        TMP0 = 0.9700E-28*(TO300)**(  -5.600)
        TMPI = 0.9300E-11*(TO300)**(  -1.500)
        TMPM = TMP0 * CM
        TMPR = TMPM/TMPI
        TMPE = (1. + (LOG10(TMPR)**2))**(-1)
        TMPF = (TMPM/(1. + TMPR))*0.6**TMPE
        TMPQ = 0.8600E-28*EXP( 13954.0    /TEMP)
      RKI(107) = (TMPF/TMPQ) * 1. * 60.
C
C 108 MO2   NO        ->      HCHO        HO2         NO2                      
      RKI(108) = 0.4200E-11* EXP( 180.000/TEMP) * PATMOT2
C
C 109 ETHP  NO        ->      ALD         HO2         NO2                      
      RKI(109) = 0.8700E-11 * PATMOT2
C
C 110 HC3P  NO        -> .047 HCHO   .233 ALD   .623  KET                      
C &                      .063 GLY    .742 HO2   .150  MO2               
C &                      .048 ETHP   .048 XO2   .059  ONIT              
C &                      .941 NO2                                       
      RKI(110) = 0.4000E-11 * PATMOT2
C
C
C     FIRST 110
C
C 111 HC5P  NO        -> .021 HCHO   .211 ALD   .722  KET                      
C &                      .599 HO2    .031 MO2   .245  ETHP              
C &                      .334 XO2    .124 ONIT  .876  NO2               
      RKI(111) = 0.4000E-11 * PATMOT2
C
C 112 HC8P  NO        -> .150 ALD    .642 KET   .133  ETHP                     
C &                      .261 ONIT   .739 NO2   .606  HO2               
C &                      .416 XO2                                       
      RKI(112) = 0.4000E-11 * PATMOT2
C
C 113 ETEP  NO        -> 1.6  HCHO        HO2         NO2                      
C &                      0.2  ALD                                       
      RKI(113) = 0.9000E-11 * PATMOT2
C
C 114 OLTP  NO        -> 0.94 ALD         HCHO        HO2                      
C &                           NO2    0.06 KET                           
      RKI(114) = 0.4000E-11 * PATMOT2
C
C 115 OLIP  NO        ->      HO2    1.71 ALD   0.29  KET                      
C &                           NO2                                       
      RKI(115) = 0.4000E-11 * PATMOT2
C
C 116 ISOP  NO        -> .446 MACR   .354 OLT   .847  HO2                      
C &                      .847 NO2    .153 ONIT  .606  HCHO              
      RKI(116) = 0.4000E-11 * PATMOT2
C
C 117 APIP  NO        -> 0.80 HO2    0.80 ALD   0.80  NO2                      
C &                      0.80 KET    0.20 ONIT                          
      RKI(117) = 0.4000E-11 * PATMOT2
C
C 118 LIMP  NO        -> 0.65 HO2    0.40 MACR  0.25  OLI                      
C &                      0.25 HCHO   0.65 NO2   0.35  ONIT              
      RKI(118) = 0.4000E-11 * PATMOT2
C
C 119 TOLP  NO        -> 0.95 NO2    0.95 HO2   1.20  GLY                      
C &                      0.50 DCB    0.05 ONIT  0.65  MGLY              
      RKI(119) = 0.4000E-11 * PATMOT2
C
C 120 XYLP  NO        -> 0.95 NO2    0.95 HO2   0.35  GLY                      
C &                      0.95 DCB    0.05 ONIT  0.60  MGLY              
      RKI(120) = 0.4000E-11 * PATMOT2
C
C
C     FIRST 120
C
C 121 CSLP  NO        ->      GLY         MGLY        NO2                      
C &                           HO2                                       
      RKI(121) = 0.4000E-11 * PATMOT2
C
C 122 ACO3  NO        ->      MO2         NO2                                  
      RKI(122) = 0.2000E-10 * PATMOT2
C
C 123 TCO3  NO        ->      NO2         ACO3        HCHO                     
      RKI(123) = 0.2000E-10 * PATMOT2
C
C 124 KETP  NO        -> 0.54 MGLY   0.46 ALD   0.23  ACO3                     
C &                      0.77 HO2    0.16 XO2         NO2               
      RKI(124) = 0.4000E-11 * PATMOT2
C
C 125 OLNN  NO        ->      ONIT        NO2         HO2                      
      RKI(125) = 0.4000E-11 * PATMOT2
C
C 126 OLND  NO        -> .287 HCHO   1.24 ALD   .464  KET                      
C &                      2.00 NO2                                       
      RKI(126) = 0.4000E-11 * PATMOT2
C
C 127 MO2   HO2       ->      OP1                                              
      RKI(127) = 0.3800E-12* EXP( 800.000/TEMP) * PATMOT2
C
C 128 ETHP  HO2       ->      OP2                                              
      RKI(128) = 0.7500E-12* EXP( 700.000/TEMP) * PATMOT2
C
C 129 HC3P  HO2       ->      OP2                                              
      RKI(129) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 130 HC5P  HO2       ->      OP2                                              
      RKI(130) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2

C
C     FIRST 130
C
C 131 HC8P  HO2       ->      OP2                                              
      RKI(131) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 132 ETEP  HO2       ->      OP2                                              
      RKI(132) = 0.1900E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 133 OLTP  HO2       ->      OP2                                              
      RKI(133) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 134 OLIP  HO2       ->      OP2                                              
      RKI(134) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 135 ISOP  HO2       ->      OP2                                              
      RKI(135) = 0.1280E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 136 APIP  HO2       ->      OP2                                              
      RKI(136) = 0.1500E-10 * PATMOT2
C
C 137 LIMP  HO2       ->      OP2                                              
      RKI(137) = 0.1500E-10 * PATMOT2
C
C 138 TOLP  HO2       ->      OP2                                              
      RKI(138) = 0.3750E-12* EXP( 980.000/TEMP) * PATMOT2
C
C 139 XYLP  HO2       ->      OP2                                              
      RKI(139) = 0.3750E-12* EXP( 980.000/TEMP) * PATMOT2
C
C 140 CSLP  HO2       ->      OP2                                              
      RKI(140) = 0.3750E-12* EXP( 980.000/TEMP) * PATMOT2
C
C
C     FIRST 140
C
C 141 ACO3  HO2       ->      PAA                                              
      RKI(141) = 0.1150E-11* EXP( 550.000/TEMP) * PATMOT2
C
C 142 ACO3  HO2       ->      ORA2        O3                                   
      RKI(142) = 0.3860E-15* EXP( 2640.00/TEMP) * PATMOT2
C
C 143 TCO3  HO2       ->      OP2                                              
      RKI(143) = 0.1150E-11* EXP( 550.000/TEMP) * PATMOT2
C
C 144 TCO3  HO2       ->      ORA2        O3                                   
      RKI(144) = 0.3860E-15* EXP( 2640.00/TEMP) * PATMOT2
C
C 145 KETP  HO2       ->      OP2                                              
      RKI(145) = 0.1150E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 146 OLNN  HO2       ->      ONIT                                             
      RKI(146) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 147 OLND  HO2       ->      ONIT                                             
      RKI(147) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 148 MO2   MO2       -> 1.33 HCHO   0.66 HO2                                  
      RKI(148) = 0.9100E-13* EXP( 416.000/TEMP) * PATMOT2
C
C 149 ETHP  MO2       -> 0.75 HCHO        HO2   0.75  ALD                      
      RKI(149) = 0.1180E-12* EXP( 158.000/TEMP) * PATMOT2
C
C 150 HC3P  MO2       -> .810 HCHO   .992 HO2   .580  ALD                      
C &                      .018 KET    .007 MO2   .005  MGLY              
C &                      .085 XO2    .119 GLY                           
      RKI(150) = 0.9460E-13* EXP( 431.000/TEMP) * PATMOT2
C
C
C     FIRST 150
C
C 151 HC5P  MO2       -> .829 HCHO   .946 HO2   .523  ALD                      
C &                      .240 KET    .014 ETHP  .245  XO2               
C &                      .049 MO2                                       
      RKI(151) = 0.1000E-12* EXP( 467.000/TEMP) * PATMOT2
C
C 152 HC8P  MO2       -> .753 HCHO   .993 HO2   .411  ALD                      
C &                      .419 KET    .322 XO2   .013  ETHP              
      RKI(152) = 0.4340E-13* EXP( 633.000/TEMP) * PATMOT2
C
C 153 ETEP  MO2       -> 1.55 HCHO        HO2   0.35  ALD                      
      RKI(153) = 0.1710E-12* EXP( 708.000/TEMP) * PATMOT2
C
C 154 OLTP  MO2       -> 1.25 HCHO        HO2   .669  ALD                      
C &                      .081 KET                                       
      RKI(154) = 0.1460E-12* EXP( 708.000/TEMP) * PATMOT2
C
C 155 OLIP  MO2       -> .755 HCHO        HO2   .932  ALD                      
C &                      .313 KET                                       
      RKI(155) = 0.9180E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 156 ISOP  MO2       -> .550 MACR   .370 OLT         HO2                      
C &                      .080 OLI    1.09 HCHO                          
      RKI(156) = 0.1360E-12* EXP( 708.000/TEMP) * PATMOT2
C
C 157 APIP  MO2       -> 2.00 HO2         ALD         HCHO                     
C &                           KET                                       
      RKI(157) = 0.3560E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 158 LIMP  MO2       -> 2.00 HO2    0.60 MACR  0.40  OLI                      
C &                      1.40 HCHO                                      
      RKI(158) = 0.3560E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 159 TOLP  MO2       ->      HCHO        HO2   0.65  GLY                      
C &                           DCB    0.35 MGLY                          
      RKI(159) = 0.3560E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 160 XYLP  MO2       ->      HCHO        HO2   0.37  GLY                      
C &                           DCB    0.63 MGLY                          
      RKI(160) = 0.3560E-13* EXP( 708.000/TEMP) * PATMOT2
C
C
C     FIRST 160
C
C 161 CSLP  MO2       ->      GLY         MGLY   2.00 HO2                      
C &                           HCHO                                      
      RKI(161) = 0.3560E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 162 ACO3  MO2       ->      HCHO        HO2         MO2                      
      RKI(162) = 0.3210E-10* EXP(-440.000/TEMP) * PATMOT2
C
C 163 ACO3  MO2       ->      HCHO        ORA2                                 
      RKI(163) = 0.2680E-15* EXP( 2510.00/TEMP) * PATMOT2
C
C 164 TCO3  MO2       ->      ACO3   2.00 HCHO        HO2                      
      RKI(164) = 0.3210E-10* EXP(-440.000/TEMP) * PATMOT2
C
C 165 TCO3  MO2       ->      HCHO        ORA2                                 
      RKI(165) = 0.2680E-15* EXP( 2510.00/TEMP) * PATMOT2
C
C 166 KETP  MO2       -> 0.40 MGLY   0.30 ALD   0.30  HKET                     
C &                      0.88 HO2    0.08 XO2   0.12  ACO3              
C &                      0.75 HCHO                                      
      RKI(166) = 0.6910E-12* EXP( 508.000/TEMP) * PATMOT2
C
C 167 OLNN  MO2       -> 0.75 HCHO        HO2         ONIT                     
      RKI(167) = 0.1600E-12* EXP( 708.000/TEMP) * PATMOT2
C
C 168 OLND  MO2       -> .960 HCHO   .500 HO2   .640  ALD                      
C &                      .149 KET    .500 NO2   .500  ONIT              
      RKI(168) = 0.9680E-13* EXP( 708.000/TEMP) * PATMOT2
C
C 169 ETHP  ACO3      ->      ALD    .500 HO2   0.5   MO2                      
C &                      0.5  ORA2                                      
      RKI(169) = 0.1030E-11* EXP( 211.000/TEMP) * PATMOT2
C
C 170 HC3P  ACO3      -> .724 ALD    .127 KET   .488  HO2                      
C &                      .508 MO2    .499 ORA2  .091  HCHO              
C &                      .006 ETHP   .071 XO2   .004  MGLY              
C &                      .100 GLY                                       
      RKI(170) = 0.6900E-12* EXP( 460.000/TEMP) * PATMOT2
C
C
C     FIRST 170
C
C 171 HC5P  ACO3      -> .677 ALD    .330 KET   .438  HO2                      
C &                      .554 MO2    .495 ORA2  .076  HCHO              
C &                      .018 ETHP   .237 XO2                           
      RKI(171) = 0.5590E-12* EXP( 522.000/TEMP) * PATMOT2
C
C 172 HC8P  ACO3      -> .497 ALD    .581 KET   .489  HO2                      
C &                      .507 MO2    .495 ORA2  .015  ETHP              
C &                      .318 XO2                                       
      RKI(172) = 0.2470E-12* EXP( 683.000/TEMP) * PATMOT2
C
C 173 ETEP  ACO3      -> 0.8  HCHO   0.6  ALD   0.5   HO2                      
C &                      0.5  MO2    0.5  ORA2                          
      RKI(173) = 0.9480E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 174 OLTP  ACO3      -> .859 ALD    .501 HCHO  .501  HO2                      
C &                      .501 MO2    .499 ORA2  .141  KET               
      RKI(174) = 0.8110E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 175 OLIP  ACO3      -> .941 ALD    .510 HO2   .510  MO2                      
C &                      .569 KET    .490 ORA2                          
      RKI(175) = 0.5090E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 176 ISOP  ACO3      -> .771 MACR   .229 OLT   .506  HO2                      
C &                      .494 ORA2   .340 HCHO  .506  MO2               
      RKI(176) = 0.7600E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 177 APIP  ACO3      ->      HO2         ALD         MO2                      
C &                           KET                                       
      RKI(177) = 0.7400E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 178 LIMP  ACO3      ->      HO2    0.60 MACR  0.40  OLI                      
C &                      0.40 HCHO        MO2                           
      RKI(178) = 0.7400E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 179 TOLP  ACO3      ->      MO2         HO2         DCB                      
C &                      0.65 GLY    0.35 MGLY                          
      RKI(179) = 0.7400E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 180 XYLP  ACO3      ->      MO2         HO2         DCB                      
C &                      0.37 GLY    0.63 MGLY                          
      RKI(180) = 0.7400E-12* EXP( 765.000/TEMP) * PATMOT2
C
C
C     FIRST 180
C
C 181 CSLP  ACO3      ->      GLY         MGLY        HO2                      
C &                           MO2                                       
      RKI(181) = 0.7400E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 182 ACO3  ACO3      ->  2.0 MO2                                              
      RKI(182) = 0.2800E-11* EXP( 530.000/TEMP) * PATMOT2
C
C 183 TCO3  ACO3      ->      MO2         ACO3        HCHO                     
      RKI(183) = 0.2800E-11* EXP( 530.000/TEMP) * PATMOT2
C
C 184 KETP  ACO3      -> 0.54 MGLY   0.35 ALD   0.11  KET                      
C &                      0.12 ACO3   0.38 HO2   0.08  XO2               
C &                      0.50 MO2    0.50 ORA2                          
      RKI(184) = 0.7510E-12* EXP( 565.000/TEMP) * PATMOT2
C
C 185 OLNN  ACO3      ->      ONIT   0.50 MO2   0.50  ORA2                     
C &                      0.50 HO2                                       
      RKI(185) = 0.8850E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 186 OLND  ACO3      -> .207 HCHO   .650 ALD   .167  KET                      
C &                      .516 MO2    .484 ORA2  .484  ONIT              
C &                      .516 NO2                                       
      RKI(186) = 0.5370E-12* EXP( 765.000/TEMP) * PATMOT2
C
C 187 OLNN  OLNN      -> 2.00 ONIT        HO2                                  
      RKI(187) = 0.7000E-13* EXP( 1000.00/TEMP) * PATMOT2
C
C 188 OLNN  OLND      -> .202 HCHO   .640 ALD   .149  KET                      
C &                      .500 HO2    .500 NO2   1.50  ONIT              
      RKI(188) = 0.4250E-13* EXP( 1000.00/TEMP) * PATMOT2
C
C 189 OLND  OLND      -> .504 HCHO   1.21 ALD   .285  KET                      
C &                           ONIT        NO2                           
      RKI(189) = 0.2960E-13* EXP( 1000.00/TEMP) * PATMOT2
C
C 190 MO2   NO3       ->      HCHO        HO2         NO2                      
      RKI(190) = 0.1200E-11 * PATMOT2
C
C
C     FIRST 190
C
C 191 ETHP  NO3       ->      ALD         HO2         NO2                      
      RKI(191) = 0.1200E-11 * PATMOT2
C
C 192 HC3P  NO3       -> .048 HCHO   .243 ALD   .670  KET                      
C &                      .063 GLY    .792 HO2   .155  MO2               
C &                      .053 ETHP   .051 XO2         NO2               
      RKI(192) = 0.1200E-11 * PATMOT2
C
C 193 HC5P  NO3       -> .021 HCHO   .239 ALD   .828  KET                      
C &                      .699 HO2    .040 MO2   .262  ETHP              
C &                      .391 XO2         NO2                           
      RKI(193) = 0.1200E-11 * PATMOT2
C
C 194 HC8P  NO3       -> .187 ALD    .880 KET   .155  ETHP                     
C &                           NO2    .845 HO2   .587  XO2               
      RKI(194) = 0.1200E-11 * PATMOT2
C
C 195 ETEP  NO3       -> 1.6  HCHO        HO2         NO2                      
C &                      0.2  ALD                                       
      RKI(195) = 0.1200E-11 * PATMOT2
C
C 196 OLTP  NO3       -> 0.94 ALD         HCHO        HO2                      
C &                           NO2    0.06 KET                           
      RKI(196) = 0.1200E-11 * PATMOT2
C
C 197 OLIP  NO3       ->      HO2    1.71 ALD   0.29  KET                      
C &                           NO2                                       
      RKI(197) = 0.1200E-11 * PATMOT2
C
C 198 ISOP  NO3       -> .600 MACR   .400 OLT         HO2                      
C &                           NO2    .686 HCHO                          
      RKI(198) = 0.1200E-11 * PATMOT2
C
C 199 APIP  NO3       ->      HO2         ALD         NO2                      
C &                           KET                                       
      RKI(199) = 0.1200E-11 * PATMOT2
C
C 200 LIMP  NO3       ->      HO2    0.60 MACR  0.40  OLI                      
C &                      0.40 HCHO        NO2                           
      RKI(200) = 0.1200E-11 * PATMOT2
C
C
C     FIRST 200
C
C 201 TOLP  NO3       ->      NO2         HO2   0.50  DCB                      
C &                      1.30 GLY    0.70 MGLY                          
      RKI(201) = 0.1200E-11 * PATMOT2
C
C 202 XYLP  NO3       ->      NO2         HO2         DCB                      
C &                      0.74 GLY    1.26 MGLY                          
      RKI(202) = 0.1200E-11 * PATMOT2
C
C 203 CSLP  NO3       ->      GLY         MGLY        NO2                      
C &                           HO2                                       
      RKI(203) = 0.1200E-11 * PATMOT2
C
C 204 ACO3  NO3       ->      MO2         NO2                                  
      RKI(204) = 0.4000E-11 * PATMOT2
C
C 205 TCO3  NO3       ->      NO2         ACO3        HCHO                     
      RKI(205) = 0.4000E-11 * PATMOT2
C
C 206 KETP  NO3       -> 0.54 MGLY   0.46 ALD   0.23  ACO3                     
C &                      0.77 HO2    0.16 XO2         NO2               
      RKI(206) = 0.1200E-11 * PATMOT2
C
C 207 OLNN  NO3       ->      ONIT        NO2         HO2                      
      RKI(207) = 0.1200E-11 * PATMOT2
C
C 208 OLND  NO3       -> .280 HCHO   1.24 ALD   .469  KET                      
C &                      2.00 NO2                                       
      RKI(208) = 0.1200E-11 * PATMOT2
C
C 209 XO2   HO2       ->      OP2                                              
      RKI(209) = 0.1660E-12* EXP( 1300.00/TEMP) * PATMOT2
C
C 210 XO2   MO2       ->      HCHO        HO2                                  
      RKI(210) = 0.5990E-14* EXP( 1510.00/TEMP) * PATMOT2
C
C
C     FIRST 210
C
C 211 XO2   ACO3      ->      MO2                                              
      RKI(211) = 0.3400E-13* EXP( 1560.00/TEMP) * PATMOT2
C
C 212 XO2   XO2       ->                                                       
      RKI(212) = 0.7130E-16* EXP( 2950.00/TEMP) * PATMOT2
C
C 213 XO2   NO        ->      NO2                                              
      RKI(213) = 0.4000E-11 * PATMOT2
C
C 214 XO2   NO3       ->      NO2                                              
      RKI(214) = 0.1200E-11 * PATMOT2
      
C
C     RETURN
      END


      SUBROUTINE CRJK
C---------------------------------------------------------------------------
C DATE 10/14/97   WILLIAM R. STOCKWELL
C                 COMPUTE CRJ & CRK BE USED IN  PORDLOSS, NOXOX, AND HOXHNOX
C                 ROUTINES.  MOST OF THE TERMS REMAIN UNCHANGED IN
C                 NEWTON-RAPHSON ITERATION, THEREFORE, NEED NOT BE RECOMPUTED
C---------------------------------------------------------------------------
C
      INCLUDE "a_params.com"
      SAVE
      
C
C BEGIN OF PHOTOLYTIC SPECIES
C
      CRJ(  1) = RJI(  1) * YC(LNO2 )
      CRJ(  2) = RJI(  2) * YC(LO3  )
      CRJ(  3) = RJI(  3) * YC(LO3  )
      CRJ(  4) = RJI(  4) * YC(LHONO)
      CRJ(  5) = RJI(  5) * YC(LHNO3)
      CRJ(  6) = RJI(  6) * YC(LHNO4)
      CRJ(  7) = RJI(  7) * YC(LNO3 )
      CRJ(  8) = RJI(  8) * YC(LNO3 )
      CRJ(  9) = RJI(  9) * YC(LH2O2)
      CRJ( 10) = RJI( 10) * YC(LHCHO)
      CRJ( 11) = RJI( 11) * YC(LHCHO)
      CRJ( 12) = RJI( 12) * YC(LALD )
      CRJ( 13) = RJI( 13) * YC(LOP1 )
      CRJ( 14) = RJI( 14) * YC(LOP2 )
      CRJ( 15) = RJI( 15) * YC(LPAA )
      CRJ( 16) = RJI( 16) * YC(LKET )
      CRJ( 17) = RJI( 17) * YC(LGLY )
      CRJ( 18) = RJI( 18) * YC(LGLY )
      CRJ( 19) = RJI( 19) * YC(LMGLY)
      CRJ( 20) = RJI( 20) * YC(LDCB )
      CRJ( 21) = RJI( 21) * YC(LONIT)
      CRJ( 22) = RJI( 22) * YC(LMACR)
      CRJ( 23) = RJI( 23) * YC(LHKET)
C
C END OF PHOTOLYTIC SPECIES
C
C BEGIN THERMAL SPECIES
C
      CRK(  1) = RKI(  1) * YC(LO3P ) * YC(LO2  )
      CRK(  2) = RKI(  2) * YC(LO3P ) * YC(LO3  )
      CRK(  3) = RKI(  3) * YC(LO1D ) * YC(LN2  )
      CRK(  4) = RKI(  4) * YC(LO1D ) * YC(LO2  )
      CRK(  5) = RKI(  5) * YC(LO1D ) * YC(LH2O )
      CRK(  6) = RKI(  6) * YC(LO3  ) * YC(LHO  )
      CRK(  7) = RKI(  7) * YC(LO3  ) * YC(LHO2 )
      CRK(  8) = RKI(  8) * YC(LHO  ) * YC(LHO2 )
      CRK(  9) = RKI(  9) * YC(LH2O2) * YC(LHO  )
      CRK( 10) = RKI( 10) * YC(LHO2 ) * YC(LHO2 )
C
C     FIRST 10
C
      CRK( 11) = RKI( 11) * YC(LHO2 ) * YC(LHO2 ) * YC(LH2O )
      CRK( 12) = RKI( 12) * YC(LO3P ) * YC(LNO  )
      CRK( 13) = RKI( 13) * YC(LO3P ) * YC(LNO2 )
      CRK( 14) = RKI( 14) * YC(LO3P ) * YC(LNO2 )
      CRK( 15) = RKI( 15) * YC(LHO  ) * YC(LNO  )
      CRK( 16) = RKI( 16) * YC(LHO  ) * YC(LNO2 )
      CRK( 17) = RKI( 17) * YC(LHO  ) * YC(LNO3 )
      CRK( 18) = RKI( 18) * YC(LHO2 ) * YC(LNO  )
      CRK( 19) = RKI( 19) * YC(LHO2 ) * YC(LNO2 )
      CRK( 20) = RKI( 20) * YC(LHNO4)
C
C     FIRST 20
C
      CRK( 21) = RKI( 21) * YC(LHO2 ) * YC(LNO3 )
      CRK( 22) = RKI( 22) * YC(LHO  ) * YC(LHONO)
      CRK( 23) = RKI( 23) * YC(LHO  ) * YC(LHNO3)
      CRK( 24) = RKI( 24) * YC(LHO  ) * YC(LHNO4)
      CRK( 25) = RKI( 25) * YC(LO3  ) * YC(LNO  )
      CRK( 26) = RKI( 26) * YC(LO3  ) * YC(LNO2 )
      CRK( 27) = RKI( 27) * YC(LNO  ) * YC(LNO  ) * YC(LO2  )
      CRK( 28) = RKI( 28) * YC(LNO3 ) * YC(LNO  )
      CRK( 29) = RKI( 29) * YC(LNO3 ) * YC(LNO2 )
      CRK( 30) = RKI( 30) * YC(LNO3 ) * YC(LNO2 )
C
C     FIRST 30
C
      CRK( 31) = RKI( 31) * YC(LN2O5)
      CRK( 32) = RKI( 32) * YC(LNO3 ) * YC(LNO3 )
      CRK( 33) = RKI( 33) * YC(LHO  ) * YC(LH2  )
      CRK( 34) = RKI( 34) * YC(LHO  ) * YC(LSO2 )
      CRK( 35) = RKI( 35) * YC(LCO  ) * YC(LHO  )
      CRK( 36) = RKI( 36) * YC(LISO ) * YC(LO3P )
      CRK( 37) = RKI( 37) * YC(LMACR) * YC(LO3P )
      CRK( 38) = RKI( 38) * YC(LCH4 ) * YC(LHO  )
      CRK( 39) = RKI( 39) * YC(LETH ) * YC(LHO  )
      CRK( 40) = RKI( 40) * YC(LHC3 ) * YC(LHO  )
C
C     FIRST 40
C
      CRK( 41) = RKI( 41) * YC(LHC5 ) * YC(LHO  )
      CRK( 42) = RKI( 42) * YC(LHC8 ) * YC(LHO  )
      CRK( 43) = RKI( 43) * YC(LETE ) * YC(LHO  )
      CRK( 44) = RKI( 44) * YC(LOLT ) * YC(LHO  )
      CRK( 45) = RKI( 45) * YC(LOLI ) * YC(LHO  )
      CRK( 46) = RKI( 46) * YC(LDIEN) * YC(LHO  )
      CRK( 47) = RKI( 47) * YC(LISO ) * YC(LHO  )
      CRK( 48) = RKI( 48) * YC(LAPI ) * YC(LHO  )
      CRK( 49) = RKI( 49) * YC(LLIM ) * YC(LHO  )
      CRK( 50) = RKI( 50) * YC(LTOL ) * YC(LHO  )
C
C     FIRST 50
C
      CRK( 51) = RKI( 51) * YC(LXYL ) * YC(LHO  )
      CRK( 52) = RKI( 52) * YC(LCSL ) * YC(LHO  )
      CRK( 53) = RKI( 53) * YC(LHCHO) * YC(LHO  )
      CRK( 54) = RKI( 54) * YC(LALD ) * YC(LHO  )
      CRK( 55) = RKI( 55) * YC(LKET ) * YC(LHO  )
      CRK( 56) = RKI( 56) * YC(LHKET) * YC(LHO  )
      CRK( 57) = RKI( 57) * YC(LGLY ) * YC(LHO  )
      CRK( 58) = RKI( 58) * YC(LMGLY) * YC(LHO  )
      CRK( 59) = RKI( 59) * YC(LMACR) * YC(LHO  )
      CRK( 60) = RKI( 60) * YC(LHO  ) * YC(LDCB )
C
C     FIRST 60
C
      CRK( 61) = RKI( 61) * YC(LHO  ) * YC(LUDD )
      CRK( 62) = RKI( 62) * YC(LOP1 ) * YC(LHO  )
      CRK( 63) = RKI( 63) * YC(LOP2 ) * YC(LHO  )
      CRK( 64) = RKI( 64) * YC(LPAA ) * YC(LHO  )
      CRK( 65) = RKI( 65) * YC(LPAN ) * YC(LHO  )
      CRK( 66) = RKI( 66) * YC(LTPAN) * YC(LHO  )
      CRK( 67) = RKI( 67) * YC(LONIT) * YC(LHO  )
      CRK( 68) = RKI( 68) * YC(LHCHO) * YC(LNO3 )
      CRK( 69) = RKI( 69) * YC(LALD ) * YC(LNO3 )
      CRK( 70) = RKI( 70) * YC(LGLY ) * YC(LNO3 )
C
C     FIRST 70
C
      CRK( 71) = RKI( 71) * YC(LMGLY) * YC(LNO3 )
      CRK( 72) = RKI( 72) * YC(LMACR) * YC(LNO3 )
      CRK( 73) = RKI( 73) * YC(LDCB ) * YC(LNO3 )
      CRK( 74) = RKI( 74) * YC(LCSL ) * YC(LNO3 )
      CRK( 75) = RKI( 75) * YC(LETE ) * YC(LNO3 )
      CRK( 76) = RKI( 76) * YC(LOLT ) * YC(LNO3 )
      CRK( 77) = RKI( 77) * YC(LOLI ) * YC(LNO3 )
      CRK( 78) = RKI( 78) * YC(LDIEN) * YC(LNO3 )
      CRK( 79) = RKI( 79) * YC(LISO ) * YC(LNO3 )
      CRK( 80) = RKI( 80) * YC(LAPI ) * YC(LNO3 )
C
C     FIRST 80
C
      CRK( 81) = RKI( 81) * YC(LLIM ) * YC(LNO3 )
      CRK( 82) = RKI( 82) * YC(LTPAN) * YC(LNO3 )
      CRK( 83) = RKI( 83) * YC(LETE ) * YC(LO3  )
      CRK( 84) = RKI( 84) * YC(LOLT ) * YC(LO3  )
      CRK( 85) = RKI( 85) * YC(LOLI ) * YC(LO3  )
      CRK( 86) = RKI( 86) * YC(LDIEN) * YC(LO3  )
      CRK( 87) = RKI( 87) * YC(LISO ) * YC(LO3  )
      CRK( 88) = RKI( 88) * YC(LAPI ) * YC(LO3  )
      CRK( 89) = RKI( 89) * YC(LLIM ) * YC(LO3  )
      CRK( 90) = RKI( 90) * YC(LMACR) * YC(LO3  )
C
C     FIRST 90
C
      CRK( 91) = RKI( 91) * YC(LDCB ) * YC(LO3  )
      CRK( 92) = RKI( 92) * YC(LTPAN) * YC(LO3  )
      CRK( 93) = RKI( 93) * YC(LPHO ) * YC(LNO2 )
      CRK( 94) = RKI( 94) * YC(LPHO ) * YC(LHO2 )
      CRK( 95) = RKI( 95) * YC(LADDT) * YC(LNO2 )
      CRK( 96) = RKI( 96) * YC(LADDT) * YC(LO2  )
      CRK( 97) = RKI( 97) * YC(LADDT) * YC(LO3  )
      CRK( 98) = RKI( 98) * YC(LADDX) * YC(LNO2 )
      CRK( 99) = RKI( 99) * YC(LADDX) * YC(LO2  )
      CRK(100) = RKI(100) * YC(LADDX) * YC(LO3  )
C
C     FIRST 100
C
      CRK(101) = RKI(101) * YC(LADDC) * YC(LNO2 )
      CRK(102) = RKI(102) * YC(LADDC) * YC(LO2  )
      CRK(103) = RKI(103) * YC(LADDC) * YC(LO3  )
      CRK(104) = RKI(104) * YC(LACO3) * YC(LNO2 )
      CRK(105) = RKI(105) * YC(LPAN )
      CRK(106) = RKI(106) * YC(LTCO3) * YC(LNO2 )
      CRK(107) = RKI(107) * YC(LTPAN)
      CRK(108) = RKI(108) * YC(LMO2 ) * YC(LNO  )
      CRK(109) = RKI(109) * YC(LETHP) * YC(LNO  )
      CRK(110) = RKI(110) * YC(LHC3P) * YC(LNO  )
C
C     FIRST 110
C
      CRK(111) = RKI(111) * YC(LHC5P) * YC(LNO  )
      CRK(112) = RKI(112) * YC(LHC8P) * YC(LNO  )
      CRK(113) = RKI(113) * YC(LETEP) * YC(LNO  )
      CRK(114) = RKI(114) * YC(LOLTP) * YC(LNO  )
      CRK(115) = RKI(115) * YC(LOLIP) * YC(LNO  )
      CRK(116) = RKI(116) * YC(LISOP) * YC(LNO  )
      CRK(117) = RKI(117) * YC(LAPIP) * YC(LNO  )
      CRK(118) = RKI(118) * YC(LLIMP) * YC(LNO  )
      CRK(119) = RKI(119) * YC(LTOLP) * YC(LNO  )
      CRK(120) = RKI(120) * YC(LXYLP) * YC(LNO  )
C
C     FIRST 120
C
      CRK(121) = RKI(121) * YC(LCSLP) * YC(LNO  )
      CRK(122) = RKI(122) * YC(LACO3) * YC(LNO  )
      CRK(123) = RKI(123) * YC(LTCO3) * YC(LNO  )
      CRK(124) = RKI(124) * YC(LKETP) * YC(LNO  )
      CRK(125) = RKI(125) * YC(LOLNN) * YC(LNO  )
      CRK(126) = RKI(126) * YC(LOLND) * YC(LNO  )
      CRK(127) = RKI(127) * YC(LMO2 ) * YC(LHO2 )
      CRK(128) = RKI(128) * YC(LETHP) * YC(LHO2 )
      CRK(129) = RKI(129) * YC(LHC3P) * YC(LHO2 )
      CRK(130) = RKI(130) * YC(LHC5P) * YC(LHO2 )
C
C     FIRST 130
C
      CRK(131) = RKI(131) * YC(LHC8P) * YC(LHO2 )
      CRK(132) = RKI(132) * YC(LETEP) * YC(LHO2 )
      CRK(133) = RKI(133) * YC(LOLTP) * YC(LHO2 )
      CRK(134) = RKI(134) * YC(LOLIP) * YC(LHO2 )
      CRK(135) = RKI(135) * YC(LISOP) * YC(LHO2 )
      CRK(136) = RKI(136) * YC(LAPIP) * YC(LHO2 )
      CRK(137) = RKI(137) * YC(LLIMP) * YC(LHO2 )
      CRK(138) = RKI(138) * YC(LTOLP) * YC(LHO2 )
      CRK(139) = RKI(139) * YC(LXYLP) * YC(LHO2 )
      CRK(140) = RKI(140) * YC(LCSLP) * YC(LHO2 )
C
C     FIRST 140
C
      CRK(141) = RKI(141) * YC(LACO3) * YC(LHO2 )
      CRK(142) = RKI(142) * YC(LACO3) * YC(LHO2 )
      CRK(143) = RKI(143) * YC(LTCO3) * YC(LHO2 )
      CRK(144) = RKI(144) * YC(LTCO3) * YC(LHO2 )
      CRK(145) = RKI(145) * YC(LKETP) * YC(LHO2 )
      CRK(146) = RKI(146) * YC(LOLNN) * YC(LHO2 )
      CRK(147) = RKI(147) * YC(LOLND) * YC(LHO2 )
      CRK(148) = RKI(148) * YC(LMO2 ) * YC(LMO2 )
      CRK(149) = RKI(149) * YC(LETHP) * YC(LMO2 )
      CRK(150) = RKI(150) * YC(LHC3P) * YC(LMO2 )
C
C     FIRST 150
C
      CRK(151) = RKI(151) * YC(LHC5P) * YC(LMO2 )
      CRK(152) = RKI(152) * YC(LHC8P) * YC(LMO2 )
      CRK(153) = RKI(153) * YC(LETEP) * YC(LMO2 )
      CRK(154) = RKI(154) * YC(LOLTP) * YC(LMO2 )
      CRK(155) = RKI(155) * YC(LOLIP) * YC(LMO2 )
      CRK(156) = RKI(156) * YC(LISOP) * YC(LMO2 )
      CRK(157) = RKI(157) * YC(LAPIP) * YC(LMO2 )
      CRK(158) = RKI(158) * YC(LLIMP) * YC(LMO2 )
      CRK(159) = RKI(159) * YC(LTOLP) * YC(LMO2 )
      CRK(160) = RKI(160) * YC(LXYLP) * YC(LMO2 )
C
C     FIRST 160
C
      CRK(161) = RKI(161) * YC(LCSLP) * YC(LMO2 )
      CRK(162) = RKI(162) * YC(LACO3) * YC(LMO2 )
      CRK(163) = RKI(163) * YC(LACO3) * YC(LMO2 )
      CRK(164) = RKI(164) * YC(LTCO3) * YC(LMO2 )
      CRK(165) = RKI(165) * YC(LTCO3) * YC(LMO2 )
      CRK(166) = RKI(166) * YC(LKETP) * YC(LMO2 )
      CRK(167) = RKI(167) * YC(LOLNN) * YC(LMO2 )
      CRK(168) = RKI(168) * YC(LOLND) * YC(LMO2 )
      CRK(169) = RKI(169) * YC(LETHP) * YC(LACO3)
      CRK(170) = RKI(170) * YC(LHC3P) * YC(LACO3)
C
C     FIRST 170
C
      CRK(171) = RKI(171) * YC(LHC5P) * YC(LACO3)
      CRK(172) = RKI(172) * YC(LHC8P) * YC(LACO3)
      CRK(173) = RKI(173) * YC(LETEP) * YC(LACO3)
      CRK(174) = RKI(174) * YC(LOLTP) * YC(LACO3)
      CRK(175) = RKI(175) * YC(LOLIP) * YC(LACO3)
      CRK(176) = RKI(176) * YC(LISOP) * YC(LACO3)
      CRK(177) = RKI(177) * YC(LAPIP) * YC(LACO3)
      CRK(178) = RKI(178) * YC(LLIMP) * YC(LACO3)
      CRK(179) = RKI(179) * YC(LTOLP) * YC(LACO3)
      CRK(180) = RKI(180) * YC(LXYLP) * YC(LACO3)
C
C     FIRST 180
C
      CRK(181) = RKI(181) * YC(LCSLP) * YC(LACO3)
      CRK(182) = RKI(182) * YC(LACO3) * YC(LACO3)
      CRK(183) = RKI(183) * YC(LTCO3) * YC(LACO3)
      CRK(184) = RKI(184) * YC(LKETP) * YC(LACO3)
      CRK(185) = RKI(185) * YC(LOLNN) * YC(LACO3)
      CRK(186) = RKI(186) * YC(LOLND) * YC(LACO3)
      CRK(187) = RKI(187) * YC(LOLNN) * YC(LOLNN)
      CRK(188) = RKI(188) * YC(LOLNN) * YC(LOLND)
      CRK(189) = RKI(189) * YC(LOLND) * YC(LOLND)
      CRK(190) = RKI(190) * YC(LMO2 ) * YC(LNO3 )
C
C     FIRST 190
C
      CRK(191) = RKI(191) * YC(LETHP) * YC(LNO3 )
      CRK(192) = RKI(192) * YC(LHC3P) * YC(LNO3 )
      CRK(193) = RKI(193) * YC(LHC5P) * YC(LNO3 )
      CRK(194) = RKI(194) * YC(LHC8P) * YC(LNO3 )
      CRK(195) = RKI(195) * YC(LETEP) * YC(LNO3 )
      CRK(196) = RKI(196) * YC(LOLTP) * YC(LNO3 )
      CRK(197) = RKI(197) * YC(LOLIP) * YC(LNO3 )
      CRK(198) = RKI(198) * YC(LISOP) * YC(LNO3 )
      CRK(199) = RKI(199) * YC(LAPIP) * YC(LNO3 )
      CRK(200) = RKI(200) * YC(LLIMP) * YC(LNO3 )
C
C     FIRST 200
C
      CRK(201) = RKI(201) * YC(LTOLP) * YC(LNO3 )
      CRK(202) = RKI(202) * YC(LXYLP) * YC(LNO3 )
      CRK(203) = RKI(203) * YC(LCSLP) * YC(LNO3 )
      CRK(204) = RKI(204) * YC(LACO3) * YC(LNO3 )
      CRK(205) = RKI(205) * YC(LTCO3) * YC(LNO3 )
      CRK(206) = RKI(206) * YC(LKETP) * YC(LNO3 )
      CRK(207) = RKI(207) * YC(LOLNN) * YC(LNO3 )
      CRK(208) = RKI(208) * YC(LOLND) * YC(LNO3 )
      CRK(209) = RKI(209) * YC(LXO2 ) * YC(LHO2 )
      CRK(210) = RKI(210) * YC(LXO2 ) * YC(LMO2 )
C
C     FIRST 210
C
      CRK(211) = RKI(211) * YC(LXO2 ) * YC(LACO3)
      CRK(212) = RKI(212) * YC(LXO2 ) * YC(LXO2 )
      CRK(213) = RKI(213) * YC(LXO2 ) * YC(LNO  )
      CRK(214) = RKI(214) * YC(LXO2 ) * YC(LNO3 )
      RETURN
      END


      SUBROUTINE DRY_DEPOSITION(TIMED, DTSTEP)
C--------------------------------------------------------------------------
C*****  FOR OPERATOR SPLITTING MODULE
C--------------------------------------------------------------------------
      INCLUDE 'a_params.com'
      SAVE
C
        DO 2 L = 1, LDRY
          LS = IDRY(L)
          YC(LS) = YC(LS) 
2       CONTINUE
C
      RETURN
      END
C--------------------------------------------------------------------------
C          CHEM BOX MODEL EMISSION RATE MODULE    
C--------------------------------------------------------------------------
       SUBROUTINE GET_EMISSION(EMTIME)
       INCLUDE "a_params.com"
       SAVE
C

C
       DO 1 L = 1, LEMIT
         LS = IEMIT(L)
         PRODSI(LS) = 0.            
1      CONTINUE
C
       RETURN
       END
C
      SUBROUTINE HOXHNOX( X, XDOT, PD, CNST_XDOT, CNST_PD, XCPO1D )
C---------------------------------------------------------------------      
C
C MODIFIED FOR HERTEL ET AL. SCHEME IN SOLVING THE HO, HO2, HONO,
C HONO4 AS A GROUPED SPECIES.  THE INPUT SPECIES SEQUENCE IS FIXED AS
C HO(1), HO2(2), HONO(3), AND HONO4(4)
C
C----------------------------------------------------------------------      
C
      INCLUDE "a_params.com"
      SAVE
      PARAMETER (ISOLVE = 4 )
      DIMENSION X(ISOLVE), XDOT(ISOLVE), PD(ISOLVE,ISOLVE)
      DIMENSION CNST_XDOT(ISOLVE), CNST_PD(ISOLVE,ISOLVE)
C
      IHO   = 1
      IHO2  = 2
      IHONO = 3
      IHNO4 = 4
C
C     PHOTOLYSIS REACTION

      AJ4  = RJI( 4) * X(IHONO)
      AJ6  = RJI( 6) * X(IHNO4)

C     THERMAL REACTIONS
      AK5 = RKI(  5) * XCPO1D    * YC(LH2O)
      AK6 = RKI(  6) * YC(LO3  ) * X(IHO  )
      AK7 = RKI(  7) * YC(LO3  ) * X(IHO2 )
      AK8 = RKI(  8) * X(IHO  )  * X(IHO2 )
      AK9 = RKI(  9) * YC(LH2O2) * X(IHO  )
      AK10 = RKI( 10) * X(IHO2 ) * X(IHO2 )
      AK11 = RKI( 11) * X(IHO2 ) * X(IHO2 ) * YC(LH2O )
      AK15 = RKI( 15) * X(IHO  ) * YC(LNO  )
      AK16 = RKI( 16) * X(IHO  ) * YC(LNO2 )
      AK17 = RKI( 17) * X(IHO  ) * YC(LNO3 )
      AK18 = RKI( 18) * X(IHO2 ) * YC(LNO  )
      AK19 = RKI( 19) * X(IHO2 ) * YC(LNO2 )
      AK20 = RKI( 20) * X(IHNO4)
      AK21 = RKI( 21) * X(IHO2 ) * YC(LNO3 )
      AK22 = RKI( 22) * X(IHO  ) * X(IHONO)
      AK23 = RKI( 23) * X(IHO  ) * YC(LHNO3)
      AK24 = RKI( 24) * X(IHO  ) * X(IHNO4)
      AK33 = RKI( 33) * X(IHO  ) * YC(LH2  )
      AK34 = RKI( 34) * X(IHO  ) * YC(LSO2 )
      AK35 = RKI( 35) * YC(LCO  ) * X(IHO  )
      AK38 = RKI( 38) * YC(LCH4 ) * X(IHO  )
      AK39 = RKI( 39) * YC(LETH ) * X(IHO  )
      AK40 = RKI( 40) * YC(LHC3 ) * X(IHO  )
      AK41 = RKI( 41) * YC(LHC5 ) * X(IHO  )
      AK42 = RKI( 42) * YC(LHC8 ) * X(IHO  )
      AK43 = RKI( 43) * YC(LETE ) * X(IHO  )
      AK44 = RKI( 44) * YC(LOLT ) * X(IHO  )
      AK45 = RKI( 45) * YC(LOLI ) * X(IHO  )
      AK46 = RKI( 46) * YC(LDIEN) * X(IHO  )
      AK47 = RKI( 47) * YC(LISO ) * X(IHO  )
      AK48 = RKI( 48) * YC(LAPI ) * X(IHO  )
      AK49 = RKI( 49) * YC(LLIM ) * X(IHO  )
      AK50 = RKI( 50) * YC(LTOL ) * X(IHO  )
      AK51 = RKI( 51) * YC(LXYL ) * X(IHO  )
      AK52 = RKI( 52) * YC(LCSL ) * X(IHO  )
      AK53 = RKI( 53) * YC(LHCHO) * X(IHO  )
      AK54 = RKI( 54) * YC(LALD ) * X(IHO  )
      AK55 = RKI( 55) * YC(LKET ) * X(IHO  )
      AK56 = RKI( 56) * YC(LHKET) * X(IHO  )
      AK57 = RKI( 57) * YC(LGLY ) * X(IHO  )
      AK58 = RKI( 58) * YC(LMGLY) * X(IHO  )
      AK59 = RKI( 59) * YC(LMACR) * X(IHO  )
      AK60 = RKI( 60) * X(IHO  ) * YC(LDCB )
      AK61 = RKI( 61) * X(IHO  ) * YC(LUDD )
      AK62 = RKI( 62) * YC(LOP1 ) * X(IHO  )
      AK63 = RKI( 63) * YC(LOP2 ) * X(IHO  )
      AK64 = RKI( 64) * YC(LPAA ) * X(IHO  )
      AK65 = RKI( 65) * YC(LPAN ) * X(IHO  )
      AK66 = RKI( 66) * YC(LTPAN) * X(IHO  )
      AK67 = RKI( 67) * YC(LONIT) * X(IHO  )
      AK94 = RKI( 94) * YC(LPHO ) * X(IHO2 )
      AK127 = RKI(127) * YC(LMO2 ) * X(IHO2 )
      AK128 = RKI(128) * YC(LETHP) * X(IHO2 )
      AK129 = RKI(129) * YC(LHC3P) * X(IHO2 )
      AK130 = RKI(130) * YC(LHC5P) * X(IHO2 )
      AK131 = RKI(131) * YC(LHC8P) * X(IHO2 )
      AK132 = RKI(132) * YC(LETEP) * X(IHO2 )
      AK133 = RKI(133) * YC(LOLTP) * X(IHO2 )
      AK134 = RKI(134) * YC(LOLIP) * X(IHO2 )
      AK135 = RKI(135) * YC(LISOP) * X(IHO2 )
      AK136 = RKI(136) * YC(LAPIP) * X(IHO2 )
      AK137 = RKI(137) * YC(LLIMP) * X(IHO2 )
      AK138 = RKI(138) * YC(LTOLP) * X(IHO2 )
      AK139 = RKI(139) * YC(LXYLP) * X(IHO2 )
      AK140 = RKI(140) * YC(LCSLP) * X(IHO2 )
      AK141 = RKI(141) * YC(LACO3) * X(IHO2 )
      AK142 = RKI(142) * YC(LACO3) * X(IHO2 )
      AK143 = RKI(143) * YC(LTCO3) * X(IHO2 )
      AK144 = RKI(144) * YC(LTCO3) * X(IHO2 )
      AK145 = RKI(145) * YC(LKETP) * X(IHO2 )
      AK146 = RKI(146) * YC(LOLNN) * X(IHO2 )
      AK147 = RKI(147) * YC(LOLND) * X(IHO2 )
      AK209 = RKI(209) * YC(LXO2 ) * X(IHO2 )


C
C *****************************************************
C START COMPUTING RATE CHANGE OF SPECIES' CONCENTRATION
C *****************************************************
C
C    use all species PROD AND LOSS terms
C
      XDOT(IHO)   = CNST_XDOT(IHO)  +       AJ4  +  0.350*CRJ(6)
     &             + 2.000 * AK5      
     &            + AK7       + AK18      + 0.700 * AK21 
     &            - AK6       - AK8       - AK9        -    AK15
     &            - AK16      - AK17      - AK22       -    AK23
     &            - AK24      - AK33      - AK34       -    AK35
     &            - AK38      - AK39      - 0.964 * AK40 
     &            - AK41      - AK42      - AK43       -    AK44
     &            - AK45      - AK46      - AK47       -    AK48
     &            - AK49      - AK50      - AK51       -    AK52
     &            - AK53      - AK54      - AK55       -    AK56
     &            - AK57      - AK58      - AK59       -    AK60
     &            - AK61      - 0.650 * AK62 - 0.510 * AK63
     &            - AK64      - AK65      - AK66       -    AK67

C
      XDOT(IHO2)  = CNST_XDOT(IHO2) +   0.650 * AJ6    +    AK6
     &            + AK9       + AK17      + AK20       +    AK33
     &            + AK34      + AK35 + 0.381 * AK40 + 0.250 * AK41
     &            + 0.049 * AK42     + 0.100 * AK50 + 0.100 * AK51
     &            + 0.050 * AK52          + AK53       +    AK56
     &            + AK57      + 0.490 * AK59 + 0.500 * AK60
     &            + AK61      + 0.350 * AK64 + 0.400 * AK66
     &            - AK7       - AK8       - 2.000 * AK10
     &            - 2.000 * AK11          - AK18        -   AK19
     &            - AK21      - AK94      - AK127       -   AK128
     &            - AK129     - AK130     - AK131       -   AK132
     &            - AK133     - AK134     - AK135       -   AK136
     &            - AK137     - AK138     - AK139       -   AK140
     &            - AK141     - AK142     - AK143       -   AK144
     &            - AK145     - AK146     - AK147       -   AK209    
C
      XDOT(IHONO) = CNST_XDOT(IHONO)      + AK15        -   AJ4
     &            - AK22

C
      XDOT(IHNO4) = AK19      - AJ6       - AK20        -   AK24
C
C        all correct 12.05.1998
C************************************************************************
C
C
C ADD EMISSION
C
      XDOT(IHONO) = XDOT(IHONO) + PRODSI(LHONO)
C
C FILL IN J MATRIX COEFFICIENT
C THE STATEMENT PD(I,J) = 0., IF NECESSARY, IS NEEDED TO RESET PD ARRAY THAT
C HAS BEEN DESTROYED IN LAST MATRIX INVERSION PROCESSES
C
C
C************************ HO MATRIX

C   PROVISIONAL TERMS FOR FIRST ORDER HO LOSS

      PD(IHO, IHO)     =  CNST_PD(IHO, IHO) 
     &                 -  RKI(  8) * X(IHO2)
     &                 -  RKI( 22) * X(IHONO)
     &                 -  RKI( 24) * X(IHNO4)
C   PROVISIONAL TERMS FOR HONO REACTING TO FORM HO

      PD(IHO, IHONO)   =  RJI(  4)  -  RKI( 22) * X(IHO)
C   PROVISIONAL TERMS FOR HONO REACTING TO FORM HO

      PD(IHO, IHNO4)   =  0.350 * RJI(  6)  -  RKI( 24) * X(IHO)
C   PROVISIONAL TERMS FOR HO2 REACTING TO FORM HO

      PD(IHO, IHO2)    = CNST_PD(IHO, IHO2) -  RKI(  8) * X(IHO)
C
C************************ HO2 MATRIX
C
C   PROVISIONAL TERMS FOR FIRST ORDER HO2 LOSS

      PD(IHO2, IHO2)   = CNST_PD(IHO2, IHO2)
     &                 -       RKI(  8) * X(IHO)
     &                 - 4.0 * RKI( 10) * X(IHO2)
     &                 - 4.0 * RKI( 11) * X(IHO2)* YC(LH2O)

C   PROVISIONAL TERMS FOR HNO4 REACTING TO FORM HO2 
   
      PD(IHO2, IHNO4)  =   +  RKI( 20) +  0.650 * RJI(  6)

C   PROVISIONAL TERMS FOR HO REACTING TO FORM HO2
  
      PD(IHO2, IHO)    = CNST_PD(IHO2, IHO) -  RKI(  8) * X(IHO2)
      PD(IHO2, IHONO)  = 0.
 
C
C*********************** HONO MATRIX
C
C   PROVISIONAL TERMS FOR FIRST ORDER HONO LOSS

      PD(IHONO, IHONO) = - RJI( 4) - RKI(22) * X(IHO) 

C   PROVISIONAL TERMS FOR HO REACTING TO FORM HONO 
 
      PD(IHONO, IHO)   = CNST_PD(IHONO, IHO) - RKI(22) * X(IHONO)

      PD(IHONO, IHNO4) = 0.
      PD(IHONO, IHO2)  = 0.

C
C*********************** HNO4 MATRIX
C
C   PROVISIONAL TERMS FOR FIRST ORDER HNO4 LOSS

      PD(IHNO4, IHNO4) = - RKI( 20) - RKI( 24) * X(IHO)
     &                   - RJI(  6)

C   PROVISIONAL TERMS FOR HO REACTING TO FORM HNO4
      PD(IHNO4, IHO)   = - RKI( 24) * X(IHNO4)


      PD(IHNO4, IHO2)  = CNST_PD(IHNO4, IHO2)
      PD(IHNO4, IHONO) = 0.
C
C************************ END PROVISIONAL TERMS    
C
      RETURN
      END
C
      SUBROUTINE NEWRAP_NOXOX(NTRIAL, X0, X, N, TOLX, TOLF, XCPO1D,
     &                        NIT)
C
C NUMERICAL RECIPES PAGE 272
C
C GIVEN AN INITIAL GUESS X FOR A ROOT IN N DIMENSIONS, TAKE NTRIAL
C NEWTON-RAPSHON STEPS TO IMPROVE THE ROOT.  STOP IF THE ROOT CONVERGES
C IN EITHER SUMMED ABSOLUTE VARIABLE INCREMENTS TOLX OR SUMMED ABSOLUTE
C FUNCTION VALUES TOLF.
C
C--------------------------------------------------------------------------
C THE ITERATION FOR SOLVING NO2, NO, O3, AND O3P IN HERTEL ET AL.
C AS A GROUPED SPECIES. THE INPUT SPECIES SEQUENCE IS FIXED AS
C NO2(1), NO(2), O3(3), O3P(4)
C--------------------------------------------------------------------------
C
      INCLUDE 'a_params.com'
      SAVE
C HARDWIRE DIMENSION DECLARATION
      PARAMETER ( NP = 4 )
      DIMENSION X(NP), ALPHA(NP, NP), BETA(NP), INDEX(NP)
      DIMENSION X0(NP)
      DIMENSION CNST_XDOT(NP), CNST_PD(NP,NP)
      INTEGER INDEX
C
      INO2 = 1
      INO  = 2
      IO3  = 3
      IO3P = 4
C
COMPUTE CONSTANT TERMS FOR XCPO1D CALCULATION
C
      BOTO1D = RKI(3) * YC(LN2) + RKI(4) * YC(LO2) + RKI(5) * YC(LH2O)
C
COMPUTE CONSTANT PROD TERMS FOR BETA (XDOT) CALCULATION IN SUB NOXOX
C
      CNST_XDOT(INO2)  =   CRJ(5)   +  0.650*CRJ(6)
     &                   + CRJ(8)   +        CRJ(21) +        CRK(17)
     &                   + CRK(20)  +  0.700*CRK(21) +        CRK(22)
     &                   + CRK(24)  +        CRK(31) +  2.000*CRK(32)
     &                   + CRK(67)  +  0.500*CRK(73) +  0.400*CRK(82)
     &                   + CRK(105) +        CRK(107)
     &             + 0.500*CRK(168) +  0.516*CRK(186)
     &             + 0.500*CRK(188) +       CRK(189) +       CRK(190)
     &                  + CRK(191)  +       CRK(192) +       CRK(193)
     &                  + CRK(194)  +       CRK(195) +       CRK(196)
     &                  + CRK(197)  +       CRK(198) +       CRK(199)
     &                  + CRK(200)  +       CRK(201) +       CRK(202)
     &                  + CRK(203)  +       CRK(204) +       CRK(205)
     &                  + CRK(206)  +       CRK(207) + 2.000*CRK(208)
     &                  + CRK(214)
C
      CNST_XDOT(INO)   =  CRJ(4)    +       CRJ(7)
C
      CNST_XDOT(IO3)   =  CRK(142)  +       CRK(144)
C
      CNST_XDOT(IO3P)  =  CRJ(8)
C
COMPUTE CONSTANT TERMS FOR ALPHA (PD) CALCULATION IN SUB NOXOX
C
C    CONSTANT TERMS FOR FIRST ORDER NO2 LOSS
C
      CNST_PD(INO2,INO2) = - RJI(  1) - RKI(16) * YC(LHO)
     &                     - RKI(19) * YC(LHO2)
     &                     - RKI(30) * YC(LNO3)
     &                     - RKI(93) * YC(LPHO)
     &                     - RKI(95) * YC(LADDT)
     &                     - RKI(98) * YC(LADDX)
     &                     - RKI(101) * YC(LADDC)
     &                     - RKI(104) * YC(LACO3)
     &                     - RKI(106) * YC(LTCO3)

C
C    CONSTANT TERMS FOR NO INTERCONVERTING WITH NO2
C
      CNST_PD(INO2, INO) =       RKI(18)  * YC(LHO2)
     &                   + 2.0 * RKI(28)  * YC(LNO3)
     &                   +       RKI(108) * YC(LMO2)
     &                   +       RKI(109) * YC(LETHP)
     &                 + 0.941 * RKI(110) * YC(LHC3P)
     &                 + 0.876 * RKI(111) * YC(LHC5P)
     &                 + 0.739 * RKI(112) * YC(LHC8P)
     &                   +       RKI(113) * YC(LETEP)
     &                   +       RKI(114) * YC(LOLTP)
     &                   +       RKI(115) * YC(LOLIP)
     &                 + 0.847 * RKI(116) * YC(LISOP)
     &                 + 0.800 * RKI(117) * YC(LAPIP)
     &                 + 0.650 * RKI(118) * YC(LLIMP)
     &                 + 0.950 * RKI(119) * YC(LTOLP)
     &                 + 0.950 * RKI(120) * YC(LXYLP)
     &                   +       RKI(121) * YC(LCSLP)
     &                   +       RKI(122) * YC(LACO3)
     &                   +       RKI(123) * YC(LTCO3)
     &                   +       RKI(124) * YC(LKETP)
     &                   +       RKI(125) * YC(LOLNN)
     &                   + 2.0 * RKI(126) * YC(LOLND)
     &                   +       RKI(213) * YC(LXO2)
C

C    CONSTANT TERMS FOR O3 REACTING TO FORM NO2
      CNST_PD(INO2,  IO3) = + RKI(92) * YC(LTPAN)

C
C    CONSTANT TERMS FOR NO2 INTERCONVERTING WITH NO
C
      CNST_PD(INO, INO2) = RJI(1) + RKI( 29) * YC(LNO3)
C
C    CONSTANT TERMS FOR FIRST ORDER NO LOSS
C
      CNST_PD(INO,  INO) = - RKI( 15) * YC(LHO)
     &                     - RKI( 18) * YC(LHO2)
     &                     - RKI( 28) * YC(LNO3)
     &                     - RKI(108) * YC(LMO2)
     &                     - RKI(109) * YC(LETHP)
     &                     - RKI(110) * YC(LHC3P)
     &                     - RKI(111) * YC(LHC5P)
     &                     - RKI(112) * YC(LHC8P)
     &                     - RKI(113) * YC(LETEP)
     &                     - RKI(114) * YC(LOLTP)
     &                     - RKI(115) * YC(LOLIP)
     &                     - RKI(116) * YC(LISOP)
     &                     - RKI(117) * YC(LAPIP)
     &                     - RKI(118) * YC(LLIMP)
     &                     - RKI(119) * YC(LTOLP)
     &                     - RKI(120) * YC(LXYLP)
     &                     - RKI(121) * YC(LCSLP)
     &                     - RKI(122) * YC(LACO3)
     &                     - RKI(123) * YC(LTCO3)
     &                     - RKI(124) * YC(LKETP)
     &                     - RKI(125) * YC(LOLNN)
     &                     - RKI(126) * YC(LOLND)
     &                     - RKI(213) * YC(LXO2)


C
C    CONSTANT TERMS FOR FIRST ORDER O3 LOSS
C
      CNST_PD(IO3,  IO3) = - RJI(  2)
     &                     - RJI(  3)
     &                     - RKI(  6) * YC(LHO)
     &                     - RKI(  7) * YC(LHO2)
     &                     - RKI( 83) * YC(LETE)
     &                     - RKI( 84) * YC(LOLT)
     &                     - RKI( 85) * YC(LOLI)
     &                     - RKI( 86) * YC(LDIEN)
     &                     - RKI( 87) * YC(LISO)
     &                     - RKI( 88) * YC(LAPI)
     &                     - RKI( 89) * YC(LLIM)
     &                     - RKI( 90) * YC(LMACR)
     &                     - RKI( 91) * YC(LDCB)
     &                     - RKI( 92) * YC(LTPAN)
     &                     - RKI( 97) * YC(LADDT)
     &                     - RKI(100) * YC(LADDX)
     &                     - RKI(103) * YC(LADDC)

C    CONSTANT TERMS FOR O3P REACTING TO FORM O3

      CNST_PD(IO3, IO3P) = + RKI(  1) * YC(LO2)
      
C    CONSTANT TERMS FOR FIRST ORDER O3P LOSS
    
      CNST_PD(IO3P,IO3P) = - RKI(  1) * YC(LO2)
     &                     - RKI( 36) * YC(LISO)
     &                     - RKI( 37) * YC(LMACR)
C    CONSTANT TERMS FOR O3 REACTING TO FORM O3P

      CNST_PD(IO3P, IO3)= + 0.090 *RKI( 86) * YC(LDIEN)
     &                    + 0.090 *RKI( 87)  *YC(LISO)
      
C    CNST_PD(INO2,  IO3P)
C    THERE ARE NO CONSTANT TERMS FOR O3P REACTING TO FORM NO2 
C    CNST_PD(INO, IO3)
C    THERE ARE NO CONSTANT TERMS FOR O3 REACTING TO FORM NO
C    CNST_PD(INO, IO3P)
C    THERE ARE NO CONSTANT TERMS FOR O3P REACTING TO NO
C    CNST_PD(IO3,  INO)
C    THERE ARE NO CONSTANT TERMS FOR NO REACTING TO FORM O3
C    CNST_PD(IO3,  INO2)
C    THERE ARE NO CONSTANT TERMS FOR NO2 REACTING TO FORM O3
C    CNST_PD(IO3P,  INO)   
C    THERE ARE NO CONSTANT TERMS FOR NO REACTING TO FORM O3P
C    CNST_PD(IO3P,  INO2)   
C    THERE ARE NO CONSTANT TERMS FOR NO2 REACTING TO FORM O3P
      DO 1 K = 1, NTRIAL
        NIT = K
C
C USER DEFINED FUNCTION, ALPHA AND BETA :
C
C     ALPHA = 1 - DF/D(VCF) * DTC
C     BETA  = - VCF(K-1,T+DT) + VCF(T) + F(VCS'(T+DT),VCF(K-1,T+DT)) * DT
C     F = D(VCF)/DT
C
             
        CALL NOXOX(X, BETA, ALPHA, CNST_XDOT, CNST_PD, XCPO1D)! BETA = F = DC/DT
        DO 12 J = 1, N
          BETA(J) = - X(J) + X0(J) + BETA(J) * DTC
12      CONTINUE
C
C REMEMBER TO RESET ALPHA ARRAY, SINCE ALPHA ARRAY ARE DESTROYED IN LU
C DECOMPOSITION
C
        DO 13 J = 1, N
          DO 14 I = 1, N
            ALPHA(I,J) = - ALPHA(I,J) * DTC
14        CONTINUE
          ALPHA(J,J) = 1. + ALPHA(J,J)
          
13      CONTINUE

C
        ERRF = 0.			! CHECK FUNCTION CONVERGENCE
        DO 2 J = 1, N
          ERRF = ERRF + ABS( BETA(J) )
2       CONTINUE
        IF ( ERRF .LE. TOLF ) RETURN
C
        CALL LUDCMP( ALPHA, N, NP, INDEX, D )  ! SOLVE LINEAR EQUATION USING LU
        CALL LUBKSB( ALPHA, N, NP, INDEX, BETA ) ! DECOMPOSITION

      
C
        ERRX = 0.		! CHECK ROOT CONVERGENCE
        DO 3 J = 1, N		! UPDATE SOLUTION
          ERRX = ERRX + ABS( BETA(J) )
          X(J) = X(J) + BETA(J)
3       CONTINUE
        
C
C STEADY STATE SOLUTION FOR SPECIES O1D
C
        XCPO1D = RJI( 2) * X(IO3) / BOTO1D
 
C
C OK! ONLY PHOTOLYSIS REACTION 2 FORMS O1D

        IF ( ERRX .LE. TOLX ) RETURN
C
 
1     CONTINUE
      PRINT *, 'NOXOX ITERATION NUMBER OVER ', NTRIAL
      NTRIAL = -999
C
      RETURN
      END
 
C

C
      
      SUBROUTINE NEWRAP_HOXHNOX( NTRIAL, X0, X, N, TOLX, TOLF, XCPO1D,
     &                              NIT )
C
C NUMERICAL RECIPES PAGE 272
C
C GIVEN AN INITIAL GUESS X FOR A ROOT IN N DIMENSIONS, TAKE NTRIAL
C NEWTON-RAPSHON STEPS TO IMPROVE THE ROOT.  STOP IF THE ROOT CONVERGES
C IN EITHER SUMMED ABSOLUTE VARIABLE INCREMENTS TOLX OR SUMMED ABSOLUTE
C FUNCTION VALUES TOLF.
C
C--------------------------------------------------------------------------
C THE ITERATION FOR SOLVING HO, HO2, HONO, AND HNO4 IN HERTEL ET AL.
C AS A GROUPED SPECIES. THE INPUT SPECIES SEQUENCE IS FIXED AS
C HO(1), HO2(2), HONO(3), AND HNO4(4).
C--------------------------------------------------------------------------
      INCLUDE 'a_params.com'
      SAVE
C HARDWIRE DIMENSION DECLARATION
      PARAMETER ( NP = 4 )
      DIMENSION X(NP), ALPHA(NP, NP), BETA(NP), INDEX(NP)
      DIMENSION X0(NP)
      DIMENSION CNST_XDOT(NP), CNST_PD(NP,NP)
      INTEGER INDEX
     
C
      IHO   = 1
      IHO2  = 2
      IHONO = 3
      IHNO4 = 4
C
COMPUTE CONSTANT TERMS FOR XCPO1D CALCULATION
C
      BOTO1D = RKI(3) * YC(LN2) + RKI(4) * YC(LO2) + RKI(5) * YC(LH2O) 
C
C COMPUTE CONSTANT PROD TERMS FOR BETA (XDOT) CALCULATION IN SUB NOXOX
C
      CNST_XDOT(IHO)   =  +         CRJ(5) 
     &            +  2.000*CRJ(9)
     &            +        CRJ(13) +        CRJ(14) +       CRJ(15)
     &            +  0.020*CRK(36) + 0.120*CRK(83)
     &            +  0.400*CRK(84) +  0.630*CRK(85) + 0.280*CRK(86)
     &            +  0.280*CRK(87) +  0.850*CRK(88) + 0.850*CRK(89)
     &            +  0.070*CRK(90) +  0.210*CRK(91) + 0.036*CRK(92)
     &            +        CRK(97) +        CRK(100)+      CRK(103)
C
C
      CNST_XDOT(IHO2)  =  2.000*CRJ(11) +        CRJ(12)
     &            +        CRJ(13) +        CRJ(14) + 0.800*CRJ(18)
     &            +        CRJ(19) +        CRJ(20) +       CRJ(21)
     &            +        CRJ(22) +        CRJ(23) + 0.280*CRK(36)
     &            +        CRK(68) +        CRK(70) 
     &            +  0.500*CRK(73) +  0.260*CRK(83)
     &            +  0.250*CRK(84) +  0.220*CRK(85) + 0.300*CRK(86)
     &            +  0.300*CRK(87) +  0.100*CRK(88) + 0.100*CRK(89)
     &            +  0.290*CRK(90) +  0.290*CRK(91) + 0.080*CRK(92)
     &            +  0.020*CRK(96) +  0.020*CRK(99) + 0.020*CRK(102)
     &            +        CRK(108)+        CRK(109)+0.742*CRK(110)
     &            +  0.599*CRK(111)+  0.606*CRK(112)+      CRK(113)
     &            +        CRK(114)+        CRK(115)+0.847*CRK(116)
     &            +  0.800*CRK(117)+  0.650*CRK(118)+0.950*CRK(119)
     &            +  0.950*CRK(120)+        CRK(121)+0.770*CRK(124)
     &            +        CRK(125)+  0.660*CRK(148)+      CRK(149)
     &            +  0.992*CRK(150)+  0.946*CRK(151)+0.993*CRK(152)
     &            +        CRK(153)+        CRK(154)+      CRK(155)
     &            +        CRK(156)+  2.000*CRK(157)+2.000*CRK(158)
     &            +        CRK(159)+        CRK(160)+2.000*CRK(161)
     &            +        CRK(162)+        CRK(164)+0.880*CRK(166)
     &            +        CRK(167)+  0.500*CRK(168)+0.500*CRK(169)
     &            +  0.488*CRK(170)+  0.438*CRK(171)+0.489*CRK(172)
     &            +  0.500*CRK(173)
     &            +  0.501*CRK(174)+ 0.510*CRK(175)+ 0.506*CRK(176)
     &            +        CRK(177)+       CRK(178)+       CRK(179)
     &            +        CRK(180)+       CRK(181)+ 0.380*CRK(184)
     &            +  0.500*CRK(185)+       CRK(187)+ 0.500*CRK(188)
     &            +        CRK(190)+       CRK(191)+ 0.792*CRK(192)
     &            +  0.699*CRK(193)+ 0.845*CRK(194)+       CRK(195)
     &            +        CRK(196)+       CRK(197)
     &            +        CRK(198)+       CRK(199)+       CRK(200)
     &            +        CRK(201)+       CRK(202)+       CRK(203)
     &            +  0.770*CRK(206)+       CRK(207)+       CRK(210)
C
      CNST_XDOT(IHONO) =   CRK(95) +       CRK(98) +       CRK(101)
C    NO  CNST_XDOT(IHNO4)
C
C
COMPUTE CONSTANT TERMS FOR ALPHA (PD) CALCULATION IN SUB NOXOX
C
C
C  CONSTANT TERMS FOR HO2 INTERCONVERTING WITH HO
          
      CNST_PD(IHO , IHO2) = 
     &                    +  RKI(  7) * YC(LO3)
     &                    +  RKI( 18) * YC(LNO)
     &                    + .700*RKI( 21) * YC(LNO3)
C
C
C
C CONSTANT TERMS FOR  FIRST ORDER  HO LOSS
           
      CNST_PD(IHO , IHO)     = 
     &                     - RKI( 6) * YC(LO3)
     &                     - RKI( 9) * YC(LH2O2) 
     &                     - RKI( 16) * YC(LNO2)
     &                     - RKI( 17) * YC(LNO3)
     &                     - RKI( 23) * YC(LHNO3)
     &                     - RKI( 33) * YC(LH2)
     &                     - RKI( 34) * YC(LSO2)
     &                     - RKI( 35) * YC(LCO)
     &                     - RKI( 38) * YC(LCH4)
     &                     - RKI( 39) * YC(LETH)
     &             - 0.964 * RKI( 40) * YC(LHC3)
     &                     - RKI( 41) * YC(LHC5)
     &                     - RKI( 42) * YC(LHC8)
     &                     - RKI( 43) * YC(LETE)
     &                     - RKI( 44) * YC(LOLT)
     &                     - RKI( 45) * YC(LOLI)
     &                     - RKI( 46) * YC(LDIEN)
     &                     - RKI( 47) * YC(LISO)
     &                     - RKI( 48) * YC(LAPI)
     &                     - RKI( 49) * YC(LLIM)
     &                     - RKI( 50) * YC(LTOL)
     &                     - RKI( 51) * YC(LXYL)
     &                     - RKI( 52) * YC(LCSL)
     &                     - RKI( 53) * YC(LHCHO)
     &                     - RKI( 54) * YC(LALD)
     &                     - RKI( 55) * YC(LKET)
     &                     - RKI( 56) * YC(LHKET)
     &                     - RKI( 57) * YC(LGLY)
     &                     - RKI( 58) * YC(LMGLY)
     &                     - RKI( 59) * YC(LMACR)
     &                     - RKI( 60) * YC(LDCB)
     &                     - RKI( 61) * YC(LUDD)
     &             - 0.650 * RKI( 62) * YC(LOP1)
     &             - 0.510 * RKI( 63) * YC(LOP2)
     &                     - RKI( 64) * YC(LPAA)
     &                     - RKI( 65) * YC(LPAN)
     &                     - RKI( 66) * YC(LTPAN)
     &                     - RKI( 67) * YC(LONIT)
  
C CONSTANT TERMS FOR  FIRST ORDER  HO2 LOSS
      
      CNST_PD(IHO2, IHO2)   =   - RKI(  7) *  YC(LO3)
     &                     - RKI( 18) *  YC(LNO)
     &                     - RKI( 19) *  YC(LNO2)
     &                     - RKI( 21) *  YC(LNO3)
     &                     - RKI( 94) *  YC(LPHO)
     &                     - RKI(127) *  YC(LMO2)
     &                     - RKI(128) *  YC(LETHP)
     &                     - RKI(129) * YC(LHC3P)
     &                     - RKI(130) * YC(LHC5P)  
     &                     - RKI(131) * YC(LHC8P) 
     &                     - RKI(132) * YC(LETEP) 
     &                     - RKI(133) * YC(LOLTP) 
     &                     - RKI(134) * YC(LOLIP) 
     &                     - RKI(135) * YC(LISOP) 
     &                     - RKI(136) * YC(LAPIP) 
     &                     - RKI(137) * YC(LLIMP) 
     &                     - RKI(138) * YC(LTOLP)
     &                     - RKI(139) * YC(LXYLP) 
     &                     - RKI(140) * YC(LCSLP) 
     &                     - RKI(141) * YC(LACO3) 
     &                     - RKI(142) * YC(LACO3) 
     &                     - RKI(143) * YC(LTCO3) 
     &                     - RKI(144) * YC(LTCO3) 
     &                     - RKI(145) * YC(LKETP) 
     &                     - RKI(146) * YC(LOLNN) 
     &                     - RKI(147) * YC(LOLND) 
     &                     - RKI(209) * YC(LXO2)
C
C    CONSTANT TERMS FOR HO INTERCONVERTING WITH HO2
      
      CNST_PD(IHO2, IHO)    =    + RKI( 6)  * YC(LO3)
     &                     +     RKI( 9)  * YC(LH2O2)
     &                     +     RKI(17)  * YC(LNO3)
     &                     +     RKI(33)  * YC(LH2)
     &                     +     RKI(34)  * YC(LSO2)
     &                     +     RKI(35)  * YC(LCO)
     &                 + 0.381 * RKI(40)  * YC(LHC3)
     &                 + 0.250 * RKI(41)  * YC(LHC5)
     &                 + 0.049 * RKI(42)  * YC(LHC8)
     &                 + 0.100 * RKI(50)  * YC(LTOL)
     &                 + 0.100 * RKI(51)  * YC(LXYL)
     &                 + 0.050 * RKI(52)  * YC(LCSL)
     &                     +     RKI(53)  * YC(LHCHO)
     &                     +     RKI(56)  * YC(LHKET)
     &                     +     RKI(57)  * YC(LGLY)
     &                 + 0.490 * RKI(59)  * YC(LMACR)
     &                 + 0.500 * RKI(60)  * YC(LDCB)
     &                     +     RKI(61)  * YC(LUDD)
     &                 + 0.350 * RKI(64)  * YC(LPAA)
     &                 + 0.400 * RKI(66)  * YC(LTPAN)


C CONSTANT TERMS FOR HO REACTING TO FORM HONO

      CNST_PD(IHONO, IHO)     = RKI( 15) * YC(LNO)

C  CONSTANT TERM FOR HO2 REACTING TO HNO4
      
      CNST_PD(IHNO4, IHO2)    = RKI(19) * YC(LNO2)


C  CNST_PD(IHO, IHNO4)
C  THERE ARE NO CONSTANT TERMS FOR HNO4 REACTING TO FROM HO 
C  CNST_PD(IHO, IHONO)
C  THERE ARE NO CONSTANT TERMS FOR HONO REACTING TO FROM HO 
C  CNST_PD(IHO2, IHONO) 
C  THERE ARE NO CONSTANT TERMS FOR HONO REACTING TO FROM HO2
C  CNST_PD(IHO2, IHNO4)
C  THERE ARE NO CONSTANT TERMS FOR HNO4 REACTING TO FORM HO2
C  CNST_PD(IHONO, IHO2)
C  THERE ARE NO CONSTANT TERMS FOR HO2 REACTING TO FROM HONO
C  CNST_PD(IHONO,IHONO)
C  THERE ARE NO CONSTANT TERMS FOR  FIRST ORDER  HONO LOSS
C  CNST_PD(IHONO, IHNO4) 
C  THERE ARE NO CONSTANT TERMS FOR  HNO4 REACTING TO FORM HONO
C  CNST_PD(IHNO4,IHNO4) 
C  THERE ARE NO CONSTANT TERMS FOR  FIRST ORDER  HNO4 LOSS 
C  CNST_PD(IHNO4, IHO)
C  THERE ARE NO CONSTANT TERMS FOR HO REACTING TO FROM HNO4
C  CNST_PD(IHNO4, IHONO)
C  THERE ARE NO CONSTANT TERMS FOR HONO REACTING TO FROM HNO4

      DO 1 K = 1, NTRIAL
        NIT = K
C
C USER DEFINED FUNCTION, ALPHA AND BETA :
C
C FOLLOWING EQUATION (3) ON GONG AND CHO (1993), THE DEFINITION OF BETA
C AND ALPHA ARE THE FOLLOWING
C
C     ALPHA = 1 - DF/D(VCF) * DTC
C     BETA  = - VCF(K-1,T+DT) + VCF(T) + F(VCS'(T+DT),VCF(K-1,T+DT)) * DT
C     F = D(VCF)/DT
C
        CALL HOXHNOX(X, BETA, ALPHA, CNST_XDOT, CNST_PD, XCPO1D ) ! BETA = F = DC/DT
        DO 12 J = 1, N
          BETA(J) = - X(J) + X0(J) + BETA(J) * DTC
12      CONTINUE
C
C REMEMBER TO RESET ALPHA ARRAY, SINCE ALPHA ARRAY ARE DESTROYED IN LU
C DECOMPOSITION
C
        DO 13 J = 1, N
          DO 14 I = 1, N
            ALPHA(I,J) = - ALPHA(I,J) * DTC
14        CONTINUE
          ALPHA(J,J) = 1. + ALPHA(J,J)
13      CONTINUE
C
        ERRF = 0.			! CHECK FUNCTION CONVERGENCE
        DO 2 J = 1, N
          ERRF = ERRF + ABS( BETA(J) )
2       CONTINUE
        IF ( ERRF .LE. TOLF ) RETURN
C
        CALL LUDCMP( ALPHA, N, NP, INDEX, D )  ! SOLVE LINEAR EQUATION USING LU
  
        CALL LUBKSB( ALPHA, N, NP, INDEX, BETA ) ! DECOMPOSITION
C
        ERRX = 0.		! CHECK ROOT CONVERGENCE
        DO 3 J = 1, N		! UPDATE SOLUTION
          ERRX = ERRX + ABS( BETA(J) )
          X(J) = X(J) + BETA(J)
          
3       CONTINUE
C
C STEADY STATE SOLUTION FOR SPECIES O1D
C
        XCPO1D = RJI( 2) * YC(LO3) / BOTO1D

C
        IF ( ERRX .LE. TOLX ) RETURN
1     CONTINUE
      PRINT *, 'HOXHNOX ITERATION NUMBER OVER ', NTRIAL
      NTRIAL = -999
C
      RETURN
      END
 
 
      SUBROUTINE LUDCMP( A, N, NP, INDEX, D )
      IMPLICIT double precision (A-H,O-Z)
C
C NUMERICAL RECIPES PAGE 35
C
C GIVEN AN N X N MATRIX A, WITH PHYSICAL DIMENSION NP, THIS ROUTINE
C REPLACES IT BY THE LU DECOMPOSITION OF A ROWWISE PERMUTATION OF ITSELF.
C A AND N ARE INPUT.  A IS OUTPUT, ARRANGED AS IN EQUATION (2.3.14)
C ABOVE; INDEX IS AN OUTPUT VECTOR WHICH RECORDS THE ROW PERMUTATION
C EFFECTED BY THE PARTIAL PIVOTING; D IS OUTPUT AS (+-)1. DEPENDING ON
C WHETHER THE NUMBER OF ROW INTERCHANGES WAS EVEN OR ODD, RESPECTIVELY.
C THIS ROUTINE IS USED IN COMBINATION WITH LUBKSB TO SOLVE LINEAR
C EQUATIONS OR INVERT A MATRIX.
C
C NMAX = LARGEST EXPECTED N, AND A SMALL NUMBER, TINY
C VV STORES THE IMPLICIT SCALING OF EACH ROW.
C
C     INCLUDE 'A_PARAMS.COM'
      SAVE
C HARDWIRE DIMENSION DECLARATION
      PARAMETER( NMAX = 100, TINY = 1.0E-20 )
      PARAMETER( NS = 4 )
      DIMENSION A(NS, NS), INDEX(NS), VV(NMAX)
C
      D = 1.0	       ! NO ROW INTERCHANGES YET
      DO 1 I = 1, N    ! LOOP OVER ROWS TO GET THE IMPLICIT SCALING INFORMATION.
        AAMAX = 0.
        DO 2 J = 1, N
          IF( ABS( A(I,J) ) .GT. AAMAX ) AAMAX = ABS( A(I,J) )
2       CONTINUE
        IF ( AAMAX .EQ. 0. ) STOP 'SINGULAR MATRIX'
        VV(I) = 1. / AAMAX	! SAVE THE SCALING
1     CONTINUE
C
      DO 3 J = 1, N	! THIS IS THE LOOP OVER COLUMNS OF CROUT'S METHOD
        DO 4 I = 1, J - 1	! THIS IS EQUATION 2.3.12 EXCEPT FOR I = J
          SUM = A(I,J)
          DO 5 K = 1, I - 1
            SUM = SUM - A(I,K) * A(K,J)
5         CONTINUE
          A(I,J) = SUM
4       CONTINUE
        AAMAX = 0.	! INITIALIZE FOR THE SEARCH FOR LARGEST PIVOT ELEMENT
        DO 6 I = J, N	! THIS IS I=J OF EQUATION 2.3.12 & I=J+1..N OF EQUATION
          SUM = A(I,J)	! 2.3.13
          DO 7 K = 1, J - 1
            SUM = SUM - A(I,K) * A(K,J)
7         CONTINUE
          A(I,J) = SUM
          DUM = VV(I) * ABS(SUM)	! FIGURE OF MERIT FOR THE PIVOT
          IF ( DUM .GE. AAMAX ) THEN	! IS IT BETTER THAN THE BEST SO FAR ?
            IMAX = I
            AAMAX = DUM
          END IF
6       CONTINUE
        IF ( J .NE. IMAX ) THEN		! DO WE NEED TO INTERCHANGE ROWS
          DO 8 K = 1, N			! YES, DO SO ....
            DUM = A(IMAX, K)
            A(IMAX, K) = A(J,K)
            A(J,K) = DUM
8         CONTINUE
          D = - D			! ... AND CHANGE THE PARITY OF D
          VV(IMAX) = VV(J)		! ALSO INTERCHANGE THE SCALE FACTOR.
        END IF
        INDEX(J) = IMAX
        IF( A(J,J) .EQ. 0. ) A(J,J) = TINY
C
C IF THE PIVOT ELEMENT IS ZERO THE MATRIX IS SINGULAR ( AT LEAST TO THE
C PRECISION OF THE ALGORITHM).  FOR SOME APPLICATION ON SINGULAR MATRICES,
C IT IS DESIRABLE TO SUBSTITUTE TINY FOR ZERO
C
        IF ( J .NE. N ) THEN	! NOW, FINALLY, DIVIDE BY THE PIVOT ELEMENT
          DUM = 1. / A(J,J)
          DO 9 I = J + 1, N
            A(I,J) = A(I,J) * DUM
9         CONTINUE

        END IF
3     CONTINUE		!  GO BACK FOR THE NEXT COLUMN IN THE REDUCTION
C
      RETURN
      END
 
 
 
      SUBROUTINE LUBKSB( A, N, NP, INDEX, B )
      IMPLICIT double precision (A-H,O-Z)
C
C NUMERICAL RECIPES PAGE 36
C
C SOLVE THE SET OF N LINEAR EQUATIONS AXX = B.  HERE A IS INPUT, NOT AS
C THE MATRIX A BUT RATHER AS ITS LU DECOMPOSITION, DETERMINED BY THE
C ROUTINE LUDCMP.  INDEX IS INPUT AS THE PERMUTATION VECTOR RETURNED BY
C LUDCMP.  B IS INPUT AS THE RIGHT-HAND SIDE VECTOR B, AND RETURNS WITH
C THE SOLUTION VECTOR X.  A, N, NP AND INDEX ARE NOT MODIFIED BY THIS
C ROUTINE AND CAN BE LEFT IN PLACE FOR SUCCESSIVE CALLS WITH DIFFERENT
C RIGHT-HAND SIDE B.  THIS ROUTINE TAKES INTO ACCOUNT THE POSSIBILITY
C THAT B WILL BEGIN WITH MANY ZERO ELEMENT, SO IT IS EFFICIENT FOR USE
C IN MATRIX INVERSION.
C
C      INCLUDE 'A_PARAMS.COM'
C HARDWIRE DIMENSION DECLARATION
       SAVE
      PARAMETER( NS = 4 )
      DIMENSION A(NS,NS), INDEX(NS), B(NS)
      INTEGER INDEX
C
C WHEN II IS SET TO A POSITIVE VALUE, IT WILL BECOME THE INDEX OF THE FIRST
C NONVANISHING ELEMENT OF B.  WE NOW DO THE FORWARD SUBSTITUTION, EQUATION
C 2.3.6.  THE ONLY NEW WRINKLE IS TO UNSCRAMBLE THE PERMUTATION AS WE GO.
C
 
      II = 0
      DO 1  I = 1, N
        LL = INDEX(I)
        SUM = B(LL)
        B(LL) = B(I)
        IF( II .NE. 0 ) THEN
          DO 2 J = II, I - 1
            
            SUM = SUM - A(I,J) * B(J)
2         CONTINUE
        ELSE IF ( SUM .NE. 0 ) THEN
          II = I		! A NONZERO ELEMENT WAS ENCOUNTERED, SO
        END IF			! FROM NOW ON WE WILL HAVE TO DO THE SUMS
        B(I) = SUM		! IN THE LOOP ABOVE
       
1     CONTINUE
C
      DO 3 I = N, 1, -1	     ! NOW WE DO THE BACKSUBSTITUTION, EQUATION 2.3.7
        SUM = B(I)
        DO 4 J = I + 1, N
          SUM = SUM - A(I,J) * B(J)
4       CONTINUE
        B(I) = SUM / A(I,I)	! STORE A COMPONENT OF THE SOLUTION VECTOR X.
3     CONTINUE
C
      RETURN
      END
 
C

      SUBROUTINE NOXOX( X, XDOT, PD, CNST_XDOT, CNST_PD, XCPO1D )

C----------------------------------------------------------------------

C

C MODIFIED FOR HERTEL ET AL. SCHEME IN SOLVING THE NO2, NO, O3, O3P
C AS A GROUPED SPECIES.  THE INPUT SPECIES SEQUENCE IS FIXED AS
C NO2(1), NO(2), O3(3), O3P(4)
C

C----------------------------------------------------------------------
C

      INCLUDE "a_params.com"
      SAVE
      PARAMETER (ISOLVE = 4 )
      DIMENSION X(ISOLVE), XDOT(ISOLVE), PD(ISOLVE,ISOLVE)
      DIMENSION CNST_XDOT(ISOLVE), CNST_PD(ISOLVE,ISOLVE)

C

      INO2 = 1
      INO  = 2
      IO3  = 3
      IO3P = 4

C
C   RATE TERMS INVOLVING NO2 NO O3 O3P AND O1D
C

C BEGIN OF PHOTOLYTIC SPECIES

C
      
      AJ1 = RJI(1) * X(INO2)
      AJ2 = RJI(2) * X(IO3)
      AJ3 = RJI(3) * X(IO3)
 
C
C END OF PHOTOLYTIC SPECIES
C

C BEGIN THERMAL SPECIES
C
  
      AK1   = RKI(1)   * X(IO3P)   * YC(LO2)
      AK2   = RKI(2)   * X(IO3P)   * X(IO3)
      AK3   = RKI(3)   * XCPO1D    * YC(LN2)
      AK4   = RKI(4)   * XCPO1D    * YC(LO2)
      AK6   = RKI(6)   * X(IO3)    * YC(LHO)
      AK7   = RKI(7)   * X(IO3)    * YC(LHO2)
      AK12  = RKI(12)  * X(IO3P)   * X(INO)
      AK13  = RKI(13)  * X(IO3P)   * X(INO2)
      AK14  = RKI(14)  * X(IO3P)   * YC(LNO2)
      AK15  = RKI(15)  * YC(LHO)   * X(INO)
      AK16  = RKI(16)  * YC(LHO)   * X(INO2)
      AK18  = RKI(18)  * YC(LHO2)  * X(INO)
      AK19  = RKI(19)  * YC(LHO2)  * X(INO2)
      AK25  = RKI( 25) * X(IO3)    * X(INO)
      AK26  = RKI( 26) * X(IO3)    * X(INO2)
      AK27  = RKI( 27) * X(INO)    * X(INO) * YC(LO2)
      AK28  = RKI( 28) * YC(LNO3)  * X(INO)
      AK29  = RKI( 29) * YC(LNO3)  * X(INO2)
      AK30  = RKI( 30) * YC(LNO3)  * X(INO2)
      AK36  = RKI( 36) * YC(LISO)  * X(IO3P)
      AK37  = RKI( 37) * YC(LMACR) * X(IO3P)
      AK83  = RKI( 83) * YC(LETE)  * X(IO3)
      AK84  = RKI( 84) * YC(LOLT)  * X(IO3)
      AK85  = RKI( 85) * YC(LOLI)  * X(IO3)
      AK86  = RKI( 86) * YC(LDIEN) * X(IO3)
      AK87  = RKI( 87) * YC(LISO)  * X(IO3)
      AK88  = RKI( 88) * YC(LAPI)  * X(IO3)
      AK89  = RKI( 89) * YC(LLIM)  * X(IO3)
      AK90  = RKI( 90) * YC(LMACR) * X(IO3)
      AK91  = RKI( 91) * YC(LDCB)  * X(IO3)
      AK92  = RKI( 92) * YC(LTPAN) * X(IO3)
      AK93  = RKI( 93) * YC(LPHO)  * X(INO2)
      AK95  = RKI( 95) * YC(LADDT) * X(INO2)
      AK97  = RKI( 97) * YC(LADDT) * X(IO3)
      AK98  = RKI( 98) * YC(LADDX) * X(INO2)
      AK100 = RKI(100) * YC(LADDX) * X(IO3)
      AK101 = RKI(101) * YC(LADDC) * X(INO2)
      AK103 = RKI(103) * YC(LADDC) * X(IO3)
      AK104 = RKI(104) * YC(LACO3) * X(INO2)
      AK106 = RKI(106) * YC(LTCO3) * X(INO2)
      AK108 = RKI(108) * YC(LMO2)  * X(INO)
      AK109 = RKI(109) * YC(LETHP) * X(INO)
      AK110 = RKI(110) * YC(LHC3P) * X(INO)
      AK111 = RKI(111) * YC(LHC5P) * X(INO)
      AK112 = RKI(112) * YC(LHC8P) * X(INO)
      AK113 = RKI(113) * YC(LETEP) * X(INO)
      AK114 = RKI(114) * YC(LOLTP) * X(INO)
      AK115 = RKI(115) * YC(LOLIP) * X(INO)
      AK116 = RKI(116) * YC(LISOP) * X(INO)
      AK117 = RKI(117) * YC(LAPIP) * X(INO)
      AK118 = RKI(118) * YC(LLIMP) * X(INO)
      AK119 = RKI(119) * YC(LTOLP) * X(INO)
      AK120 = RKI(120) * YC(LXYLP) * X(INO)
      AK121 = RKI(121) * YC(LCSLP) * X(INO)
      AK122 = RKI(122) * YC(LACO3) * X(INO)
      AK123 = RKI(123) * YC(LTCO3) * X(INO)
      AK124 = RKI(124) * YC(LKETP) * X(INO)
      AK125 = RKI(125) * YC(LOLNN) * X(INO)
      AK126 = RKI(126) * YC(LOLND) * X(INO)
      AK213 = RKI(213) * YC(LXO2)  * X(INO)

C END RATE CONSTANT COMPUTATION
C

C *****************************************************
C START COMPUTING RATE CHANGE OF SPECIES' CONCENTRATION
C *****************************************************
C    use all species PROD AND LOSS terms
C
C
      XDOT(INO2)  = CNST_XDOT(INO2)     
     &              + AK12  +       AK18  + AK25
     &        + 2.000*AK27  + 2.000*AK28  + 0.700*AK92 
     &              + AK108 +       AK109 + 0.941*AK110
     &        + 0.876*AK111 + 0.739*AK112 + AK113
     &              + AK114 +       AK115 + 0.847*AK116
     &        + 0.800*AK117 + 0.650*AK118 + 0.950*AK119
     &        + 0.950*AK120 +       AK121 + AK122
     &              + AK123 +       AK124 + AK125
     &              + 2.000*AK126         + AK213
     &        - AJ1   - AK13  - AK14 - AK16 - AK19
     &        - AK26  - AK30  - AK93 - AK95 - AK98
     &        - AK101 - AK104 - AK106 
   
C
      XDOT(INO)   = CNST_XDOT(INO)
     &              + AJ1   + AK13  + AK29
     &              - AK12  - AK15  - AK18  - AK25
     &        - 2.000*AK27  - AK28  - AK108 - AK109
     &              - AK110 - AK111 - AK112 - AK113
     &              - AK114 - AK115 - AK116 - AK117
     &              - AK118 - AK119 - AK120 - AK121
     &              - AK122 - AK123 - AK124 - AK125
     &              - AK126 - AK213

C
      XDOT(IO3)   =  CNST_XDOT(IO3) +  AK1
     &              - AJ2   - AJ3   - AK2   - AK6
     &              - AK7   - AK25  - AK26  - AK83
     &              - AK84  - AK85  - AK86  - AK87
     &              - AK88  - AK89  - AK90  - AK91
     &              - AK92  - AK97  - AK100 - AK103
C
      XDOT(IO3P)  = CNST_XDOT(IO3P)
     &              + AJ1    + AJ3   + AK3   + AK4
     &             + 0.090*AK86     + 0.090*AK87
     &             - AK1    - AK2   - AK12  - AK13
     &             - AK14   - AK36  - AK37
C
c     write(06,'(" NOXOX,XDOT(IO3P)",e12.4)') XDOT(IO3P)
C*********    all correct, 12.05.1998   ********************************
C
C ADD EMISSION
C
      XDOT(INO2) = XDOT(INO2) + PRODSI(LNO2)
      XDOT(INO)  = XDOT(INO)  + PRODSI(LNO)

C
C FILL IN J MATRIX COEFFICIENT
C THE STATEMENT PD(I,J) = 0., IF NECESSARY, IS NEEDED TO RESET
C PD ARRAY THAT
C HAS BEEN DESTROYED IN LAST MATRIX INVERSION PROCESSES
C
C
C****************************** NO2 MATRIX
C
C    PROVISIONAL TERMS FOR FIRST ORDER NO2 LOSS
C
      PD(INO2,  INO2) = CNST_PD(INO2,INO2)
     &                   - (RKI( 13) + RKI( 14)) * X(IO3P)
     &                   - RKI( 26)  * X(IO3)
C
C    PROVISIONAL TERMS FOR NO REACTING TO FORM NO2
C
      PD(INO2,  INO) =  CNST_PD(INO2, INO)
     &                 +      RKI( 12) * X(IO3P)
     &                 +      RKI( 25) * X(IO3)
     &                 + 4.0 * RKI( 27) * X(INO) * YC(LO2)
C
C    PROVISIONAL TERMS FOR O3P REACTING TO FORM NO2
C
      PD(INO2,  IO3P) =  + RKI( 12) * X(INO)
     &                   - (RKI( 13) + RKI( 14)) * X(INO2)

C    PROVISIONAL TERMS FOR O3 REACTING TO FORM NO2

      PD(INO2,  IO3) =   CNST_PD(INO2, IO3)
     &                   + RKI( 25) * X(INO)
     &                   - RKI( 26)  * X(INO2)

C
C****************************** NO MATRIX 
C
C    PROVISIONAL TERMS FOR NO2 REACTING TO FORM NO
C
      PD(INO,   INO2) = CNST_PD(INO, INO2) + RKI( 13) * X(IO3P)
C
C    PROVISIONAL TERMS FOR FIRST ORDER NO LOSS
C
      PD(INO,   INO) = CNST_PD(INO, INO)
     &                 -       RKI( 12) * X(IO3P)
     &                 -       RKI( 25) * X(IO3)
     &                 - 4.0 * RKI( 27) * X(INO) * YC(LO2)
C         
C    PROVISIONAL TERMS FOR O3P REACTING TO FORM NO
      PD(INO,  IO3P) = +       RKI( 13) * X(INO2)
     &                 -       RKI( 12) * X(INO)

      PD(INO,  IO3 ) = -       RKI( 25) * X(INO)

C
C***************************** O3 MATRIX
C
C    PROVISIONAL TERMS FOR FIRST ORDER O3 LOSS
C
      PD(IO3,   IO3) = CNST_PD(IO3, IO3)
     &                   - RKI(  2) * X(IO3P)
     &                   - RKI( 25) * X(INO)
     &                   - RKI( 26) * X(INO2)
C
C   PROVISIONAL TERMS FOR O3P REACTING TO FORM O3
C
      PD(IO3,   IO3P ) = CNST_PD(IO3, IO3P)
     &                   - RKI(  2) * X(IO3)
C
      PD(IO3,   INO2 ) = - RKI( 26) * X(IO3)
      PD(IO3,   INO  ) = - RKI( 25) * X(IO3)

C  
C***************************** O3P MATRIX

C    PROVISIONAL TERMS FOR FIRST ORDER O3P LOSS
      PD(IO3P,  IO3P ) = CNST_PD(IO3P,IO3P) 
     &                 -  ( RKI( 13) + RKI( 14) ) * X(INO2)
     &                 -    RKI( 12) * X(INO)
     &                 -    RKI(  2) * X(IO3)
     
C   PROVISIONAL TERMS FOR NO2 REACTING TO FORM O3P

      PD(IO3P,  INO2 ) =   RJI(  1)
     &                 - ( RKI( 13) + RKI( 14) ) * X(IO3P)
C
C   PROVISIONAL TERMS FOR O3 REACTING TO FORM O3P
C
      PD(IO3P,  IO3 ) = CNST_PD(IO3P, IO3) + RJI( 3)
C
      PD(IO3P,  INO  ) =  -    RKI( 12) * X(IO3P)
C


C***************************** END PROVISORIAL TERMS

      RETURN
      END
      SUBROUTINE PRODLOSS( PROD, LOSS )
C*****************************************************************************
C***
C***  PRODUCTION AND LOSS TERMS OF REMAINING EULER-BACKWARD ITERATION SPECIES
C***
C*****************************************************************************
      INCLUDE 'a_params.com'
      SAVE
      DIMENSION PROD(LSPEC), LOSS(LSPEC)
      double precision LOSS
C
C *****************************************************
C START COMPUTING RATE CHANGE OF SPECIES' CONCENTRATION
C *****************************************************
C
C  Not computed here are ACO3, HNO4, HO, HO2, HONO, N2O5, NO, NO2,
C  NO3, O1D, O3, O3P, PAN, TCO3, TPAN
C
C
      PROD(LADDC) = + 0.850*CRK( 52)
      LOSS(LADDC) = +       CRK(101)+       CRK(102)+       CRK(103)
C
      PROD(LADDT) = + 0.900*CRK( 50)
      LOSS(LADDT) = +       CRK( 95)+       CRK( 96)+       CRK( 97)
C
      PROD(LADDX) = + 0.900*CRK( 51)
      LOSS(LADDX) = +       CRK( 98)+       CRK( 99)+       CRK(100)
C
      PROD(LALD ) = +       CRJ( 14)+ 0.200*CRJ( 21)+       CRK( 37)
     &              + 0.335*CRK( 40)+ 0.025*CRK( 42)+ 0.880*CRK( 61)
     &              + 0.080*CRK( 63)+ 0.250*CRK( 73)+ 0.440*CRK( 84)
     &              + 0.990*CRK( 85)+ 0.650*CRK( 88)+ 0.160*CRK( 91)
     &              +       CRK(109)+ 0.233*CRK(110)+ 0.211*CRK(111)
     &              + 0.150*CRK(112)+ 0.200*CRK(113)+ 0.940*CRK(114)
     &              + 1.710*CRK(115)+ 0.800*CRK(117)+ 0.460*CRK(124)
     &              + 1.240*CRK(126)+ 0.750*CRK(149)+ 0.580*CRK(150)
     &              + 0.523*CRK(151)+ 0.411*CRK(152)+ 0.350*CRK(153)
     &              + 0.669*CRK(154)+ 0.932*CRK(155)+       CRK(157)
     &              + 0.300*CRK(166)+ 0.640*CRK(168)+       CRK(169)
     &              + 0.724*CRK(170)+ 0.677*CRK(171)+ 0.497*CRK(172)
     &              + 0.600*CRK(173)+ 0.859*CRK(174)+ 0.941*CRK(175)
     &              +       CRK(177)+ 0.350*CRK(184)+ 0.650*CRK(186)
     &              + 0.640*CRK(188)+ 1.210*CRK(189)+       CRK(191)
     &              + 0.243*CRK(192)+ 0.239*CRK(193)+ 0.187*CRK(194)
     &              + 0.200*CRK(195)+ 0.940*CRK(196)+ 1.710*CRK(197)
     &              +       CRK(199)+ 0.460*CRK(206)+ 1.240*CRK(208)
c     PROD(LALD ) = 0.0
c -----------------------------
     
      LOSS(LALD ) = +       CRJ( 12)+       CRK( 54)+       CRK( 69)
c     LOSS(LALD ) = 0.0
c -----------------------------
C
      PROD(LAPI ) =   0.0
      LOSS(LAPI ) = +       CRK( 48)+       CRK( 80)+       CRK( 88)
C
      PROD(LAPIP) = +       CRK( 48)
      LOSS(LAPIP) = +       CRK(117)+       CRK(136)+       CRK(157)
     &              +       CRK(177)+       CRK(199)
C
      PROD(LCH4 ) = + 0.060*CRK( 84)+ 0.070*CRK( 85)
      LOSS(LCH4 ) = +       CRK( 38)
C
      PROD(LCO  ) = +       CRJ( 10)+       CRJ( 11)+       CRJ( 12)
     &              + 1.870*CRJ( 17)+ 1.550*CRJ( 18)+       CRJ( 19)
     &              +       CRJ( 22)+ 0.010*CRK( 36)+ 0.036*CRK( 40)
     &              +       CRK( 53)+ 2.000*CRK( 57)+       CRK( 58)
     &              + 0.410*CRK( 59)+       CRK( 68)+ 2.000*CRK( 70)
     &              +       CRK( 71)+ 0.800*CRK( 72)+ 0.430*CRK( 83)
     &              + 0.370*CRK( 84)+ 0.300*CRK( 85)+ 0.360*CRK( 86)
     &              + 0.360*CRK( 87)+ 0.140*CRK( 88)+ 0.140*CRK( 89)
     &              + 0.540*CRK( 90)+ 0.660*CRK( 91)+ 0.130*CRK( 92)
      LOSS(LCO  ) = +       CRK( 35)
C
      PROD(LCSL ) = + 0.100*CRK( 93)+       CRK( 94)+       CRK( 95)
     &              + 0.020*CRK( 96)+       CRK( 97)+       CRK( 98)
     &              + 0.020*CRK( 99)+       CRK(100)+       CRK(101)
     &              + 0.020*CRK(102)+       CRK(103)
      LOSS(LCSL ) = +       CRK( 52)+       CRK( 74)
C
      PROD(LCSLP) = + 0.980*CRK(102)
      LOSS(LCSLP) = +       CRK(121)+       CRK(140)+       CRK(161)
     &              +       CRK(181)+       CRK(203)
C
      PROD(LDCB ) = + 0.130*CRK( 36)+ 0.500*CRK(119)+ 0.950*CRK(120)
     &              +       CRK(159)+       CRK(160)+       CRK(179)
     &              +       CRK(180)+ 0.500*CRK(201)+       CRK(202)
      LOSS(LDCB ) = +       CRJ( 20)+       CRK( 60)+       CRK( 73)
     &              +       CRK( 91)
C
      PROD(LDIEN) =   0.0
      LOSS(LDIEN) = +       CRK( 46)+       CRK( 78)+       CRK( 86)
C
      PROD(LETE ) =   0.0
      LOSS(LETE ) = +       CRK( 43)+       CRK( 75)+       CRK( 83)
C
      PROD(LETEP) = +       CRK( 43)
      LOSS(LETEP) = +       CRK(113)+       CRK(132)+       CRK(153)
     &              +       CRK(173)+       CRK(195)
C
      PROD(LETH ) = + 0.030*CRK( 84)+ 0.060*CRK( 85)
      LOSS(LETH ) = +       CRK( 39)
C
      PROD(LETHP) = +       CRJ( 16)+       CRK( 39)+ 0.100*CRK( 84)
     &              + 0.180*CRK( 85)+ 0.200*CRK( 88)+ 0.160*CRK( 89)
     &              + 0.048*CRK(110)+ 0.245*CRK(111)+ 0.133*CRK(112)
     &              + 0.014*CRK(151)+ 0.013*CRK(152)+ 0.006*CRK(170)
     &              + 0.018*CRK(171)+ 0.015*CRK(172)+ 0.053*CRK(192)
     &              + 0.262*CRK(193)+ 0.155*CRK(194)
      LOSS(LETHP) = +       CRK(109)+       CRK(128)+       CRK(149)
     &              +       CRK(169)+       CRK(191)
C
      PROD(LGLY ) = + 0.036*CRK( 40)+ 0.150*CRK( 60)+ 0.250*CRK( 73)
     &              + 0.500*CRK( 91)+ 0.063*CRK(110)+ 1.200*CRK(119)
     &              + 0.350*CRK(120)+       CRK(121)+ 0.119*CRK(150)
     &              + 0.650*CRK(159)+ 0.370*CRK(160)+       CRK(161)
     &              + 0.100*CRK(170)+ 0.650*CRK(179)+ 0.370*CRK(180)
     &              +       CRK(181)+ 0.063*CRK(192)+ 1.300*CRK(201)
     &              + 0.740*CRK(202)+       CRK(203)
      LOSS(LGLY ) = +       CRJ( 17)+       CRJ( 18)+       CRK( 57)
     &              +       CRK( 70)
C
      PROD(LH2O2) = +       CRK( 10)+       CRK( 11)+ 0.006*CRK( 84)
     &              + 0.011*CRK( 85)+ 0.001*CRK( 86)+ 0.001*CRK( 87)
     &              + 0.020*CRK( 88)+ 0.020*CRK( 89)
      LOSS(LH2O2) = +       CRJ(  9)+       CRK(  9)
C
      PROD(LHC3 ) =   0.0
      LOSS(LHC3 ) = +       CRK( 40)
C
      PROD(LHC3P) = + 0.583*CRK( 40)+ 0.440*CRK( 63)+       CRK( 67)
      LOSS(LHC3P) = +       CRK(110)+       CRK(129)+       CRK(150)
     &              +       CRK(170)+       CRK(192)
C
      PROD(LHC5 ) =   0.0
      LOSS(LHC5 ) = +       CRK( 41)
C
      PROD(LHC5P) = + 0.750*CRK( 41)
      LOSS(LHC5P) = +       CRK(111)+       CRK(130)+       CRK(151)
     &              +       CRK(171)+       CRK(193)
C
      PROD(LHC8 ) =   0.0
      LOSS(LHC8 ) = +       CRK( 42)
C
      PROD(LHC8P) = + 0.951*CRK( 42)
      LOSS(LHC8P) = +       CRK(112)+       CRK(131)+       CRK(152)
     &              +       CRK(172)+       CRK(194)
C
      PROD(LHCHO) =  +       CRJ( 13)+ 0.130*CRJ( 17)+ 0.450*CRJ( 18)
     &               +       CRJ( 22)+       CRJ( 23)+ 0.050*CRK( 36)
     &              + 0.010*CRK( 40)+ 0.080*CRK( 59)+ 0.350*CRK( 62)
     &              + 0.350*CRK( 64)+       CRK( 65)+ 0.400*CRK( 66)
     &              + 0.400*CRK( 82)+       CRK( 83)+ 0.640*CRK( 84)
     &              + 0.020*CRK( 85)+ 0.900*CRK( 86)+ 0.900*CRK( 87)
     &              + 0.040*CRK( 89)+ 0.400*CRK( 90)+ 0.700*CRK( 92)
c xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c dacay at noon (MO2+no, hc3p+no, hc5p+no)
     &              +       CRK(108)+ 0.047*CRK(110)+ 0.021*CRK(111)
c increase in the morning (etep+no, oltp+no,isop+no)
     &              + 1.600*CRK(113)+       CRK(114)  + 0.606*CRK(116)
c xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     &              + 0.250*CRK(118)+       CRK(123)+ 0.287*CRK(126)
     &              + 1.330*CRK(148)+ 0.750*CRK(149)+ 0.810*CRK(150)
     &              + 0.829*CRK(151)+ 0.753*CRK(152)+ 1.550*CRK(153)
     &              + 1.250*CRK(154)+ 0.755*CRK(155)+ 1.090*CRK(156)
     &              +       CRK(157)+ 1.400*CRK(158)+       CRK(159)
     &              +       CRK(160)+       CRK(161)+       CRK(162)
     &              +       CRK(163)+ 2.000*CRK(164)+       CRK(165)
     &              + 0.750*CRK(166)+ 0.750*CRK(167)+ 0.960*CRK(168)
     &              + 0.091*CRK(170)+ 0.076*CRK(171)+ 0.800*CRK(173)
     &              + 0.501*CRK(174)+ 0.340*CRK(176) ! + ???????????????????????????????????????
     &              + 0.400*CRK(178)+       CRK(183)+ 0.207*CRK(186)
     &              + 0.202*CRK(188)+ 0.504*CRK(189)+       CRK(190)
     &              + 0.048*CRK(192)+ 0.021*CRK(193)+ 1.600*CRK(195)
     &              +       CRK(196)+ 0.686*CRK(198)+ 0.400*CRK(200)
     &              +       CRK(205)+ 0.280*CRK(208)+       CRK(210)

      LOSS(LHCHO) = +       CRJ( 10)+       CRJ( 11)+       CRK( 53)
     &              +       CRK( 68)
C
      PROD(LHKET) = + 0.024*CRK( 42)+ 0.410*CRK( 59)+ 0.600*CRK( 66)
     &              + 0.300*CRK(166)
      LOSS(LHKET) = +       CRJ( 23)+       CRK( 56)
C
      PROD(LHNO3) = +       CRK( 16)+ 0.300*CRK( 21)+       CRK( 68)
     &              +       CRK( 69)+       CRK( 70)+       CRK( 71)
     &              + 0.200*CRK( 72)+ 0.500*CRK( 73)+       CRK( 74)
      LOSS(LHNO3) = +       CRJ(  5)+       CRK( 23)
C
      PROD(LISO ) =   0.0
      LOSS(LISO ) = +       CRK( 36)+       CRK( 47)+       CRK( 79)
     &              +       CRK( 87)
C
      PROD(LISOP) = +       CRK( 46)+       CRK( 47)
      LOSS(LISOP) = +       CRK(116)+       CRK(135)+       CRK(156)
     &              +       CRK(176)+       CRK(198)
C
      PROD(LKET ) = + 0.800*CRJ( 21)+ 0.250*CRK( 41)+ 0.120*CRK( 61)
     &              + 0.410*CRK( 63)+ 0.030*CRK( 73)+ 0.030*CRK( 84)
     &              + 0.160*CRK( 85)+ 0.530*CRK( 88)+ 0.623*CRK(110)
     &              + 0.722*CRK(111)+ 0.642*CRK(112)+ 0.060*CRK(114)
     &              + 0.290*CRK(115)+ 0.800*CRK(117)+ 0.464*CRK(126)
     &              + 0.018*CRK(150)+ 0.240*CRK(151)+ 0.419*CRK(152)
     &              + 0.081*CRK(154)+ 0.313*CRK(155)+       CRK(157)
     &              + 0.149*CRK(168)+ 0.127*CRK(170)+ 0.330*CRK(171)
     &              + 0.581*CRK(172)+ 0.141*CRK(174)+ 0.569*CRK(175)
     &              +       CRK(177)+ 0.110*CRK(184)+ 0.167*CRK(186)
     &              + 0.149*CRK(188)+ 0.285*CRK(189)+ 0.670*CRK(192)
     &              + 0.828*CRK(193)+ 0.880*CRK(194)+ 0.060*CRK(196)
     &              + 0.290*CRK(197)+       CRK(199)+ 0.469*CRK(208)
      LOSS(LKET ) = +       CRJ( 16)+       CRK( 55)
c     PROD(LKET ) = 0.0
c     LOSS(LKET ) = 0.0
c ---------------------------------
C
      PROD(LKETP) = +       CRK( 55)+ 0.030*CRK( 84)+ 0.120*CRK( 85)
     &              + 0.020*CRK( 86)+ 0.020*CRK( 87)+ 0.420*CRK( 88)
     &              + 0.420*CRK( 89)
      LOSS(LKETP) = +       CRK(124)+       CRK(145)+       CRK(166)
     &              +       CRK(184)+       CRK(206)
C
      PROD(LLIM ) =   0.0
      LOSS(LLIM ) = +       CRK( 49)+       CRK( 81)+       CRK( 89)
C
      PROD(LLIMP) = +       CRK( 49)
      LOSS(LLIMP) = +       CRK(118)+       CRK(137)+       CRK(158)
     &              +       CRK(178)+       CRK(200)
C
      PROD(LMACR) = + 0.900*CRK( 78)+ 0.900*CRK( 79)+ 0.390*CRK( 86)
     &              + 0.390*CRK( 87)+ 0.790*CRK( 89)+ 0.446*CRK(116)
     &              + 0.400*CRK(118)+ 0.550*CRK(156)+ 0.600*CRK(158)
     &              + 0.771*CRK(176)+ 0.600*CRK(178)+ 0.600*CRK(198)
     &              + 0.600*CRK(200)
      LOSS(LMACR) = +       CRJ( 22)+       CRK( 37)+       CRK( 59)
     &              +       CRK( 72)+       CRK( 90)
C
      PROD(LMGLY) = +       CRK( 56)+ 0.080*CRK( 59)+ 0.150*CRK( 60)
     &              + 0.250*CRK( 73)+ 0.600*CRK( 90)+ 0.620*CRK( 91)
     &              + 0.650*CRK(119)+ 0.600*CRK(120)+       CRK(121)
     &              + 0.540*CRK(124)+ 0.005*CRK(150)+ 0.350*CRK(159)
     &              + 0.630*CRK(160)+       CRK(161)+ 0.400*CRK(166)
     &              + 0.004*CRK(170)+ 0.350*CRK(179)+ 0.630*CRK(180)
     &              +       CRK(181)+ 0.540*CRK(184)+ 0.700*CRK(201)
     &              + 1.260*CRK(202)+       CRK(203)+ 0.540*CRK(206)
      LOSS(LMGLY) = +       CRJ( 19)+       CRK( 58)+       CRK( 71)
C
      PROD(LMO2 ) = +       CRJ( 12)+       CRJ( 15)+       CRK( 38)
     &              + 0.650*CRK( 62)+ 0.190*CRK( 84)+ 0.230*CRK( 85)
     &              + 0.030*CRK( 86)+ 0.030*CRK( 87)+ 0.150*CRK(110)
     &              + 0.031*CRK(111)+       CRK(122)+ 0.500*CRK(169)
     &              + 0.508*CRK(170)+ 0.554*CRK(171)+ 0.507*CRK(172)
     &              + 0.500*CRK(173)+ 0.501*CRK(174)+ 0.510*CRK(175)
     &              + 0.506*CRK(176)+       CRK(177)+       CRK(178)
     &              +       CRK(179)+       CRK(180)+       CRK(181)
     &              + 2.000*CRK(182)+       CRK(183)+ 0.500*CRK(184)
     &              + 0.500*CRK(185)+ 0.516*CRK(186)+ 0.155*CRK(192)
     &              + 0.040*CRK(193)+       CRK(204)+       CRK(211)
      LOSS(LMO2 ) = +       CRK(108)+       CRK(127)+ 2.000*CRK(148)
     &              +       CRK(149)+ 0.993*CRK(150)+ 0.951*CRK(151)
     &              +       CRK(152)+       CRK(153)+       CRK(154)
     &              +       CRK(155)+       CRK(156)+       CRK(157)
     &              +       CRK(158)+       CRK(159)+       CRK(160)
     &              +       CRK(161)+       CRK(163)+       CRK(164)
     &              +       CRK(165)+       CRK(166)+       CRK(167)
     &              +       CRK(168)+       CRK(190)+       CRK(210)
C
      PROD(LOLI ) = + 0.250*CRK(118)+ 0.080*CRK(156)+ 0.400*CRK(158)
     &              + 0.400*CRK(178)+ 0.400*CRK(200)
      LOSS(LOLI ) = +       CRK( 45)+       CRK( 77)+       CRK( 85)
C
      PROD(LOLIP) = +       CRK( 45)
      LOSS(LOLIP) = +       CRK(115)+       CRK(134)+       CRK(155)
     &              +       CRK(175)+       CRK(197)
C
      PROD(LOLND) = + 0.200*CRK( 75)+ 0.570*CRK( 76)+ 0.890*CRK( 77)
     &              + 0.100*CRK( 78)+ 0.100*CRK( 79)+ 0.900*CRK( 80)
     &              + 0.870*CRK( 81)
      LOSS(LOLND) = +       CRK(126)+       CRK(147)+       CRK(168)
     &              +       CRK(186)+       CRK(188)+ 2.000*CRK(189)
     &              +       CRK(208)
C
      PROD(LOLNN) = + 0.800*CRK( 72)+ 0.800*CRK( 75)+ 0.430*CRK( 76)
     &              + 0.110*CRK( 77)+ 0.900*CRK( 78)+ 0.900*CRK( 79)
     &              + 0.100*CRK( 80)+ 0.130*CRK( 81)
      LOSS(LOLNN) = +       CRK(125)+       CRK(146)+       CRK(167)
     &              +       CRK(185)+ 2.000*CRK(187)+       CRK(188)
     &              +       CRK(207)
C
      PROD(LOLT ) = + 0.860*CRK( 36)+ 0.350*CRK( 86)+ 0.350*CRK( 87)
     &              + 0.460*CRK( 89)+ 0.354*CRK(116)+ 0.370*CRK(156)
     &              + 0.229*CRK(176)+ 0.400*CRK(198)
      LOSS(LOLT ) = +       CRK( 44)+       CRK( 76)+       CRK( 84)
C
      PROD(LOLTP) = +       CRK( 44)
      LOSS(LOLTP) = +       CRK(114)+       CRK(133)+       CRK(154)
     &              +       CRK(174)+       CRK(196)
C
      PROD(LONIT) = + 0.600*CRK( 82)+       CRK( 93)+ 0.059*CRK(110)
     &              + 0.124*CRK(111)+ 0.261*CRK(112)+ 0.153*CRK(116)
     &              + 0.200*CRK(117)+ 0.350*CRK(118)+ 0.050*CRK(119)
     &              + 0.050*CRK(120)+       CRK(125)+       CRK(146)
     &              +       CRK(147)+       CRK(167)+ 0.500*CRK(168)
     &              +       CRK(185)+ 0.484*CRK(186)+ 2.000*CRK(187)
     &              + 1.500*CRK(188)+       CRK(189)+       CRK(207)
      LOSS(LONIT) = +       CRJ( 21)+       CRK( 67)
C
      PROD(LOP1 ) = +       CRK(127)
      LOSS(LOP1 ) = +       CRJ( 13)+       CRK( 62)
C
      PROD(LOP2 ) = + 0.130*CRK( 90)+       CRK(128)+       CRK(129)
     &              +       CRK(130)+       CRK(131)+       CRK(132)
     &              +       CRK(133)+       CRK(134)+       CRK(135)
     &              +       CRK(136)+       CRK(137)+       CRK(138)
     &              +       CRK(139)+       CRK(140)+       CRK(143)
     &              +       CRK(145)+       CRK(209)
      LOSS(LOP2 ) = +       CRJ( 14)+       CRK( 63)
C
      PROD(LORA1) = + 0.036*CRK( 40)+ 0.370*CRK( 83)+ 0.140*CRK( 84)
     &              + 0.150*CRK( 86)+ 0.150*CRK( 87)+ 0.010*CRK( 89)
     &              + 0.220*CRK( 90)+ 0.110*CRK( 91)+ 0.110*CRK( 92)
      LOSS(LORA1) =   0.0
C
      PROD(LORA2) = + 0.100*CRK( 84)+ 0.140*CRK( 85)+ 0.070*CRK( 89)
     &              + 0.130*CRK( 90)+ 0.210*CRK( 91)+       CRK(142)
     &              +       CRK(144)+       CRK(163)+       CRK(165)
     &              + 0.500*CRK(169)+ 0.499*CRK(170)+ 0.495*CRK(171)
     &              + 0.495*CRK(172)+ 0.500*CRK(173)+ 0.499*CRK(174)
     &              + 0.490*CRK(175)+ 0.494*CRK(176)+ 0.500*CRK(184)
     &              + 0.500*CRK(185)+ 0.484*CRK(186)
      LOSS(LORA2) =   0.0
C
      PROD(LPAA ) = + 0.110*CRK( 91)+       CRK(141)
      LOSS(LPAA ) = +       CRJ( 15)+       CRK( 64)
C
      PROD(LPHO ) = + 0.100*CRK( 52)+       CRK( 74)
      LOSS(LPHO ) = +       CRK( 93)+       CRK( 94)
C
      PROD(LSO2 ) =   0.0
      LOSS(LSO2 ) = +       CRK( 34)
C
      PROD(LSULF) = +       CRK( 34)
      LOSS(LSULF) =   0.0
C
      PROD(LTOL ) =   0.0
      LOSS(LTOL ) = +       CRK( 50)
C
      PROD(LTOLP) = + 0.980*CRK( 96)
      LOSS(LTOLP) = +       CRK(119)+       CRK(138)+       CRK(159)
     &              +       CRK(179)+       CRK(201)
C
      PROD(LUDD ) = + 0.350*CRK( 60)
      LOSS(LUDD ) = +       CRK( 61)
C
      PROD(LXO2 ) = + 0.150*CRK( 36)+ 0.100*CRK( 50)+ 0.100*CRK( 51)
     &              + 0.050*CRK( 52)+ 0.490*CRK( 59)+ 0.500*CRK( 60)
     &              + 0.070*CRK( 63)+ 0.350*CRK( 64)+       CRK( 65)
     &              +       CRK( 66)+ 0.500*CRK( 73)+       CRK( 82)
     &              + 0.130*CRK( 86)+ 0.130*CRK( 87)+ 0.048*CRK(110)
     &              + 0.334*CRK(111)+ 0.416*CRK(112)+ 0.160*CRK(124)
     &              + 0.085*CRK(150)+ 0.245*CRK(151)+ 0.322*CRK(152)
     &              + 0.080*CRK(166)+ 0.071*CRK(170)+ 0.237*CRK(171)
     &              + 0.318*CRK(172)+ 0.080*CRK(184)+ 0.051*CRK(192)
     &              + 0.391*CRK(193)+ 0.587*CRK(194)+ 0.160*CRK(206)
      LOSS(LXO2 ) = +       CRK(209)+       CRK(210)+       CRK(211)
     &              + 2.000*CRK(212)+       CRK(213)+       CRK(214)
C
      PROD(LXYL ) =   0.0
      LOSS(LXYL ) = +       CRK( 51)
C
      PROD(LXYLP) = + 0.980*CRK( 99)
      LOSS(LXYLP) = +       CRK(120)+       CRK(139)+       CRK(160)
     &              +       CRK(180)+       CRK(202)

C
C    END PRODUCTION AND LOSS CALCULATION
C
C
C ADD EMISSION CONTRIBUTION
C
      DO 1 Ls = 1, LPRED
      PROD(LS) = PROD(LS) + PRODSI(LS)
1     CONTINUE
C
      RETURN
      END

